/*

 Counter block mode compatible with  Dr Brian Gladman fileenc.c
 derived from CryptoJS.mode.CTR
 Jan Hruby jhruby.web@gmail.com

 (c) 2012 by C?dric Mesnil. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

     - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
     - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 Yusuke Kawasaki
 @license MIT
 @constructor
 @see https://github.com/kawanet/event-lite
 @see http://kawanet.github.io/event-lite/EventLite.html
 @example
 var EventLite = require("event-lite");

 function MyClass() {...}             // your class

 EventLite.mixin(MyClass.prototype);  // import event methods

 var obj = new MyClass();
 obj.on("foo", function() {...});     // add event listener
 obj.once("bar", function() {...});   // add one-time event listener
 obj.emit("foo");                     // dispatch event
 obj.emit("bar");                     // dispatch another event
 obj.off("foo");                      // remove event listener
 bignumber.js v3.0.1 https://github.com/MikeMcl/bignumber.js/LICENCE  MIT License (c) copyright 2013-2014 original author or authors  MIT License (c) copyright 2010-2014 original author or authors  The buffer module from node.js, for the browser.

 @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 @license  MIT
 Determine if an object is a Buffer

 @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 @license  MIT
 https://mths.be/punycode v1.4.1 by @mathias */
var $jscomp=$jscomp||{};$jscomp.scope={};$jscomp.inherits=function(H,f){function l(){}l.prototype=f.prototype;H.superClass_=f.prototype;H.prototype=new l;H.prototype.constructor=H;for(var h in f)if(Object.defineProperties){var b=Object.getOwnPropertyDescriptor(f,h);b&&Object.defineProperty(H,h,b)}else H[h]=f[h]};$jscomp.defineProperty="function"==typeof Object.defineProperties?Object.defineProperty:function(H,f,l){H!=Array.prototype&&H!=Object.prototype&&(H[f]=l.value)};
$jscomp.getGlobal=function(H){return"undefined"!=typeof window&&window===H?H:"undefined"!=typeof global&&null!=global?global:H};$jscomp.global=$jscomp.getGlobal(this);$jscomp.SYMBOL_PREFIX="jscomp_symbol_";$jscomp.initSymbol=function(){$jscomp.initSymbol=function(){};$jscomp.global.Symbol||($jscomp.global.Symbol=$jscomp.Symbol)};$jscomp.symbolCounter_=0;$jscomp.Symbol=function(H){return $jscomp.SYMBOL_PREFIX+(H||"")+$jscomp.symbolCounter_++};
$jscomp.initSymbolIterator=function(){$jscomp.initSymbol();var H=$jscomp.global.Symbol.iterator;H||(H=$jscomp.global.Symbol.iterator=$jscomp.global.Symbol("iterator"));"function"!=typeof Array.prototype[H]&&$jscomp.defineProperty(Array.prototype,H,{configurable:!0,writable:!0,value:function(){return $jscomp.arrayIterator(this)}});$jscomp.initSymbolIterator=function(){}};$jscomp.arrayIterator=function(H){var f=0;return $jscomp.iteratorPrototype(function(){return f<H.length?{done:!1,value:H[f++]}:{done:!0}})};
$jscomp.iteratorPrototype=function(H){$jscomp.initSymbolIterator();H={next:H};H[$jscomp.global.Symbol.iterator]=function(){return this};return H};$jscomp.makeIterator=function(H){$jscomp.initSymbolIterator();var f=H[Symbol.iterator];return f?f.call(H):$jscomp.arrayIterator(H)};
$jscomp.polyfill=function(H,f,l,h){if(f){l=$jscomp.global;H=H.split(".");for(h=0;h<H.length-1;h++){var b=H[h];b in l||(l[b]={});l=l[b]}H=H[H.length-1];h=l[H];f=f(h);f!=h&&null!=f&&$jscomp.defineProperty(l,H,{configurable:!0,writable:!0,value:f})}};$jscomp.EXPOSE_ASYNC_EXECUTOR=!0;$jscomp.FORCE_POLYFILL_PROMISE=!1;
$jscomp.polyfill("Promise",function(H){function f(){this.batch_=null}if(H&&!$jscomp.FORCE_POLYFILL_PROMISE)return H;f.prototype.asyncExecute=function(a){null==this.batch_&&(this.batch_=[],this.asyncExecuteBatch_());this.batch_.push(a);return this};f.prototype.asyncExecuteBatch_=function(){var a=this;this.asyncExecuteFunction(function(){a.executeBatch_()})};var l=$jscomp.global.setTimeout;f.prototype.asyncExecuteFunction=function(a){l(a,0)};f.prototype.executeBatch_=function(){for(;this.batch_&&this.batch_.length;){var a=
this.batch_;this.batch_=[];for(var b=0;b<a.length;++b){var c=a[b];delete a[b];try{c()}catch(n){this.asyncThrow_(n)}}}this.batch_=null};f.prototype.asyncThrow_=function(a){this.asyncExecuteFunction(function(){throw a;})};var h=function(a){this.state_=0;this.result_=void 0;this.onSettledCallbacks_=[];var b=this.createResolveAndReject_();try{a(b.resolve,b.reject)}catch(c){b.reject(c)}};h.prototype.createResolveAndReject_=function(){function a(a){return function(g){c||(c=!0,a.call(b,g))}}var b=this,c=
!1;return{resolve:a(this.resolveTo_),reject:a(this.reject_)}};h.prototype.resolveTo_=function(a){if(a===this)this.reject_(new TypeError("A Promise cannot resolve to itself"));else if(a instanceof h)this.settleSameAsPromise_(a);else{a:switch(typeof a){case "object":var b=null!=a;break a;case "function":b=!0;break a;default:b=!1}b?this.resolveToNonPromiseObj_(a):this.fulfill_(a)}};h.prototype.resolveToNonPromiseObj_=function(a){var b=void 0;try{b=a.then}catch(c){this.reject_(c);return}"function"==typeof b?
this.settleSameAsThenable_(b,a):this.fulfill_(a)};h.prototype.reject_=function(a){this.settle_(2,a)};h.prototype.fulfill_=function(a){this.settle_(1,a)};h.prototype.settle_=function(a,b){if(0!=this.state_)throw Error("Cannot settle("+a+", "+b|"): Promise already settled in state"+this.state_);this.state_=a;this.result_=b;this.executeOnSettledCallbacks_()};h.prototype.executeOnSettledCallbacks_=function(){if(null!=this.onSettledCallbacks_){for(var a=this.onSettledCallbacks_,b=0;b<a.length;++b)a[b].call(),
a[b]=null;this.onSettledCallbacks_=null}};var b=new f;h.prototype.settleSameAsPromise_=function(a){var b=this.createResolveAndReject_();a.callWhenSettled_(b.resolve,b.reject)};h.prototype.settleSameAsThenable_=function(a,b){var c=this.createResolveAndReject_();try{a.call(b,c.resolve,c.reject)}catch(n){c.reject(n)}};h.prototype.then=function(a,b){function c(a,c){return"function"==typeof a?function(d){try{e(a(d))}catch(t){g(t)}}:c}var e,g,p=new h(function(a,c){e=a;g=c});this.callWhenSettled_(c(a,e),
c(b,g));return p};h.prototype["catch"]=function(a){return this.then(void 0,a)};h.prototype.callWhenSettled_=function(a,e){function c(){switch(n.state_){case 1:a(n.result_);break;case 2:e(n.result_);break;default:throw Error("Unexpected state: "+n.state_);}}var n=this;null==this.onSettledCallbacks_?b.asyncExecute(c):this.onSettledCallbacks_.push(function(){b.asyncExecute(c)})};h.resolve=function(a){return a instanceof h?a:new h(function(b,c){b(a)})};h.reject=function(a){return new h(function(b,c){c(a)})};
h.race=function(a){return new h(function(b,c){for(var e=$jscomp.makeIterator(a),g=e.next();!g.done;g=e.next())h.resolve(g.value).callWhenSettled_(b,c)})};h.all=function(a){var b=$jscomp.makeIterator(a),c=b.next();return c.done?h.resolve([]):new h(function(a,g){function e(d){return function(c){n[d]=c;v--;0==v&&a(n)}}var n=[],v=0;do n.push(void 0),v++,h.resolve(c.value).callWhenSettled_(e(n.length-1),g),c=b.next();while(!c.done)})};$jscomp.EXPOSE_ASYNC_EXECUTOR&&(h.$jscomp$new$AsyncExecutor=function(){return new f});
return h},"es6-impl","es3");$jscomp.iteratorFromArray=function(H,f){$jscomp.initSymbolIterator();H instanceof String&&(H+="");var l=0,h={next:function(){if(l<H.length){var b=l++;return{value:f(b,H[b]),done:!1}}h.next=function(){return{done:!0,value:void 0}};return h.next()}};h[Symbol.iterator]=function(){return h};return h};$jscomp.polyfill("Array.prototype.keys",function(H){return H?H:function(){return $jscomp.iteratorFromArray(this,function(f){return f})}},"es6-impl","es3");
$jscomp.polyfill("Number.isFinite",function(H){return H?H:function(f){return"number"!==typeof f?!1:!isNaN(f)&&Infinity!==f&&-Infinity!==f}},"es6-impl","es3");$jscomp.polyfill("Number.isInteger",function(H){return H?H:function(f){return Number.isFinite(f)?f===Math.floor(f):!1}},"es6-impl","es3");$jscomp.polyfill("Number.MAX_SAFE_INTEGER",function(){return 9007199254740991},"es6-impl","es3");$jscomp.owns=function(H,f){return Object.prototype.hasOwnProperty.call(H,f)};
$jscomp.polyfill("WeakMap",function(H){function f(a){$jscomp.owns(a,h)||$jscomp.defineProperty(a,h,{value:{}})}function l(a){var c=Object[a];c&&(Object[a]=function(a){f(a);return c(a)})}if(function(){if(!H||!Object.seal)return!1;try{var a=Object.seal({}),c=Object.seal({}),b=new H([[a,2],[c,3]]);if(2!=b.get(a)||3!=b.get(c))return!1;b["delete"](a);b.set(c,4);return!b.has(a)&&4==b.get(c)}catch(g){return!1}}())return H;var h="$jscomp_hidden_"+Math.random().toString().substring(2);l("freeze");l("preventExtensions");
l("seal");var b=0,a=function(a){this.id_=(b+=Math.random()+1).toString();if(a){$jscomp.initSymbol();$jscomp.initSymbolIterator();a=$jscomp.makeIterator(a);for(var c;!(c=a.next()).done;)c=c.value,this.set(c[0],c[1])}};a.prototype.set=function(a,c){f(a);if(!$jscomp.owns(a,h))throw Error("WeakMap key fail: "+a);a[h][this.id_]=c;return this};a.prototype.get=function(a){return $jscomp.owns(a,h)?a[h][this.id_]:void 0};a.prototype.has=function(a){return $jscomp.owns(a,h)&&$jscomp.owns(a[h],this.id_)};a.prototype["delete"]=
function(a){return $jscomp.owns(a,h)&&$jscomp.owns(a[h],this.id_)?delete a[h][this.id_]:!1};return a},"es6-impl","es3");$jscomp.MapEntry=function(){};$jscomp.ASSUME_NO_NATIVE_MAP=!1;
$jscomp.polyfill("Map",function(H){if(!$jscomp.ASSUME_NO_NATIVE_MAP&&function(){if(!H||!H.prototype.entries||"function"!=typeof Object.seal)return!1;try{var a=Object.seal({x:4}),b=new H($jscomp.makeIterator([[a,"s"]]));if("s"!=b.get(a)||1!=b.size||b.get({x:4})||b.set({x:4},"t")!=b||2!=b.size)return!1;var g=b.entries(),e=g.next();if(e.done||e.value[0]!=a||"s"!=e.value[1])return!1;e=g.next();return e.done||4!=e.value[0].x||"t"!=e.value[1]||!g.next().done?!1:!0}catch(k){return!1}}())return H;$jscomp.initSymbol();
$jscomp.initSymbolIterator();var f=new WeakMap,l=function(c){this.data_={};this.head_=a();this.size=0;if(c){c=$jscomp.makeIterator(c);for(var b;!(b=c.next()).done;)b=b.value,this.set(b[0],b[1])}};l.prototype.set=function(a,b){var c=h(this,a);c.list||(c.list=this.data_[c.id]=[]);c.entry?c.entry.value=b:(c.entry={next:this.head_,previous:this.head_.previous,head:this.head_,key:a,value:b},c.list.push(c.entry),this.head_.previous.next=c.entry,this.head_.previous=c.entry,this.size++);return this};l.prototype["delete"]=
function(a){a=h(this,a);return a.entry&&a.list?(a.list.splice(a.index,1),a.list.length||delete this.data_[a.id],a.entry.previous.next=a.entry.next,a.entry.next.previous=a.entry.previous,a.entry.head=null,this.size--,!0):!1};l.prototype.clear=function(){this.data_={};this.head_=this.head_.previous=a();this.size=0};l.prototype.has=function(a){return!!h(this,a).entry};l.prototype.get=function(a){return(a=h(this,a).entry)&&a.value};l.prototype.entries=function(){return b(this,function(a){return[a.key,
a.value]})};l.prototype.keys=function(){return b(this,function(a){return a.key})};l.prototype.values=function(){return b(this,function(a){return a.value})};l.prototype.forEach=function(a,b){for(var c=this.entries(),e;!(e=c.next()).done;)e=e.value,a.call(b,e[1],e[0],this)};l.prototype[Symbol.iterator]=l.prototype.entries;var h=function(a,b){var c=b&&typeof b;"object"==c||"function"==c?f.has(b)?c=f.get(b):(c=""+ ++e,f.set(b,c)):c="p_"+b;var p=a.data_[c];if(p&&$jscomp.owns(a.data_,c))for(var k=0;k<p.length;k++){var n=
p[k];if(b!==b&&n.key!==n.key||b===n.key)return{id:c,list:p,index:k,entry:n}}return{id:c,list:p,index:-1,entry:void 0}},b=function(a,b){var c=a.head_;return $jscomp.iteratorPrototype(function(){if(c){for(;c.head!=a.head_;)c=c.previous;for(;c.next!=c.head;)return c=c.next,{done:!1,value:b(c)};c=null}return{done:!0,value:void 0}})},a=function(){var a={};return a.previous=a.next=a.head=a},e=0;return l},"es6-impl","es3");$jscomp.ASSUME_NO_NATIVE_SET=!1;
$jscomp.polyfill("Set",function(H){if(!$jscomp.ASSUME_NO_NATIVE_SET&&function(){if(!H||!H.prototype.entries||"function"!=typeof Object.seal)return!1;try{var f=Object.seal({x:4}),h=new H($jscomp.makeIterator([f]));if(!h.has(f)||1!=h.size||h.add(f)!=h||1!=h.size||h.add({x:4})!=h||2!=h.size)return!1;var b=h.entries(),a=b.next();if(a.done||a.value[0]!=f||a.value[1]!=f)return!1;a=b.next();return a.done||a.value[0]==f||4!=a.value[0].x||a.value[1]!=a.value[0]?!1:b.next().done}catch(e){return!1}}())return H;
$jscomp.initSymbol();$jscomp.initSymbolIterator();var f=function(f){this.map_=new Map;if(f){f=$jscomp.makeIterator(f);for(var h;!(h=f.next()).done;)this.add(h.value)}this.size=this.map_.size};f.prototype.add=function(f){this.map_.set(f,f);this.size=this.map_.size;return this};f.prototype["delete"]=function(f){f=this.map_["delete"](f);this.size=this.map_.size;return f};f.prototype.clear=function(){this.map_.clear();this.size=0};f.prototype.has=function(f){return this.map_.has(f)};f.prototype.entries=
function(){return this.map_.entries()};f.prototype.values=function(){return this.map_.values()};f.prototype.keys=f.prototype.values;f.prototype[Symbol.iterator]=f.prototype.values;f.prototype.forEach=function(f,h){var b=this;this.map_.forEach(function(a){return f.call(h,a,a,b)})};return f},"es6-impl","es3");$jscomp.polyfill("Array.prototype.entries",function(H){return H?H:function(){return $jscomp.iteratorFromArray(this,function(f,l){return[f,l]})}},"es6-impl","es3");
$jscomp.polyfill("Array.prototype.fill",function(H){return H?H:function(f,l,h){var b=this.length||0;0>l&&(l=Math.max(0,b+l));if(null==h||h>b)h=b;h=Number(h);0>h&&(h=Math.max(0,b+h));for(l=Number(l||0);l<h;l++)this[l]=f;return this}},"es6-impl","es3");
(function(H){"object"===typeof exports&&"undefined"!==typeof module?module.exports=H():"function"===typeof define&&define.amd?define([],H):("undefined"!==typeof window?window:"undefined"!==typeof global?global:"undefined"!==typeof self?self:this).autobahn=H()})(function(){return function f(l,h,b){function a(c,g){if(!h[c]){if(!l[c]){var p="function"==typeof require&&require;if(!g&&p)return p(c,!0);if(e)return e(c,!0);p=Error("Cannot find module '"+c+"'");throw p.code="MODULE_NOT_FOUND",p;}p=h[c]={exports:{}};
l[c][0].call(p.exports,function(b){var g=l[c][1][b];return a(g?g:b)},p,p.exports,f,l,h,b)}return h[c].exports}for(var e="function"==typeof require&&require,c=0;c<b.length;c++)a(b[c]);return a}({1:[function(f,l,h){var b=f("crypto-js");h.sign=function(a,e){return b.HmacSHA256(e,a).toString(b.enc.Base64)};h.derive_key=function(a,e,c,n){return b.PBKDF2(a,e,{keySize:(n||32)/4,iterations:c||1E3,hasher:b.algo.SHA256}).toString(b.enc.Base64)}},{"crypto-js":40}],2:[function(f,l,h){f("when");f("when/function");
h.auth=function(b,a,e){var c=b.defer();navigator.id.watch({loggedInUser:a,onlogin:function(a){c.resolve(a)},onlogout:function(){b.leave("wamp.close.logout")}});return c.promise.then?c.promise:c}},{when:123,"when/function":99}],3:[function(f,l,h){var b="undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{};f("./polyfill.js");l=f("../package.json");var a=f("when"),e=f("msgpack-lite"),c=f("cbor");"AUTOBAHN_DEBUG"in b&&AUTOBAHN_DEBUG&&(f("when/monitor/console"),
"console"in b&&console.log("AutobahnJS debug enabled"));var b=f("./util.js"),n=f("./log.js"),g=f("./session.js"),p=f("./connection.js"),k=f("./configure.js"),v=f("./serializer.js"),d=f("./auth/persona.js");f=f("./auth/cra.js");h.version=l.version;h.transports=k.transports;h.Connection=p.Connection;h.Session=g.Session;h.Invocation=g.Invocation;h.Event=g.Event;h.Result=g.Result;h.Error=g.Error;h.Subscription=g.Subscription;h.Registration=g.Registration;h.Publication=g.Publication;h.serializer=v;h.auth_persona=
d.auth;h.auth_cra=f;h.when=a;h.msgpack=e;h.cbor=c;h.util=b;h.log=n},{"../package.json":124,"./auth/cra.js":1,"./auth/persona.js":2,"./configure.js":4,"./connection.js":5,"./log.js":6,"./polyfill.js":7,"./serializer.js":15,"./session.js":16,"./util.js":20,cbor:22,"msgpack-lite":70,when:123,"when/monitor/console":121}],4:[function(f,l,h){function b(){this._repository={}}b.prototype.register=function(a,b){this._repository[a]=b};b.prototype.isRegistered=function(a){return this._repository[a]?!0:!1};b.prototype.get=
function(a){if(void 0!==this._repository[a])return this._repository[a];throw"no such transport: "+a;};b.prototype.list=function(){var a=[],b;for(b in this._repository)a.push(b);return a};l=new b;var a=f("./transport/websocket.js");l.register("websocket",a.Factory);a=f("./transport/longpoll.js");l.register("longpoll",a.Factory);f=f("./transport/rawsocket.js");l.register("rawsocket",f.Factory);h.transports=l},{"./transport/longpoll.js":17,"./transport/rawsocket.js":18,"./transport/websocket.js":19}],
5:[function(f,l,h){(function(b){var a=f("when"),e=f("./session.js"),c=f("./util.js"),n=f("./log.js"),g=f("./autobahn.js"),p=function(c){(this._options=c)&&c.use_es6_promises?"Promise"in b?this._defer=function(){var a={};a.promise=new Promise(function(d,b){a.resolve=d;a.reject=b});return a}:(n.debug("Warning: ES6 promises requested, but not found! Falling back to whenjs."),this._defer=a.defer):this._defer=c&&c.use_deferred?c.use_deferred:a.defer;this._options.transports||(this._options.transports=
[{type:"websocket",url:this._options.url}]);this._transport_factories=[];this._init_transport_factories();this._session_close_message=this._session_close_reason=this._session=null;this._retry_if_unreachable=void 0!==this._options.retry_if_unreachable?this._options.retry_if_unreachable:!0;this._max_retries="undefined"!==typeof this._options.max_retries?this._options.max_retries:15;this._initial_retry_delay=this._options.initial_retry_delay||1.5;this._max_retry_delay=this._options.max_retry_delay||
300;this._retry_delay_growth=this._options.retry_delay_growth||1.5;this._retry_delay_jitter=this._options.retry_delay_jitter||.1;this._connect_successes=0;this._retry=!1;this._retry_count=0;this._retry_delay=this._initial_retry_delay;this._is_retrying=!1;this._retry_timer=null};p.prototype._create_transport=function(){for(var a=0;a<this._transport_factories.length;++a){var b=this._transport_factories[a];n.debug("trying to create WAMP transport of type: "+b.type);try{var d=b.create();if(d)return n.debug("using WAMP transport type: "+
b.type),d}catch(t){n.warn("could not create WAMP transport '"+b.type+"': "+t)}}n.warn("could not create any WAMP transport");return null};p.prototype._init_transport_factories=function(){var a;c.assert(this._options.transports,"No transport.factory specified");for(var b=0;b<this._options.transports.length;++b){var d=this._options.transports[b];d.url||(d.url=this._options.url);d.serializers||(d.serializers=this._options.serializers);d.protocols||(d.protocols=this._options.protocols);c.assert(d.type,
"No transport.type specified");c.assert("string"===typeof d.type,"transport.type must be a string");try{if(a=g.transports.get(d.type)){var e=new a(d);this._transport_factories.push(e)}}catch(B){console.error(B)}}};p.prototype._autoreconnect_reset_timer=function(){this._retry_timer&&clearTimeout(this._retry_timer);this._retry_timer=null};p.prototype._autoreconnect_reset=function(){this._autoreconnect_reset_timer();this._retry_count=0;this._retry_delay=this._initial_retry_delay;this._is_retrying=!1};
p.prototype._autoreconnect_advance=function(){this._retry_delay_jitter&&(this._retry_delay=c.rand_normal(this._retry_delay,this._retry_delay*this._retry_delay_jitter));this._retry_delay>this._max_retry_delay&&(this._retry_delay=this._max_retry_delay);this._retry_count+=1;var a=this._retry&&(-1===this._max_retries||this._retry_count<=this._max_retries)?{count:this._retry_count,delay:this._retry_delay,will_retry:!0}:{count:null,delay:null,will_retry:!1};this._retry_delay_growth&&(this._retry_delay*=
this._retry_delay_growth);return a};p.prototype.open=function(){function a(){try{b._transport=b._create_transport()}catch(d){console.log(d)}if(b._transport)b._session=new e.Session(b._transport,b._defer,b._options.onchallenge),b._session_close_reason=null,b._session_close_message=null,b._transport.onopen=function(){b._autoreconnect_reset();b._connect_successes+=1;b._session.join(b._options.realm,b._options.authmethods,b._options.authid,b._options.authextra)},b._session.onjoin=function(a){if(b.onopen)try{a.transport=
b._transport.info,b.onopen(b._session,a)}catch(t){n.debug("Exception raised from app code while firing Connection.onopen()",t)}},b._session.onleave=function(a,c){b._session_close_reason=a;b._session_close_message=c.message||"";b._retry=!1;b._transport.close(1E3)},b._transport.onclose=function(d){b._autoreconnect_reset_timer();b._transport=null;if(0===b._connect_successes){var c="unreachable";b._retry_if_unreachable||(b._retry=!1)}else c=d.wasClean?"closed":"lost";var g=b._autoreconnect_advance();
if(b.onclose){d={reason:b._session_close_reason,message:b._session_close_message,retry_delay:g.delay,retry_count:g.count,will_retry:g.will_retry};try{var e=b.onclose(c,d)}catch(C){n.debug("Exception raised from app code while firing Connection.onclose()",C)}}b._session&&(b._session._id=null,b._session=null,b._session_close_reason=null,b._session_close_message=null);b._retry&&!e&&(g.will_retry?(b._is_retrying=!0,n.debug("retrying in "+g.delay+" s"),b._retry_timer=setTimeout(a,1E3*g.delay)):n.debug("giving up trying to reconnect"))};
else if(b._retry=!1,b.onclose)b.onclose("unsupported",{reason:null,message:null,retry_delay:null,retry_count:null,will_retry:!1})}var b=this;if(b._transport)throw"connection already open (or opening)";b._autoreconnect_reset();b._retry=!0;a()};p.prototype.close=function(a,b){if(!this._transport&&!this._is_retrying)throw"connection already closed";this._retry=!1;this._session&&this._session.isOpen?this._session.leave(a,b):this._transport&&this._transport.close(1E3)};Object.defineProperty(p.prototype,
"defer",{get:function(){return this._defer}});Object.defineProperty(p.prototype,"session",{get:function(){return this._session}});Object.defineProperty(p.prototype,"isOpen",{get:function(){return this._session&&this._session.isOpen?!0:!1}});Object.defineProperty(p.prototype,"isConnected",{get:function(){return this._transport?!0:!1}});Object.defineProperty(p.prototype,"transport",{get:function(){return this._transport?this._transport:{info:{type:"none",url:null,protocol:null}}}});Object.defineProperty(p.prototype,
"isRetrying",{get:function(){return this._is_retrying}});h.Connection=p}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./autobahn.js":3,"./log.js":6,"./session.js":16,"./util.js":20,when:123}],6:[function(f,l,h){(function(b){var a=function(){};"AUTOBAHN_DEBUG"in b&&AUTOBAHN_DEBUG&&"console"in b&&(a=function(){console.log.apply(console,arguments)});b=console.warn;h.debug=a;h.warn=b}).call(this,"undefined"!==typeof global?global:
"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{}],7:[function(f,l,h){f("./polyfill/object.js");f("./polyfill/array.js");f("./polyfill/string.js");f("./polyfill/function.js");f("./polyfill/console.js");f("./polyfill/typedarray.js");f("./polyfill/json.js")},{"./polyfill/array.js":8,"./polyfill/console.js":9,"./polyfill/function.js":10,"./polyfill/json.js":11,"./polyfill/object.js":12,"./polyfill/string.js":13,"./polyfill/typedarray.js":14}],8:[function(f,l,h){"function"!==typeof Array.prototype.reduce&&
(Array.prototype.reduce=function(b){if(null===this||"undefined"===typeof this)throw new TypeError("Array.prototype.reduce called on null or undefined");if("function"!==typeof b)throw new TypeError(b+" is not a function");var a=Object(this);var e=a.length>>>0;var c=0;if(2<=arguments.length)var n=arguments[1];else{for(;c<e&&!c in a;)c++;if(c>=e)throw new TypeError("Reduce of empty array with no initial value");n=a[c++]}for(;c<e;c++)c in a&&(n=b(n,a[c],c,a));return n});"indexOf"in Array.prototype||(Array.prototype.indexOf=
function(b,a){void 0===a&&(a=0);0>a&&(a+=this.length);0>a&&(a=0);for(var e=this.length;a<e;a++)if(a in this&&this[a]===b)return a;return-1});"lastIndexOf"in Array.prototype||(Array.prototype.lastIndexOf=function(b,a){void 0===a&&(a=this.length-1);0>a&&(a+=this.length);a>this.length-1&&(a=this.length-1);for(a++;0<a--;)if(a in this&&this[a]===b)return a;return-1});"forEach"in Array.prototype||(Array.prototype.forEach=function(b,a){for(var e=0,c=this.length;e<c;e++)e in this&&b.call(a,this[e],e,this)});
"map"in Array.prototype||(Array.prototype.map=function(b,a){for(var e=Array(this.length),c=0,n=this.length;c<n;c++)c in this&&(e[c]=b.call(a,this[c],c,this));return e});"filter"in Array.prototype||(Array.prototype.filter=function(b,a){for(var e=[],c,n=0,g=this.length;n<g;n++)n in this&&b.call(a,c=this[n],n,this)&&e.push(c);return e});"every"in Array.prototype||(Array.prototype.every=function(b,a){for(var e=0,c=this.length;e<c;e++)if(e in this&&!b.call(a,this[e],e,this))return!1;return!0});"some"in
Array.prototype||(Array.prototype.some=function(b,a){for(var e=0,c=this.length;e<c;e++)if(e in this&&b.call(a,this[e],e,this))return!0;return!1});"function"!==typeof Array.prototype.reduceRight&&(Array.prototype.reduceRight=function(b){if(null===this||"undefined"===typeof this)throw new TypeError("Array.prototype.reduce called on null or undefined");if("function"!==typeof b)throw new TypeError(b+" is not a function");var a=Object(this),e=(a.length>>>0)-1;if(2<=arguments.length)var c=arguments[1];
else{for(;0<=e&&!e in a;)e--;if(0>e)throw new TypeError("Reduce of empty array with no initial value");c=a[e--]}for(;0<=e;e--)e in a&&(c=b(c,a[e],e,a));return c})},{}],9:[function(f,l,h){(function(b){b||(b=window.console={log:function(a,b,c,n,g){},info:function(a,b,c,n,g){},warn:function(a,b,c,n,g){},error:function(a,b,c,n,g){},assert:function(a,b){}});"object"===typeof b.log&&(b.log=Function.prototype.call.bind(b.log,b),b.info=Function.prototype.call.bind(b.info,b),b.warn=Function.prototype.call.bind(b.warn,
b),b.error=Function.prototype.call.bind(b.error,b),b.debug=Function.prototype.call.bind(b.info,b));"group"in b||(b.group=function(a){b.info("\n--- "+a+" ---\n")});"groupEnd"in b||(b.groupEnd=function(){b.log("\n")});"assert"in b||(b.assert=function(a,b){if(!a)try{throw Error("assertion failed: "+b);}catch(c){setTimeout(function(){throw c;},0)}});"time"in b||function(){var a={};b.time=function(b){a[b]=(new Date).getTime()};b.timeEnd=function(e){var c=(new Date).getTime();b.info(e+": "+(e in a?c-a[e]:
0)+"ms")}}()})("undefined"!==typeof console?console:void 0)},{}],10:[function(f,l,h){Function.prototype.bind||(Function.prototype.bind=function(b){var a=this,e=Array.prototype.slice.call(arguments,1);return function(){return a.apply(b,Array.prototype.concat.apply(e,arguments))}})},{}],11:[function(f,l,h){"object"!==typeof JSON&&(JSON={});(function(){function b(a){return 10>a?"0"+a:a}function a(a){p.lastIndex=0;return p.test(a)?'"'+a.replace(p,function(a){var b=k[a];return"string"===typeof b?b:"\\u"+
("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+a+'"'}function e(b,p){var d,k=c,t=p[b];t&&"object"===typeof t&&"function"===typeof t.toJSON&&(t=t.toJSON(b));"function"===typeof g&&(t=g.call(p,b,t));switch(typeof t){case "string":return a(t);case "number":return isFinite(t)?String(t):"null";case "boolean":case "null":return String(t);case "object":if(!t)return"null";c+=n;var f=[];if("[object Array]"===Object.prototype.toString.apply(t)){var v=t.length;for(d=0;d<v;d+=1)f[d]=e(d,t)||"null";
var q=0===f.length?"[]":c?"[\n"+c+f.join(",\n"+c)+"\n"+k+"]":"["+f.join(",")+"]";c=k;return q}if(g&&"object"===typeof g)for(v=g.length,d=0;d<v;d+=1){if("string"===typeof g[d]){var L=g[d];(q=e(L,t))&&f.push(a(L)+(c?": ":":")+q)}}else for(L in t)Object.prototype.hasOwnProperty.call(t,L)&&(q=e(L,t))&&f.push(a(L)+(c?": ":":")+q);q=0===f.length?"{}":c?"{\n"+c+f.join(",\n"+c)+"\n"+k+"}":"{"+f.join(",")+"}";c=k;return q}}"function"!==typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){return isFinite(this.valueOf())?
this.getUTCFullYear()+"-"+b(this.getUTCMonth()+1)+"-"+b(this.getUTCDate())+"T"+b(this.getUTCHours())+":"+b(this.getUTCMinutes())+":"+b(this.getUTCSeconds())+"Z":null},String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(){return this.valueOf()});var c,n,g;if("function"!==typeof JSON.stringify){var p=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;var k={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f",
"\r":"\\r",'"':'\\"',"\\":"\\\\"};JSON.stringify=function(a,b,p){var d;n=c="";if("number"===typeof p)for(d=0;d<p;d+=1)n+=" ";else"string"===typeof p&&(n=p);if((g=b)&&"function"!==typeof b&&("object"!==typeof b||"number"!==typeof b.length))throw Error("JSON.stringify");return e("",{"":a})}}if("function"!==typeof JSON.parse){var f=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;JSON.parse=function(a,b){function d(a,c){var g,e=a[c];if(e&&"object"===
typeof e)for(g in e)if(Object.prototype.hasOwnProperty.call(e,g)){var p=d(e,g);void 0!==p?e[g]=p:delete e[g]}return b.call(a,c,e)}a=String(a);f.lastIndex=0;f.test(a)&&(a=a.replace(f,function(a){return"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)}));if(/^[\],:{}\s]*$/.test(a.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]").replace(/(?:^|:|,)(?:\s*\[)+/g,""))){var c=eval("("+a+")");return"function"===typeof b?
d({"":c},""):c}throw new SyntaxError("JSON.parse");}}})();h.JSON=JSON},{}],12:[function(f,l,h){Object.create||(Object.create=function(){function b(){}return function(a){if(1!=arguments.length)throw Error("Object.create implementation only accepts one parameter.");b.prototype=a;return new b}}());Object.keys||(Object.keys=function(){var b=Object.prototype.hasOwnProperty,a=!{toString:null}.propertyIsEnumerable("toString"),e="toString toLocaleString valueOf hasOwnProperty isPrototypeOf propertyIsEnumerable constructor".split(" "),
c=e.length;return function(n){if("object"!==typeof n&&("function"!==typeof n||null===n))throw new TypeError("Object.keys called on non-object");var g=[],p;for(p in n)b.call(n,p)&&g.push(p);if(a)for(p=0;p<c;p++)b.call(n,e[p])&&g.push(e[p]);return g}}())},{}],13:[function(f,l,h){"trim"in String.prototype||(String.prototype.trim=function(){return this.replace(/^\s+/,"").replace(/\s+$/,"")})},{}],14:[function(f,l,h){"undefined"===typeof Uint8Array&&function(b,a){function e(a){switch(typeof a){case "undefined":return"undefined";
case "boolean":return"boolean";case "number":return"number";case "string":return"string";default:return null===a?"null":"object"}}function c(a){return Object.prototype.toString.call(a).replace(/^\[object *|\]$/g,"")}function n(a){return"function"===typeof a}function g(a){if(null===a||void 0===a)throw TypeError();return Object(a)}function p(a){function b(b){Object.defineProperty(a,b,{get:function(){return a._getter(b)},set:function(d){a._setter(b,d)},enumerable:!0,configurable:!1})}if(1E5<a.length)throw RangeError("Array too large for polyfill");
var d;for(d=0;d<a.length;d+=1)b(d)}function k(a,b){var d=32-b;return a<<d>>d}function f(a,b){var d=32-b;return a<<d>>>d}function d(a){return[a&255]}function t(a){return k(a[0],8)}function B(a){return[a&255]}function h(a){return f(a[0],8)}function C(a){a=R(Number(a));return[0>a?0:255<a?255:a&255]}function y(a){return[a>>8&255,a&255]}function K(a){return k(a[0]<<8|a[1],16)}function q(a){return[a>>8&255,a&255]}function L(a){return f(a[0]<<8|a[1],16)}function x(a){return[a>>24&255,a>>16&255,a>>8&255,
a&255]}function E(a){return k(a[0]<<24|a[1]<<16|a[2]<<8|a[3],32)}function G(a){return[a>>24&255,a>>16&255,a>>8&255,a&255]}function J(a){return f(a[0]<<24|a[1]<<16|a[2]<<8|a[3],32)}function l(a,b,d){function c(a){var b=r(a);a-=b;return.5>a?b:.5<a?b+1:b%2?b+1:b}var g=(1<<b-1)-1;if(a!==a){var e=(1<<b)-1;var p=S(2,d-1);var k=0}else Infinity===a||-Infinity===a?(e=(1<<b)-1,p=0,k=0>a?1:0):0===a?(p=e=0,k=-Infinity===1/a?1:0):(k=0>a,a=m(a),a>=S(2,1-g)?(e=V(r(w(a)/u),1023),p=c(a/S(2,e)*S(2,d)),2<=p/S(2,d)&&
(e+=1,p=1),e>g?(e=(1<<b)-1,p=0):(e+=g,p-=S(2,d))):(e=0,p=c(a/S(2,1-g-d))));for(a=[];d;--d)a.push(p%2?1:0),p=r(p/2);for(d=b;d;--d)a.push(e%2?1:0),e=r(e/2);a.push(k?1:0);a.reverse();b=a.join("");for(k=[];b.length;)k.push(parseInt(b.substring(0,8),2)),b=b.substring(8);return k}function F(a,b,d){var c=[],m,g;for(m=a.length;m;--m){var r=a[m-1];for(g=8;g;--g)c.push(r%2?1:0),r>>=1}c.reverse();g=c.join("");a=(1<<b-1)-1;c=parseInt(g.substring(0,1),2)?-1:1;m=parseInt(g.substring(1,1+b),2);g=parseInt(g.substring(1+
b),2);return m===(1<<b)-1?0!==g?NaN:Infinity*c:0<m?c*S(2,m-a)*(1+g/S(2,d)):0!==g?c*S(2,-(a-1))*(g/S(2,d)):0>c?-0:0}function M(a){return F(a,11,52)}function N(a){return l(a,11,52)}function I(a){return F(a,8,23)}function D(a){return l(a,8,23)}var u=Math.LN2,m=Math.abs,r=Math.floor,w=Math.log,A=Math.max,V=Math.min,S=Math.pow,R=Math.round;(function(){var a=Object.defineProperty;try{var b=Object.defineProperty({},"x",{})}catch(fa){b=!1}a&&b||(Object.defineProperty=function(b,d,c){if(a)try{return a(b,d,
c)}catch(U){}if(b!==Object(b))throw TypeError("Object.defineProperty called on non-object");Object.prototype.__defineGetter__&&"get"in c&&Object.prototype.__defineGetter__.call(b,d,c.get);Object.prototype.__defineSetter__&&"set"in c&&Object.prototype.__defineSetter__.call(b,d,c.set);"value"in c&&(b[d]=c.value);return b})})();(function(){function u(a){a>>=0;if(0>a)throw RangeError("ArrayBuffer size is not a small enough positive integer.");Object.defineProperty(this,"byteLength",{value:a});Object.defineProperty(this,
"_bytes",{value:Array(a)});for(var b=0;b<a;b+=1)this._bytes[b]=0}function k(){if(!arguments.length||"object"!==typeof arguments[0])return function(a){a>>=0;if(0>a)throw RangeError("length is not a small enough positive integer.");Object.defineProperty(this,"length",{value:a});Object.defineProperty(this,"byteLength",{value:a*this.BYTES_PER_ELEMENT});Object.defineProperty(this,"buffer",{value:new u(this.byteLength)});Object.defineProperty(this,"byteOffset",{value:0})}.apply(this,arguments);if(1<=arguments.length&&
"object"===e(arguments[0])&&arguments[0]instanceof k)return function(a){if(this.constructor!==a.constructor)throw TypeError();var b=a.length*this.BYTES_PER_ELEMENT;Object.defineProperty(this,"buffer",{value:new u(b)});Object.defineProperty(this,"byteLength",{value:b});Object.defineProperty(this,"byteOffset",{value:0});Object.defineProperty(this,"length",{value:a.length});for(b=0;b<this.length;b+=1)this._setter(b,a._getter(b))}.apply(this,arguments);if(1<=arguments.length&&"object"===e(arguments[0])&&
!(arguments[0]instanceof k)&&!(arguments[0]instanceof u||"ArrayBuffer"===c(arguments[0])))return function(a){var b=a.length*this.BYTES_PER_ELEMENT;Object.defineProperty(this,"buffer",{value:new u(b)});Object.defineProperty(this,"byteLength",{value:b});Object.defineProperty(this,"byteOffset",{value:0});Object.defineProperty(this,"length",{value:a.length});for(b=0;b<this.length;b+=1)this._setter(b,Number(a[b]))}.apply(this,arguments);if(1<=arguments.length&&"object"===e(arguments[0])&&(arguments[0]instanceof
u||"ArrayBuffer"===c(arguments[0])))return function(a,b,d){b>>>=0;if(b>a.byteLength)throw RangeError("byteOffset out of range");if(b%this.BYTES_PER_ELEMENT)throw RangeError("buffer length minus the byteOffset is not a multiple of the element size.");if(void 0===d){var c=a.byteLength-b;if(c%this.BYTES_PER_ELEMENT)throw RangeError("length of buffer minus byteOffset not a multiple of the element size");d=c/this.BYTES_PER_ELEMENT}else d>>>=0,c=d*this.BYTES_PER_ELEMENT;if(b+c>a.byteLength)throw RangeError("byteOffset and length reference an area beyond the end of the buffer");
Object.defineProperty(this,"buffer",{value:a});Object.defineProperty(this,"byteLength",{value:c});Object.defineProperty(this,"byteOffset",{value:b});Object.defineProperty(this,"length",{value:d})}.apply(this,arguments);throw TypeError();}function f(a,b,d){var c=function(){Object.defineProperty(this,"constructor",{value:c});k.apply(this,arguments);p(this)};"__proto__"in c?c.__proto__=k:(c.from=k.from,c.of=k.of);c.BYTES_PER_ELEMENT=a;var m=function(){};m.prototype=v;c.prototype=new m;Object.defineProperty(c.prototype,
"BYTES_PER_ELEMENT",{value:a});Object.defineProperty(c.prototype,"_pack",{value:b});Object.defineProperty(c.prototype,"_unpack",{value:d});return c}b.ArrayBuffer=b.ArrayBuffer||u;Object.defineProperty(k,"from",{value:function(a){return new this(a)}});Object.defineProperty(k,"of",{value:function(){return new this(arguments)}});var v={};k.prototype=v;Object.defineProperty(k.prototype,"_getter",{value:function(a){if(1>arguments.length)throw SyntaxError("Not enough arguments");a>>>=0;if(!(a>=this.length)){var b=
[],d;var c=0;for(d=this.byteOffset+a*this.BYTES_PER_ELEMENT;c<this.BYTES_PER_ELEMENT;c+=1,d+=1)b.push(this.buffer._bytes[d]);return this._unpack(b)}}});Object.defineProperty(k.prototype,"get",{value:k.prototype._getter});Object.defineProperty(k.prototype,"_setter",{value:function(a,b){if(2>arguments.length)throw SyntaxError("Not enough arguments");a>>>=0;if(!(a>=this.length)){var d=this._pack(b),c;var m=0;for(c=this.byteOffset+a*this.BYTES_PER_ELEMENT;m<this.BYTES_PER_ELEMENT;m+=1,c+=1)this.buffer._bytes[c]=
d[m]}}});Object.defineProperty(k.prototype,"constructor",{value:k});Object.defineProperty(k.prototype,"copyWithin",{value:function(a,b,d){var c=g(this),m=c.length>>>0,m=A(m,0);a>>=0;a=0>a?A(m+a,0):V(a,m);b>>=0;b=0>b?A(m+b,0):V(b,m);d=void 0===d?m:d>>0;d=0>d?A(m+d,0):V(d,m);m=V(d-b,m-a);from<a&&a<b+m?(d=-1,b=b+m-1,a=a+m-1):d=1;for(;0<count;)c._setter(a,c._getter(b)),b+=d,a+=d,--m;return c}});Object.defineProperty(k.prototype,"every",{value:function(a,b){if(void 0===this||null===this)throw TypeError();
var d=Object(this),c=d.length>>>0;if(!n(a))throw TypeError();for(var m=0;m<c;m++)if(!a.call(b,d._getter(m),m,d))return!1;return!0}});Object.defineProperty(k.prototype,"fill",{value:function(a,b,d){var c=g(this),m=c.length>>>0,m=A(m,0);b>>=0;b=0>b?A(m+b,0):V(b,m);d=void 0===d?m:d>>0;for(m=0>d?A(m+d,0):V(d,m);b<m;)c._setter(b,a),b+=1;return c}});Object.defineProperty(k.prototype,"filter",{value:function(a,b){if(void 0===this||null===this)throw TypeError();var d=Object(this),c=d.length>>>0;if(!n(a))throw TypeError();
for(var m=[],g=0;g<c;g++){var r=d._getter(g);a.call(b,r,g,d)&&m.push(r)}return new this.constructor(m)}});Object.defineProperty(k.prototype,"find",{value:function(a){var b=g(this),d=b.length>>>0;if(!n(a))throw TypeError();for(var c=1<arguments.length?arguments[1]:void 0,m=0;m<d;){var r=b._getter(m);if(a.call(c,r,m,b))return r;++m}}});Object.defineProperty(k.prototype,"findIndex",{value:function(a){var b=g(this),d=b.length>>>0;if(!n(a))throw TypeError();for(var c=1<arguments.length?arguments[1]:void 0,
m=0;m<d;){var r=b._getter(m);if(a.call(c,r,m,b))return m;++m}return-1}});Object.defineProperty(k.prototype,"forEach",{value:function(a,b){if(void 0===this||null===this)throw TypeError();var d=Object(this),c=d.length>>>0;if(!n(a))throw TypeError();for(var m=0;m<c;m++)a.call(b,d._getter(m),m,d)}});Object.defineProperty(k.prototype,"indexOf",{value:function(a){if(void 0===this||null===this)throw TypeError();var b=Object(this),d=b.length>>>0;if(0===d)return-1;var c=0;if(0<arguments.length){var g=Number(arguments[1]);
g!==c?c=0:0!==g&&g!==1/0&&g!==-(1/0)&&(c=(0<g||-1)*r(m(g)))}if(c>=d)return-1;for(c=0<=c?c:A(d-m(c),0);c<d;c++)if(b._getter(c)===a)return c;return-1}});Object.defineProperty(k.prototype,"join",{value:function(a){if(void 0===this||null===this)throw TypeError();for(var b=Object(this),d=b.length>>>0,c=Array(d),m=0;m<d;++m)c[m]=b._getter(m);return c.join(void 0===a?",":a)}});Object.defineProperty(k.prototype,"lastIndexOf",{value:function(a){if(void 0===this||null===this)throw TypeError();var b=Object(this),
d=b.length>>>0;if(0===d)return-1;var c=d;1<arguments.length&&(c=Number(arguments[1]),c!==c?c=0:0!==c&&c!==1/0&&c!==-(1/0)&&(c=(0<c||-1)*r(m(c))));for(d=0<=c?V(c,d-1):d-m(c);0<=d;d--)if(b._getter(d)===a)return d;return-1}});Object.defineProperty(k.prototype,"map",{value:function(a,b){if(void 0===this||null===this)throw TypeError();var d=Object(this),c=d.length>>>0;if(!n(a))throw TypeError();var m=[];m.length=c;for(var g=0;g<c;g++)m[g]=a.call(b,d._getter(g),g,d);return new this.constructor(m)}});Object.defineProperty(k.prototype,
"reduce",{value:function(a){if(void 0===this||null===this)throw TypeError();var b=Object(this),d=b.length>>>0;if(!n(a))throw TypeError();if(0===d&&1===arguments.length)throw TypeError();var c=0,m;for(m=2<=arguments.length?arguments[1]:b._getter(c++);c<d;)m=a.call(void 0,m,b._getter(c),c,b),c++;return m}});Object.defineProperty(k.prototype,"reduceRight",{value:function(a){if(void 0===this||null===this)throw TypeError();var b=Object(this),d=b.length>>>0;if(!n(a))throw TypeError();if(0===d&&1===arguments.length)throw TypeError();
var d=d-1,c;for(c=2<=arguments.length?arguments[1]:b._getter(d--);0<=d;)c=a.call(void 0,c,b._getter(d),d,b),d--;return c}});Object.defineProperty(k.prototype,"reverse",{value:function(){if(void 0===this||null===this)throw TypeError();for(var a=Object(this),b=a.length>>>0,d=r(b/2),c=0,b=b-1;c<d;++c,--b){var m=a._getter(c);a._setter(c,a._getter(b));a._setter(b,m)}return a}});Object.defineProperty(k.prototype,"set",{value:function(a,b){if(1>arguments.length)throw SyntaxError("Not enough arguments");
var d;if("object"===typeof arguments[0]&&arguments[0].constructor===this.constructor){var c=arguments[0];var m=arguments[1]>>>0;if(m+c.length>this.length)throw RangeError("Offset plus length of array is out of range");var g=this.byteOffset+m*this.BYTES_PER_ELEMENT;m=c.length*this.BYTES_PER_ELEMENT;if(c.buffer===this.buffer){var r=[];var e=0;for(d=c.byteOffset;e<m;e+=1,d+=1)r[e]=c.buffer._bytes[d];for(e=0;e<m;e+=1,g+=1)this.buffer._bytes[g]=r[e]}else for(e=0,d=c.byteOffset;e<m;e+=1,d+=1,g+=1)this.buffer._bytes[g]=
c.buffer._bytes[d]}else if("object"===typeof arguments[0]&&"undefined"!==typeof arguments[0].length){c=arguments[0];r=c.length>>>0;m=arguments[1]>>>0;if(m+r>this.length)throw RangeError("Offset plus length of array is out of range");for(e=0;e<r;e+=1)d=c[e],this._setter(m+e,Number(d))}else throw TypeError("Unexpected argument type(s)");}});Object.defineProperty(k.prototype,"slice",{value:function(a,b){for(var d=g(this),c=d.length>>>0,m=a>>0,m=0>m?A(c+m,0):V(m,c),r=void 0===b?c:b>>0,c=0>r?A(c+r,0):
V(r,c),r=new d.constructor(c-m),e=0;m<c;){var u=d._getter(m);r._setter(e,u);++m;++e}return r}});Object.defineProperty(k.prototype,"some",{value:function(a,b){if(void 0===this||null===this)throw TypeError();var c=Object(this),d=c.length>>>0;if(!n(a))throw TypeError();for(var m=0;m<d;m++)if(a.call(b,c._getter(m),m,c))return!0;return!1}});Object.defineProperty(k.prototype,"sort",{value:function(a){if(void 0===this||null===this)throw TypeError();for(var b=Object(this),c=b.length>>>0,d=Array(c),m=0;m<
c;++m)d[m]=b._getter(m);a?d.sort(a):d.sort();for(m=0;m<c;++m)b._setter(m,d[m]);return b}});Object.defineProperty(k.prototype,"subarray",{value:function(a,b){a>>=0;b>>=0;1>arguments.length&&(a=0);2>arguments.length&&(b=this.length);0>a&&(a=this.length+a);0>b&&(b=this.length+b);var c=this.length;a=0>a?0:a>c?c:a;c=this.length;c=(0>b?0:b>c?c:b)-a;0>c&&(c=0);return new this.constructor(this.buffer,this.byteOffset+a*this.BYTES_PER_ELEMENT,c)}});var w=f(1,d,t),z=f(1,B,h),ba=f(1,C,h),l=f(2,y,K),Q=f(2,q,L),
W=f(4,x,E),F=f(4,G,J),ja=f(4,D,I),P=f(8,N,M);b.Int8Array=a.Int8Array=b.Int8Array||w;b.Uint8Array=a.Uint8Array=b.Uint8Array||z;b.Uint8ClampedArray=a.Uint8ClampedArray=b.Uint8ClampedArray||ba;b.Int16Array=a.Int16Array=b.Int16Array||l;b.Uint16Array=a.Uint16Array=b.Uint16Array||Q;b.Int32Array=a.Int32Array=b.Int32Array||W;b.Uint32Array=a.Uint32Array=b.Uint32Array||F;b.Float32Array=a.Float32Array=b.Float32Array||ja;b.Float64Array=a.Float64Array=b.Float64Array||P})();(function(){function a(a,b){return n(a.get)?
a.get(b):a[b]}function d(a,b,d){if(!(a instanceof ArrayBuffer||"ArrayBuffer"===c(a)))throw TypeError();b>>>=0;if(b>a.byteLength)throw RangeError("byteOffset out of range");d=void 0===d?a.byteLength-b:d>>>0;if(b+d>a.byteLength)throw RangeError("byteOffset and length reference an area beyond the end of the buffer");Object.defineProperty(this,"buffer",{value:a});Object.defineProperty(this,"byteLength",{value:d});Object.defineProperty(this,"byteOffset",{value:b})}function m(d){return function(c,m){c>>>=
0;if(c+d.BYTES_PER_ELEMENT>this.byteLength)throw RangeError("Array index out of range");c+=this.byteOffset;for(var g=new b.Uint8Array(this.buffer,c,d.BYTES_PER_ELEMENT),e=[],u=0;u<d.BYTES_PER_ELEMENT;u+=1)e.push(a(g,u));!!m===!!r&&e.reverse();return a(new d((new b.Uint8Array(e)).buffer),0)}}function g(d){return function(c,m,g){c>>>=0;if(c+d.BYTES_PER_ELEMENT>this.byteLength)throw RangeError("Array index out of range");m=new d([m]);m=new b.Uint8Array(m.buffer);var e=[],u;for(u=0;u<d.BYTES_PER_ELEMENT;u+=
1)e.push(a(m,u));!!g===!!r&&e.reverse();(new Uint8Array(this.buffer,c,d.BYTES_PER_ELEMENT)).set(e)}}var r=function(){var d=new b.Uint16Array([4660]),d=new b.Uint8Array(d.buffer);return 18===a(d,0)}();Object.defineProperty(d.prototype,"getUint8",{value:m(b.Uint8Array)});Object.defineProperty(d.prototype,"getInt8",{value:m(b.Int8Array)});Object.defineProperty(d.prototype,"getUint16",{value:m(b.Uint16Array)});Object.defineProperty(d.prototype,"getInt16",{value:m(b.Int16Array)});Object.defineProperty(d.prototype,
"getUint32",{value:m(b.Uint32Array)});Object.defineProperty(d.prototype,"getInt32",{value:m(b.Int32Array)});Object.defineProperty(d.prototype,"getFloat32",{value:m(b.Float32Array)});Object.defineProperty(d.prototype,"getFloat64",{value:m(b.Float64Array)});Object.defineProperty(d.prototype,"setUint8",{value:g(b.Uint8Array)});Object.defineProperty(d.prototype,"setInt8",{value:g(b.Int8Array)});Object.defineProperty(d.prototype,"setUint16",{value:g(b.Uint16Array)});Object.defineProperty(d.prototype,"setInt16",
{value:g(b.Int16Array)});Object.defineProperty(d.prototype,"setUint32",{value:g(b.Uint32Array)});Object.defineProperty(d.prototype,"setInt32",{value:g(b.Int32Array)});Object.defineProperty(d.prototype,"setFloat32",{value:g(b.Float32Array)});Object.defineProperty(d.prototype,"setFloat64",{value:g(b.Float64Array)});b.DataView=b.DataView||d})()}(h,window);"undefined"===typeof window||"Uint8ClampedArray"in window||(window.Uint8ClampedArray=window.Uint8Array)},{}],15:[function(f,l,h){function b(){return Math.floor(9007199254740992*
Math.random())}function a(a,d){this.replacer=a;this.reviver=d;this.SERIALIZER_ID="json";this.BINARY=!1;this.newid=b}function e(){this.SERIALIZER_ID="msgpack";this.BINARY=!0;this.codec=g.createCodec();this.newid=function(){return new p(b())}}function c(){this.SERIALIZER_ID="cbor";this.BINARY=!0;this.newid=b}var n=f("./log.js");a.prototype.serialize=function(a){try{return JSON.stringify(a,this.replacer)}catch(d){throw n.warn("JSON encoding error",d),d;}};a.prototype.unserialize=function(a){try{return JSON.parse(a,
this.reviver)}catch(d){throw n.warn("JSON decoding error",d),d;}};h.JSONSerializer=a;var g=f("msgpack-lite"),p=f("int64-buffer").Uint64BE;e.prototype.serialize=function(a){try{return g.encode(a,{codec:this.codec})}catch(d){throw n.warn("MessagePack encoding error",d),d;}};e.prototype.unserialize=function(a){try{return g.decode(new Uint8Array(a),{codec:this.codec})}catch(d){throw n.warn("MessagePack decoding error",d),d;}};e.prototype.registerExtType=function(a,b,c,g){c&&b&&this.codec.addExtPacker(a,
b,c);g&&this.codec.addExtUnpacker(a,g)};h.MsgpackSerializer=e;var k=f("cbor");c.prototype.serialize=function(a){try{return k.encode(a)}catch(d){throw n.warn("CBOR encoding error",d),d;}};c.prototype.unserialize=function(a){try{return k.decodeFirstSync(a)}catch(d){throw n.warn("CBOR decoding error",d),d;}};h.CBORSerializer=c},{"./log.js":6,cbor:22,"int64-buffer":68,"msgpack-lite":70}],16:[function(f,l,h){(function(b){f("when");var a=f("when/function"),e=f("./log.js"),c=f("./util.js");Date.now=Date.now||
function(){return+new Date};var n={caller:{features:{caller_identification:!0,progressive_call_results:!0}},callee:{features:{caller_identification:!0,pattern_based_registration:!0,shared_registration:!0,progressive_call_results:!0,registration_revocation:!0}},publisher:{features:{publisher_identification:!0,subscriber_blackwhite_listing:!0,publisher_exclusion:!0}},subscriber:{features:{publisher_identification:!0,pattern_based_subscription:!0,subscription_revocation:!0}}},g=function(a,b,d,c,g){this.procedure=
a;this.progress=b;this.caller=d;this.caller_authid=c;this.caller_authrole=g},p=function(a,b,d,c,g,e){this.publication=a;this.topic=b;this.publisher=d;this.publisher_authid=c;this.publisher_authrole=g;this.retained=e},k=function(a,b){this.args=a||[];this.kwargs=b||{}},v=function(a,b,d){this.error=a;this.args=b||[];this.kwargs=d||{}},d=function(a,b,d,c,g){this.topic=a;this.handler=b;this.options=d||{};this.session=c;this.id=g;this.active=!0;this._on_unsubscribe=c._defer();this.on_unsubscribe=this._on_unsubscribe.promise.then?
this._on_unsubscribe.promise:this._on_unsubscribe};d.prototype.unsubscribe=function(){return this.session.unsubscribe(this)};var t=function(a,b,d,c,g){this.procedure=a;this.endpoint=b;this.options=d||{};this.session=c;this.id=g;this.active=!0;this._on_unregister=c._defer();this.on_unregister=this._on_unregister.promise.then?this._on_unregister.promise:this._on_unregister};t.prototype.unregister=function(){return this.session.unregister(this)};var B=function(a){this.id=a},z=function(c,f,h){var q=this;
q._socket=c;q._defer=f;q._onchallenge=h;q._id=null;q._realm=null;q._features=null;q._goodbye_sent=!1;q._transport_is_closing=!1;q._publish_reqs={};q._subscribe_reqs={};q._unsubscribe_reqs={};q._call_reqs={};q._register_reqs={};q._unregister_reqs={};q._subscriptions={};q._registrations={};q._invocations={};q._prefixes={};q._caller_disclose_me=!1;q._publisher_disclose_me=!1;q._send_wamp=function(a){e.debug(a);q._socket.send(a)};q._protocol_violation=function(a){e.warn("failing transport due to protocol violation: "+
a);q._socket.close(1002,"protocol violation: "+a)};q._MESSAGE_MAP={};q._MESSAGE_MAP[8]={};q._process_SUBSCRIBED=function(a){var b=a[1];a=a[2];if(b in q._subscribe_reqs){var c=q._subscribe_reqs[b],g=c[0],e=c[1],p=c[2],c=c[3];a in q._subscriptions||(q._subscriptions[a]=[]);e=new d(e,p,c,q,a);q._subscriptions[a].push(e);g.resolve(e);delete q._subscribe_reqs[b]}else q._protocol_violation("SUBSCRIBED received for non-pending request ID "+b)};q._MESSAGE_MAP[33]=q._process_SUBSCRIBED;q._process_SUBSCRIBE_ERROR=
function(a){var b=a[2];b in q._subscribe_reqs?(a=new v(a[4],a[5],a[6]),q._subscribe_reqs[b][0].reject(a),delete q._subscribe_reqs[b]):q._protocol_violation("SUBSCRIBE-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][32]=q._process_SUBSCRIBE_ERROR;q._process_UNSUBSCRIBED=function(a){var b=a[1];if(b in q._unsubscribe_reqs){a=q._unsubscribe_reqs[b];var d=a[0];a=a[1];if(a in q._subscriptions){var c=q._subscriptions[a];for(var g=0;g<c.length;++g)c[g].active=!1,c[g].on_unsubscribe.resolve();
delete q._subscriptions[a]}d.resolve(!0);delete q._unsubscribe_reqs[b]}else if(0===b)if(b=a[2],a=b.subscription,b=b.reason,a in q._subscriptions){c=q._subscriptions[a];for(g=0;g<c.length;++g)c[g].active=!1,c[g]._on_unsubscribe.resolve(b);delete q._subscriptions[a]}else q._protocol_violation("non-voluntary UNSUBSCRIBED received for non-existing subscription ID "+a);else q._protocol_violation("UNSUBSCRIBED received for non-pending request ID "+b)};q._MESSAGE_MAP[35]=q._process_UNSUBSCRIBED;q._process_UNSUBSCRIBE_ERROR=
function(a){var b=a[2];b in q._unsubscribe_reqs?(a=new v(a[4],a[5],a[6]),q._unsubscribe_reqs[b][0].reject(a),delete q._unsubscribe_reqs[b]):q._protocol_violation("UNSUBSCRIBE-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][34]=q._process_UNSUBSCRIBE_ERROR;q._process_PUBLISHED=function(a){var b=a[1],c=a[2];b in q._publish_reqs?(a=q._publish_reqs[b][0],c=new B(c),a.resolve(c),delete q._publish_reqs[b]):q._protocol_violation("PUBLISHED received for non-pending request ID "+b)};q._MESSAGE_MAP[17]=
q._process_PUBLISHED;q._process_PUBLISH_ERROR=function(a){var b=a[2];b in q._publish_reqs?(a=new v(a[4],a[5],a[6]),q._publish_reqs[b][0].reject(a),delete q._publish_reqs[b]):q._protocol_violation("PUBLISH-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][16]=q._process_PUBLISH_ERROR;q._process_EVENT=function(a){var b=a[1];if(b in q._subscriptions){var c=a[3],d=a[4]||[],g=a[5]||{},b=q._subscriptions[b];a=new p(a[2],c.topic||b[0]&&b[0].topic,c.publisher,c.publisher_authid,c.publisher_authrole,
c.retained||!1);for(c=0;c<b.length;++c){var k=b[c];try{k.handler(d,g,a,k)}catch(F){e.debug("Exception raised in event handler",F)}}}else q._protocol_violation("EVENT received for non-subscribed subscription ID "+b)};q._MESSAGE_MAP[36]=q._process_EVENT;q._process_REGISTERED=function(a){var b=a[1];a=a[2];if(b in q._register_reqs){var c=q._register_reqs[b],d=c[0],c=new t(c[1],c[2],c[3],q,a);q._registrations[a]=c;d.resolve(c);delete q._register_reqs[b]}else q._protocol_violation("REGISTERED received for non-pending request ID "+
b)};q._MESSAGE_MAP[65]=q._process_REGISTERED;q._process_REGISTER_ERROR=function(a){var b=a[2];b in q._register_reqs?(a=new v(a[4],a[5],a[6]),q._register_reqs[b][0].reject(a),delete q._register_reqs[b]):q._protocol_violation("REGISTER-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][64]=q._process_REGISTER_ERROR;q._process_UNREGISTERED=function(a){var b=a[1];if(b in q._unregister_reqs){a=q._unregister_reqs[b];var c=a[0];a=a[1];a.id in q._registrations&&delete q._registrations[a.id];
a.active=!1;c.resolve();delete q._unregister_reqs[b]}else 0===b?(a=a[2],b=a.registration,c=a.reason,b in q._registrations?(a=q._registrations[b],a.active=!1,a._on_unregister.resolve(c),delete q._registrations[b]):q._protocol_violation("non-voluntary UNREGISTERED received for non-existing registration ID "+b)):q._protocol_violation("UNREGISTERED received for non-pending request ID "+b)};q._MESSAGE_MAP[67]=q._process_UNREGISTERED;q._process_UNREGISTER_ERROR=function(a){var b=a[2];b in q._unregister_reqs?
(a=new v(a[4],a[5],a[6]),q._unregister_reqs[b][0].reject(a),delete q._unregister_reqs[b]):q._protocol_violation("UNREGISTER-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][66]=q._process_UNREGISTER_ERROR;q._process_RESULT=function(a){var b=a[1];if(b in q._call_reqs){var c=a[2],d=a[3]||[],g=a[4]||{};a=null;1<d.length||0<Object.keys(g).length?a=new k(d,g):0<d.length&&(a=d[0]);g=q._call_reqs[b];d=g[0];g=g[1];c.progress?g&&g.receive_progress&&d.notify(a):(d.resolve(a),delete q._call_reqs[b])}else q._protocol_violation("CALL-RESULT received for non-pending request ID "+
b)};q._MESSAGE_MAP[50]=q._process_RESULT;q._process_CALL_ERROR=function(a){var b=a[2];b in q._call_reqs?(a=new v(a[4],a[5],a[6]),q._call_reqs[b][0].reject(a),delete q._call_reqs[b]):q._protocol_violation("CALL-ERROR received for non-pending request ID "+b)};q._MESSAGE_MAP[8][48]=q._process_CALL_ERROR;q._process_INVOCATION=function(b){var c=b[1],d=b[2],e=b[3];if(d in q._registrations){var d=q._registrations[d],p=b[4]||[];b=b[5]||{};var n=null;e.receive_progress&&(n=function(a,b){var d=[70,c,{progress:!0}];
a=a||[];b=b||{};var g=Object.keys(b).length;if(a.length||g)d.push(a),g&&d.push(b);q._send_wamp(d)});e=new g(e.procedure||d.procedure,n,e.caller,e.caller_authid,e.caller_authrole);a.call(d.endpoint,p,b,e).then(function(a){var b=[70,c,{}];if(a instanceof k){var d=Object.keys(a.kwargs).length;if(a.args.length||d)b.push(a.args),d&&b.push(a.kwargs)}else b.push([a]);q._send_wamp(b)},function(a){var b=[8,68,c,{}];if(a instanceof v){b.push(a.error);var d=Object.keys(a.kwargs).length;if(a.args.length||d)b.push(a.args),
d&&b.push(a.kwargs)}else b.push("wamp.error.runtime_error"),b.push([a]);q._send_wamp(b)})}else q._protocol_violation("INVOCATION received for non-registered registration ID "+c)};q._MESSAGE_MAP[68]=q._process_INVOCATION;q._socket.onmessage=function(b){var c=b[0];if(q._id)if(6===c){if(q._goodbye_sent||q._send_wamp([6,{},"wamp.error.goodbye_and_out"]),q._id=null,q._realm=null,q._features=null,c=b[1],b=b[2],q.onleave)q.onleave(b,c)}else if(8===c){var d=b[1];if(d in q._MESSAGE_MAP[8])q._MESSAGE_MAP[c][d](b);
else q._protocol_violation("unexpected ERROR message with request_type "+d)}else if(c in q._MESSAGE_MAP)q._MESSAGE_MAP[c](b);else q._protocol_violation("unexpected message type "+c);else if(2===c){q._id=b[1];c=b[2];q._features={};if(c.roles.broker&&(q._features.subscriber={},q._features.publisher={},c.roles.broker.features)){for(d in n.publisher.features)q._features.publisher[d]=n.publisher.features[d]&&c.roles.broker.features[d];for(d in n.subscriber.features)q._features.subscriber[d]=n.subscriber.features[d]&&
c.roles.broker.features[d]}if(c.roles.dealer&&(q._features.caller={},q._features.callee={},c.roles.dealer.features)){for(d in n.caller.features)q._features.caller[d]=n.caller.features[d]&&c.roles.dealer.features[d];for(d in n.callee.features)q._features.callee[d]=n.callee.features[d]&&c.roles.dealer.features[d]}if(q.onjoin)q.onjoin(b[2])}else if(3===c){if(c=b[1],b=b[2],q.onleave)q.onleave(b,c)}else 4===c?q._onchallenge?a.call(q._onchallenge,q,b[1],b[2]).then(function(a){q._send_wamp([5,a,{}])},function(a){e.debug("onchallenge() raised:",
a);q._send_wamp([3,{message:"sorry, I cannot authenticate (onchallenge handler raised an exception)"},"wamp.error.cannot_authenticate"]);q._socket.close(1E3)}):(e.debug("received WAMP challenge, but no onchallenge() handler set"),b=[3,{message:"sorry, I cannot authenticate (no onchallenge handler set)"},"wamp.error.cannot_authenticate"],q._send_wamp(b),q._socket.close(1E3)):q._protocol_violation("unexpected message type "+c)};q._created="performance"in b&&"now"in performance?performance.now():Date.now()};
Object.defineProperty(z.prototype,"defer",{get:function(){return this._defer}});Object.defineProperty(z.prototype,"id",{get:function(){return this._id}});Object.defineProperty(z.prototype,"realm",{get:function(){return this._realm}});Object.defineProperty(z.prototype,"isOpen",{get:function(){return null!==this.id}});Object.defineProperty(z.prototype,"features",{get:function(){return this._features}});Object.defineProperty(z.prototype,"caller_disclose_me",{get:function(){return this._caller_disclose_me},
set:function(a){this._caller_disclose_me=a}});Object.defineProperty(z.prototype,"publisher_disclose_me",{get:function(){return this._publisher_disclose_me},set:function(a){this._publisher_disclose_me=a}});Object.defineProperty(z.prototype,"subscriptions",{get:function(){for(var a=Object.keys(this._subscriptions),b=[],c=0;c<a.length;++c)b.push(this._subscriptions[a[c]]);return b}});Object.defineProperty(z.prototype,"registrations",{get:function(){for(var a=Object.keys(this._registrations),b=[],c=0;c<
a.length;++c)b.push(this._registrations[a[c]]);return b}});z.prototype.log=function(){if("console"in b){if(this._id&&this._created){var a="performance"in b&&"now"in performance?performance.now()-this._created:Date.now()-this._created;a="WAMP session "+this._id+" on '"+this._realm+"' at "+Math.round(1E3*a)/1E3+" ms"}else a="WAMP session";if("group"in console){console.group(a);for(a=0;a<arguments.length;a+=1)console.log(arguments[a]);console.groupEnd()}else{var c=[a+": "];for(a=0;a<arguments.length;a+=
1)c.push(arguments[a]);console.log.apply(console,c)}}};z.prototype.join=function(a,b,d,g){c.assert("string"===typeof a,"Session.join: <realm> must be a string");c.assert(!b||Array.isArray(b),"Session.join: <authmethods> must be an array []");c.assert(!d||"string"===typeof d,"Session.join: <authid> must be a string");if(this.isOpen)throw"session already open";this._goodbye_sent=!1;this._realm=a;var e={};e.roles=n;b&&(e.authmethods=b);d&&(e.authid=d);g&&(e.authextra=g);this._send_wamp([1,a,e])};z.prototype.leave=
function(a,b){c.assert(!a||"string"===typeof a,"Session.leave: <reason> must be a string");c.assert(!b||"string"===typeof b,"Session.leave: <message> must be a string");if(!this.isOpen)throw"session not open";a||(a="wamp.close.normal");var d={};b&&(d.message=b);this._send_wamp([6,d,a]);this._goodbye_sent=!0};z.prototype.call=function(a,b,d,g){c.assert("string"===typeof a,"Session.call: <procedure> must be a string");c.assert(!b||Array.isArray(b),"Session.call: <args> must be an array []");c.assert(!d||
d instanceof Object,"Session.call: <kwargs> must be an object {}");c.assert(!g||g instanceof Object,"Session.call: <options> must be an object {}");if(!this.isOpen)throw"session not open";g=g||{};void 0===g.disclose_me&&this._caller_disclose_me&&(g.disclose_me=!0);var e=this._defer(),p=this._socket.serializer.newid();this._call_reqs[p]=[e,g];a=[48,p,g,this.resolve(a)];b?(a.push(b),d&&a.push(d)):d&&(a.push([]),a.push(d));this._send_wamp(a);return e.promise.then?e.promise:e};z.prototype.publish=function(a,
b,d,g){c.assert("string"===typeof a,"Session.publish: <topic> must be a string");c.assert(!b||Array.isArray(b),"Session.publish: <args> must be an array []");c.assert(!d||d instanceof Object,"Session.publish: <kwargs> must be an object {}");c.assert(!g||g instanceof Object,"Session.publish: <options> must be an object {}");if(!this.isOpen)throw"session not open";g=g||{};void 0===g.disclose_me&&this._publisher_disclose_me&&(g.disclose_me=!0);var e=null,p=this._socket.serializer.newid();g.acknowledge&&
(e=this._defer(),this._publish_reqs[p]=[e,g]);a=[16,p,g,this.resolve(a)];b?(a.push(b),d&&a.push(d)):d&&(a.push([]),a.push(d));this._send_wamp(a);if(e)return e.promise.then?e.promise:e};z.prototype.subscribe=function(a,b,d){c.assert("string"===typeof a,"Session.subscribe: <topic> must be a string");c.assert("function"===typeof b,"Session.subscribe: <handler> must be a function");c.assert(!d||d instanceof Object,"Session.subscribe: <options> must be an object {}");if(!this.isOpen)throw"session not open";
var g=this._socket.serializer.newid(),e=this._defer();this._subscribe_reqs[g]=[e,a,b,d];b=[32,g];d?b.push(d):b.push({});b.push(this.resolve(a));this._send_wamp(b);return e.promise.then?e.promise:e};z.prototype.register=function(a,b,d){c.assert("string"===typeof a,"Session.register: <procedure> must be a string");c.assert("function"===typeof b,"Session.register: <endpoint> must be a function");c.assert(!d||d instanceof Object,"Session.register: <options> must be an object {}");if(!this.isOpen)throw"session not open";
var g=this._socket.serializer.newid(),e=this._defer();this._register_reqs[g]=[e,a,b,d];b=[64,g];d?b.push(d):b.push({});b.push(this.resolve(a));this._send_wamp(b);return e.promise.then?e.promise:e};z.prototype.unsubscribe=function(a){c.assert(a instanceof d,"Session.unsubscribe: <subscription> must be an instance of class autobahn.Subscription");if(!this.isOpen)throw"session not open";if(!(a.active&&a.id in this._subscriptions))throw"subscription not active";var b=this._subscriptions[a.id],g=b.indexOf(a);
if(-1===g)throw"subscription not active";b.splice(g,1);a.active=!1;g=this._defer();b.length?g.resolve(!1):(b=this._socket.serializer.newid(),this._unsubscribe_reqs[b]=[g,a.id],this._send_wamp([34,b,a.id]));return g.promise.then?g.promise:g};z.prototype.unregister=function(a){c.assert(a instanceof t,"Session.unregister: <registration> must be an instance of class autobahn.Registration");if(!this.isOpen)throw"session not open";if(!(a.active&&a.id in this._registrations))throw"registration not active";
var b=this._socket.serializer.newid(),d=this._defer();this._unregister_reqs[b]=[d,a];this._send_wamp([66,b,a.id]);return d.promise.then?d.promise:d};z.prototype.prefix=function(a,b){c.assert("string"===typeof a,"Session.prefix: <prefix> must be a string");c.assert(!b||"string"===typeof b,"Session.prefix: <uri> must be a string or falsy");b?this._prefixes[a]=b:a in this._prefixes&&delete this._prefixes[a]};z.prototype.resolve=function(a){c.assert("string"===typeof a,"Session.resolve: <curie> must be a string");
var b=a.indexOf(":");if(0<=b){var d=a.substring(0,b);return d in this._prefixes?this._prefixes[d]+"."+a.substring(b+1):a}return a};h.Session=z;h.Invocation=g;h.Event=p;h.Result=k;h.Error=v;h.Subscription=d;h.Registration=t;h.Publication=B}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./log.js":6,"./util.js":20,when:123,"when/function":99}],17:[function(f,l,h){function b(b){a.assert(void 0!==b.url,"options.url missing");a.assert("string"===
typeof b.url,"options.url must be a string");this._options=b}f("when");var a=f("../util.js"),e=f("../log.js"),c=f("../serializer.js");b.prototype.type="longpoll";b.prototype.create=function(){var b=this;e.debug("longpoll.Factory.create");var g={protocol:void 0};g.serializer=new c.JSONSerializer;g.send=void 0;g.close=void 0;g.onmessage=function(){};g.onopen=function(){};g.onclose=function(){};g.info={type:"longpoll",url:null,protocol:"wamp.2.json"};g._run=function(){var c=null,k=!1,n=b._options.request_timeout||
12E3;a.http_post(b._options.url+"/open",JSON.stringify({protocols:["wamp.2.json"]}),n).then(function(d){function p(){e.debug("longpoll.Transport: polling for message ...");a.http_post(f+"/receive",null,n).then(function(a){a&&(a=JSON.parse(a),e.debug("longpoll.Transport: message received",a),g.onmessage(a));k||p()},function(a){e.debug("longpoll.Transport: could not receive message",a.code,a.text);k=!0;g.onclose({code:1001,reason:"transport receive failure (HTTP/POST status "+a.code+" - '"+a.text+"')",
wasClean:!1})})}c=JSON.parse(d);var f=b._options.url+"/"+c.transport;g.info.url=f;e.debug("longpoll.Transport: open",c);g.close=function(b,d){if(k)throw"transport is already closing";k=!0;a.http_post(f+"/close",null,n).then(function(){e.debug("longpoll.Transport: transport closed");g.onclose({code:1E3,reason:"transport closed",wasClean:!0})},function(a){e.debug("longpoll.Transport: could not close transport",a.code,a.text)})};g.send=function(b){if(k)throw"transport is closing or closed already";e.debug("longpoll.Transport: sending message ...",
b);b=JSON.stringify(b);a.http_post(f+"/send",b,n).then(function(){e.debug("longpoll.Transport: message sent")},function(a){e.debug("longpoll.Transport: could not send message",a.code,a.text);k=!0;g.onclose({code:1001,reason:"transport send failure (HTTP/POST status "+a.code+" - '"+a.text+"')",wasClean:!1})})};p();g.onopen()},function(a){e.debug("longpoll.Transport: could not open transport",a.code,a.text);k=!0;g.onclose({code:1001,reason:"transport open failure (HTTP/POST status "+a.code+" - '"+a.text+
"')",wasClean:!1})})};g._run();return g};h.Factory=b},{"../log.js":6,"../serializer.js":15,"../util.js":20,when:123}],18:[function(f,l,h){(function(b,a){function e(a){a.protocols?n.assert(Array.isArray(a.protocols),"options.protocols must be an array"):a.protocols=["wamp.2.json"];a.rawsocket_max_len_exp=a.rawsocket_max_len_exp||24;this._options=a}function c(b,c){this._options={_peer_serializer:null,_peer_max_len_exp:0};this._options=n.defaults(this._options,c,this.DEFAULT_OPTIONS);n.assert(this._options.serializer in
this.SERIALIZERS,"Unsupported serializer: "+this._options.serializer);n.assert(9<=this._options.max_len_exp&&36>=this._options.max_len_exp,"Message length out of bounds [9, 36]: "+this._options.max_len_exp);n.assert(!this._options.autoping||Number.isInteger(this._options.autoping)&&0<=this._options.autoping,"Autoping interval must be positive");n.assert(!this._options.ping_timeout||Number.isInteger(this._options.ping_timeout)&&0<=this._options.ping_timeout,"Ping timeout duration must be positive");
n.assert(!this._options.packet_timeout||Number.isInteger(this._options.packet_timeout)&&0<=this._options.packet_timeout,"Packet timeout duration must be positive");n.assert(!this._options.autoping||!this._options.ping_timeout||this._options.autoping>this._options.ping_timeout,"Autoping interval ("+this._options.autoping+") must be lower than ping timeout ("+this._options.ping_timeout+")");this._ping_interval=this._ping_payload=this._ping_timeout=null;this._status=this.STATUS.UNINITIATED;this._stream=
b;this._emitter=new k;this._buffer=new a(4);this._msgLen=this._bufferLen=0;var d=this;this._stream.on("data",function(a){d._read(a)});this._stream.on("connect",function(){d._handshake()});["close","drain","end","error","timeout"].forEach(function(a){d._stream.on(a,function(b){d._emitter.emit(a,b)})})}var n=f("../util.js"),g=f("../log.js"),p=f("../serializer.js"),k=f("events").EventEmitter;e.prototype.type="rawsocket";e.prototype.create=function(){var a=this,e={protocol:void 0};e.serializer=new p.JSONSerializer;
e.send=void 0;e.close=void 0;e.onmessage=function(){};e.onopen=function(){};e.onclose=function(){};e.info={type:"rawsocket",url:null,protocol:"wamp.2.json"};if(b.process&&b.process.versions.node)(function(){var b=f("net");if(a._options.path)connectionOptions={path:a._options.path,allowHalfOpen:!0};else if(a._options.port)connectionOptions={port:a._options.port||8E3,host:a._options.host||"localhost",allowHalfOpen:!0};else throw"You must specify a host/port combination or a unix socket path to connect to";
b=b.connect(connectionOptions);var d=new c(b,{serializer:"json",max_len_exp:a._options.rawsocket_max_len_exp});d.on("connect",function(a){g.debug("RawSocket transport negociated");e.onopen(a)});d.on("data",function(a){g.debug("RawSocket transport received",a);e.onmessage(a)});d.on("close",function(a){g.debug("RawSocket transport closed");e.onclose({code:999,reason:"",wasClean:!a})});d.on("error",function(a){g.debug("RawSocket transport error",a)});e.close=function(a,b){g.debug("RawSocket transport closing",
a,b);d.close()};e.send=function(a){g.debug("RawSocket transport sending",a);d.write(a)}})();else throw"No RawSocket support in browser";return e};c.prototype._MAGIC_BYTE=127;c.prototype.SERIALIZERS={json:1};c.prototype.STATUS={CLOSED:-1,UNINITIATED:0,NEGOCIATING:1,NEGOCIATED:2,RXHEAD:3,RXDATA:4,RXPING:5,RXPONG:6};c.prototype.ERRORS={0:"illegal (must not be used)",1:"serializer unsupported",2:"maximum message length unacceptable",3:"use of reserved bits (unsupported feature)",4:"maximum connection count reached"};
c.prototype.MSGTYPES={WAMP:0,PING:1,PONG:2};c.prototype.DEFAULT_OPTIONS={fail_on_ping_timeout:!0,strict_pong:!0,ping_timeout:2E3,autoping:0,max_len_exp:24,serializer:"json",packet_timeout:2E3};c.prototype.close=function(){this._status=this.STATUS.CLOSED;this._stream.end();return this.STATUS.CLOSED};c.prototype.write=function(b,c,g){c=void 0===c?0:c;c===this.MSGTYPES.WAMP&&(b=JSON.stringify(b));var d=a.byteLength(b,"utf8");if(d>Math.pow(2,this._options._peer_max_len_exp))this._emitter.emit("error",
new v("Frame too big"));else{var e=new a(d+4);e.writeUInt8(c,0);e.writeUIntBE(d,1,3);e.write(b,4);this._stream.write(e,g)}};c.prototype.ping=function(a){a=a||255;if(Number.isInteger(a))for(var b=Math.max(1,a),c=0;c<b;c++)a+="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789&~\"#'{([-|`_\\^@)]=},?;.:/!*$<>".charAt(92*Math.random()|0);this._ping_payload=a;return this.write(a,this.MSGTYPES.PING,this._setupPingTimeout.bind(this))};c.prototype._setupPingTimeout=function(){this._options.ping_timeout&&
(this._ping_timeout=setTimeout(this._onPingTimeout.bind(this),this._options.ping_timeout))};c.prototype._clearPingTimeout=function(){this._ping_timeout&&(clearTimeout(this._ping_timeout),this._ping_timeout=null)};c.prototype._setupAutoPing=function(){this._clearAutoPing();this._options.autoping&&(this._autoping_interval=setInterval(this.ping.bind(this),this._options.autoping))};c.prototype._clearAutoPing=function(){this._autoping_interval&&(clearInterval(this._autoping_interval),this._autoping_interval=
null)};c.prototype._onPingTimeout=function(){this._emitter.emit("error",new v("PING timeout"));this._options.fail_on_ping_timeout&&this.close()};c.prototype._read=function(a){switch(this._status){case this.STATUS.CLOSED:case this.STATUS.UNINITIATED:this._emitter.emit("error",v("Unexpected packet"));break;case this.STATUS.NEGOCIATING:var b=this._handleHandshake;var c=4;break;case this.STATUS.NEGOCIATED:case this.STATUS.RXHEAD:this._status=this.STATUS.RXHEAD;b=this._handleHeaderPacket;c=4;break;case this.STATUS.RXDATA:b=
this._handleDataPacket;c=this._msgLen;break;case this.STATUS.RXPING:b=this._handlePingPacket;c=this._msgLen;break;case this.STATUS.RXPONG:b=this._handlePongPacket,c=this._msgLen}if(a=this._splitBytes(a,c))this._status=b.call(this,a[0]),0<a[1].length&&this._read(a[1])};c.prototype._handshake=function(){if(this._status!==this.STATUS.UNINITIATED)throw"Handshake packet already sent";var b=new a(4);b.writeUInt8(this._MAGIC_BYTE,0);b.writeUInt8(this._options.max_len_exp-9<<4|this.SERIALIZERS[this._options.serializer],
1);b.writeUInt8(0,2);b.writeUInt8(0,3);this._stream.write(b);this._status=this.STATUS.NEGOCIATING};c.prototype._splitBytes=function(b,c){c!==this._buffer.length&&(this._buffer=new a(c),this._bufferLen=0);b.copy(this._buffer,this._bufferLen);if(this._bufferLen+b.length<c)return this._bufferLen+=b.length,null;var d=this._buffer.slice(),g=b.slice(c-this._bufferLen);this._bufferLen=0;return[d,g]};c.prototype._handleHandshake=function(a){if(a[0]!==this._MAGIC_BYTE)return this._emitter.emit("error",new v("Invalid magic byte. Expected 0x"+
this._MAGIC_BYTE.toString(16)+", got 0x"+a[0].toString(16))),this.close();if(0===(a[1]&15))return a=a[1]>>4,this._emitter.emit("error",new v("Peer failed handshake: "+(this.ERRORS[a]||"0x"+a.toString(16)))),this.close();this._options._peer_max_len_exp=(a[1]>>4)+9;this._options._peer_serializer=a[1]&15;if(this._options._peer_serializer!==this.SERIALIZERS.json)return this._emitter.emit("error",new v("Unsupported serializer: 0x"+this._options._peer_serializer.toString(16))),this.close();this._emitter.emit("connect");
this._setupAutoPing();return this.STATUS.NEGOCIATED};c.prototype._handleHeaderPacket=function(a){var b=a[0]&15;this._msgLen=a.readUIntBE(1,3);switch(b){case this.MSGTYPES.WAMP:return this.STATUS.RXDATA;case this.MSGTYPES.PING:return this.STATUS.RXPING;case this.MSGTYPES.PONG:return this.STATUS.RXPONG;default:return this._emitter.emit("error",new v("Invalid frame type: 0x"+b.toString(16))),this.close()}};c.prototype._handleDataPacket=function(a){try{var b=JSON.parse(a.toString("utf8"))}catch(B){return this._emitter.emit("error",
new v("Invalid JSON frame")),this.STATUS.RXHEAD}this._emitter.emit("data",b);return this.STATUS.RXHEAD};c.prototype._handlePingPacket=function(a){this.write(a.toString("utf8"),this.MSGTYPES.PONG);return this.STATUS.RXHEAD};c.prototype._handlePongPacket=function(a){this._clearPingTimeout();return this._options.strict_pong&&this._ping_payload!==a.toString("utf8")?(this._emitter.emit("error",new v("PONG response payload doesn't match PING.")),this.close()):this.STATUS.RXHEAD};c.prototype.on=function(a,
b){return this._emitter.on(a,b)};c.prototype.once=function(a,b){return this._emitter.once(a,b)};c.prototype.removeListener=function(a,b){return this._emitter.removeListener(a,b)};var v=h.ProtocolError=function(a){Error.apply(this,Array.prototype.splice.call(arguments));Error.captureStackTrace(this,this.constructor);this.message=a;this.name="ProtocolError"};v.prototype=Object.create(Error.prototype);h.Factory=e;h.Protocol=c}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:
"undefined"!==typeof window?window:{},f("buffer").Buffer)},{"../log.js":6,"../serializer.js":15,"../util.js":20,buffer:129,events:131,net:125}],19:[function(f,l,h){(function(b){function a(a){e.assert(void 0!==a.url,"options.url missing");e.assert("string"===typeof a.url,"options.url must be a string");a.serializers?e.assert(Array.isArray(a.serializers),"options.serializers must be an array"):(a.serializers=[new n.JSONSerializer],n.MsgpackSerializer&&a.serializers.push(new n.MsgpackSerializer));a.protocols?
e.assert(Array.isArray(a.protocols),"options.protocols must be an array"):(a.protocols=[],a.serializers.forEach(function(b){a.protocols.push("wamp.2."+b.SERIALIZER_ID)}));this._options=a}var e=f("../util.js"),c=f("../log.js"),n=f("../serializer.js");a.prototype.type="websocket";a.prototype.create=function(){var a=this,e={protocol:void 0,serializer:void 0,send:void 0,close:void 0,onmessage:function(){},onopen:function(){},onclose:function(){}};e.info={type:"websocket",url:a._options.url,protocol:null};
b.process&&b.process.versions.node?function(){var b=f("ws");if(a._options.protocols){var c=a._options.protocols;Array.isArray(c)&&(c=c.join(","));var d=new b(a._options.url,{protocol:c})}else d=new b(a._options.url);e.send=function(a){a=e.serializer.serialize(a);d.send(a,{binary:e.serializer.BINARY})};e.close=function(a,b){d.close()};d.on("open",function(){var b=d.protocol.split(".")[2],c;for(c in a._options.serializers){var g=a._options.serializers[c];if(g.SERIALIZER_ID==b){e.serializer=g;break}}e.info.protocol=
d.protocol;e.onopen()});d.on("message",function(a,b){var c=e.serializer.unserialize(a);e.onmessage(c)});d.on("close",function(a,b){e.onclose({code:a,reason:b,wasClean:1E3===a})});d.on("error",function(a){e.onclose({code:1006,reason:"",wasClean:!1})})}():function(){if("WebSocket"in b){var g=a._options.protocols?new b.WebSocket(a._options.url,a._options.protocols):new b.WebSocket(a._options.url);g.binaryType="arraybuffer"}else if("MozWebSocket"in b)g=a._options.protocols?new b.MozWebSocket(a._options.url,
a._options.protocols):new b.MozWebSocket(a._options.url);else throw"browser does not support WebSocket or WebSocket in Web workers";g.onmessage=function(a){c.debug("WebSocket transport receive",a.data);a=e.serializer.unserialize(a.data);e.onmessage(a)};g.onopen=function(){var b=g.protocol.split(".")[2],c;for(c in a._options.serializers){var p=a._options.serializers[c];if(p.SERIALIZER_ID==b){e.serializer=p;break}}e.info.protocol=g.protocol;e.onopen()};g.onclose=function(a){e.onclose({code:a.code,reason:a.message,
wasClean:a.wasClean})};e.send=function(a){a=e.serializer.serialize(a);c.debug("WebSocket transport send",a);g.send(a)};e.close=function(a,b){g.close(a,b)}}();return e};h.Factory=a}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"../log.js":6,"../serializer.js":15,"../util.js":20,ws:127}],20:[function(f,l,h){(function(b){var a=f("./log.js"),e=f("when"),c=function(a,e){if(!a){if(c.useDebugger||"AUTOBAHN_DEBUG"in b&&AUTOBAHN_DEBUG)debugger;
throw Error(e||"Assertion failed!");}},n=function(){var a;if(0===arguments.length)return{};var b=arguments[0],c=!1,e=arguments.length;"boolean"===typeof arguments[e-1]&&(c=arguments[e-1],--e);var d=function(d){var g=a[d];d in b?c&&"object"===typeof g&&"object"===typeof b[d]&&n(b[d],g):b[d]=g},f=1;for(;f<e;f++)if(a=arguments[f]){if("object"!==typeof a)throw Error("Expected argument at index "+f+" to be an object");Object.keys(a).forEach(d)}return b};h.rand_normal=function(a,b){do{var c=2*Math.random()-
1;var g=2*Math.random()-1;g=c*c+g*g}while(1<=g||0==g);return(a||0)+c*Math.sqrt(-2*Math.log(g)/g)*(b||1)};h.assert=c;h.http_post=function(b,c,k){a.debug("new http_post request",b,c,k);var g=e.defer(),d=new XMLHttpRequest;d.withCredentials=!0;d.onreadystatechange=function(){if(4===d.readyState){var a=1223===d.status?204:d.status;200===a&&g.resolve(d.responseText);if(204===a)g.resolve();else{var b=null;try{b=d.statusText}catch(z){}g.reject({code:a,text:b})}}};d.open("POST",b,!0);d.setRequestHeader("Content-type",
"application/json; charset=utf-8");0<k&&(d.timeout=k,d.ontimeout=function(){g.reject({code:501,text:"request timeout"})});c?d.send(c):d.send();return g.promise.then?g.promise:g};h.defaults=n}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./log.js":6,when:123}],21:[function(f,l,h){(function(b){function a(b){function q(a,b){var c,d,g,e,u=this;if(!(u instanceof q))return R&&M(26,"constructor call without new",a),new q(a,b);if(null!=
b&&T(b,2,64,I,"base")){b|=0;var k=a+"";if(10==b)return u=new q(a instanceof q?a:k),N(u,m+u.e+1,r);if((g="number"==typeof a)&&0!=0*a||!(new RegExp("^-?"+(c="["+"0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".slice(0,b)+"]+")+"(?:\\."+c+")?$",37>b?"i":"")).test(k))return h(u,k,g,b);g?(u.s=0>1/a?(k=k.slice(1),-1):1,R&&15<k.replace(/^0\.0*|\./,"").length&&M(I,"number type has more than 15 significant digits",a),g=!1):u.s=45===k.charCodeAt(0)?(k=k.slice(1),-1):1;k=v(k,10,b,u.s)}else{if(a instanceof
q){u.s=a.s;u.e=a.e;u.c=(a=a.c)?a.slice():a;I=0;return}if((g="number"==typeof a)&&0==0*a){u.s=0>1/a?(a=-a,-1):1;if(a===~~a){c=0;for(d=a;10<=d;d/=10,c++);u.e=c;u.c=[a];I=0;return}k=a+""}else{if(!z.test(k=a+""))return h(u,k,g);u.s=45===k.charCodeAt(0)?(k=k.slice(1),-1):1}}-1<(c=k.indexOf("."))&&(k=k.replace(".",""));0<(d=k.search(/e/i))?(0>c&&(c=d),c+=+k.slice(d+1),k=k.substring(0,d)):0>c&&(c=k.length);for(d=0;48===k.charCodeAt(d);d++);for(e=k.length;48===k.charCodeAt(--e););if(k=k.slice(d,e+1))if(e=
k.length,g&&R&&15<e&&(9007199254740991<a||a!==y(a))&&M(I,"number type has more than 15 significant digits",u.s*a),c=c-d-1,c>S)u.c=u.e=null;else if(c<V)u.c=[u.e=0];else{u.e=c;u.c=[];d=(c+1)%14;0>c&&(d+=14);if(d<e){d&&u.c.push(+k.slice(0,d));for(e-=14;d<e;)u.c.push(+k.slice(d,d+=14));k=k.slice(d);d=14-k.length}else d-=e;for(;d--;k+="0");u.c.push(+k)}else u.c=[u.e=0];I=0}function v(a,b,g,e){var u=a.indexOf("."),p=m,n=r;37>g&&(a=a.toLowerCase());if(0<=u){var f=ca;ca=0;a=a.replace(".","");var t=new q(g);
var h=t.pow(a.length-u);ca=f;t.c=k(d(c(h.c),h.e),10,b);t.e=t.c.length}var v=k(a,g,b);for(g=f=v.length;0==v[--f];v.pop());if(!v[0])return"0";if(0>u)--g;else{h.c=v;h.e=g;h.s=e;h=U(h,t,p,n,b);v=h.c;var B=h.r;g=h.e}a=g+p+1;u=v[a];f=b/2;B=B||0>a||null!=v[a+1];B=4>n?(null!=u||B)&&(0==n||n==(0>h.s?3:2)):u>f||u==f&&(4==n||B||6==n&&v[a-1]&1||n==(0>h.s?8:7));if(1>a||!v[0])a=B?d("1",-p):"0";else{v.length=a;if(B)for(--b;++v[--a]>b;)v[a]=0,a||(++g,v.unshift(1));for(f=v.length;!v[--f];);u=0;for(a="";u<=f;a+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".charAt(v[u++]));
a=d(a,g)}return a}function B(a,b,m,g){m=null!=m&&T(m,0,8,g,"rounding mode")?m|0:r;if(!a.c)return a.toString();var e=a.c[0];var u=a.e;if(null==b){var k=c(a.c);k=19==g||24==g&&u<=w?f(k,u):d(k,u)}else{a=N(new q(a),b,m);m=a.e;k=c(a.c);var p=k.length;if(19==g||24==g&&(b<=m||m<=w)){for(;p<b;k+="0",p++);k=f(k,m)}else if(b-=u,k=d(k,m),m+1>p){if(0<--b)for(k+=".";b--;k+="0");}else if(b+=m-p,0<b)for(m+1==p&&(k+=".");b--;k+="0");}return 0>a.s&&e?"-"+k:k}function L(a,b){var c,d=0;p(a[0])&&(a=a[0]);for(c=new q(a[0]);++d<
a.length;){var m=new q(a[d]);if(m.s)b.call(c,m)&&(c=m);else{c=m;break}}return c}function l(a,b,c,d,m){(a<b||a>c||a!=t(a))&&M(d,(m||"decimal places")+(a<b||a>c?" out of range":" not an integer"),a);return!0}function F(a,b,c){for(var d=1,m=b.length;!b[--m];b.pop());for(m=b[0];10<=m;m/=10,d++);(c=d+14*c-1)>S?a.c=a.e=null:c<V?a.c=[a.e=0]:(a.e=c,a.c=b);return a}function M(a,b,c){a=Error("new BigNumber;cmp;config;div;divToInt;eq;gt;gte;lt;lte;minus;mod;plus;precision;random;round;shift;times;toDigits;toExponential;toFixed;toFormat;toFraction;pow;toPrecision;toString;BigNumber".split(";")[a]+
"() "+b+": "+c);a.name="BigNumber Error";I=0;throw a;}function N(a,b,c,d){var m,g,e=a.c,u=K;if(e){a:{var r=1;for(m=e[0];10<=m;m/=10,r++);var k=b-r;if(0>k){k+=14;var p=b;var n=e[g=0];m=n/u[r-p-1]%10|0}else if(g=C((k+1)/14),g>=e.length)if(d){for(;e.length<=g;e.push(0));n=m=0;r=1;k%=14;p=k-14+1}else break a;else{n=m=e[g];for(r=1;10<=m;m/=10,r++);k%=14;p=k-14+r;m=0>p?0:n/u[r-p-1]%10|0}d=d||0>b||null!=e[g+1]||(0>p?n:n%u[r-p-1]);d=4>c?(m||d)&&(0==c||c==(0>a.s?3:2)):5<m||5==m&&(4==c||d||6==c&&(0<k?0<p?n/
u[r-p]:0:e[g-1])%10&1||c==(0>a.s?8:7));if(1>b||!e[0])return e.length=0,d?(b-=a.e+1,e[0]=u[(14-b%14)%14],a.e=-b||0):e[0]=a.e=0,a;0==k?(e.length=g,m=1,g--):(e.length=g+1,m=u[14-k],e[g]=0<p?y(n/u[r-p]%u[p])*m:0);if(d)for(;;)if(0==g){k=1;for(p=e[0];10<=p;p/=10,k++);p=e[0]+=m;for(m=1;10<=p;p/=10,m++);k!=m&&(a.e++,1E14==e[0]&&(e[0]=1));break}else{e[g]+=m;if(1E14!=e[g])break;e[g--]=0;m=1}for(k=e.length;0===e[--k];e.pop());}a.e>S?a.c=a.e=null:a.e<V&&(a.c=[a.e=0])}return a}var I=0,D=q.prototype,u=new q(1),
m=20,r=4,w=-7,A=21,V=-1E7,S=1E7,R=!0,T=l,ea=!1,fa=1,ca=0,Z={decimalSeparator:".",groupSeparator:",",groupSize:3,secondaryGroupSize:0,fractionGroupSeparator:"\u00a0",fractionGroupSize:0};q.another=a;q.ROUND_UP=0;q.ROUND_DOWN=1;q.ROUND_CEIL=2;q.ROUND_FLOOR=3;q.ROUND_HALF_UP=4;q.ROUND_HALF_DOWN=5;q.ROUND_HALF_EVEN=6;q.ROUND_HALF_CEIL=7;q.ROUND_HALF_FLOOR=8;q.EUCLID=9;q.config=q.set=function(){var a,b=0,c={},d=arguments,e=d[0],u=e&&"object"==typeof e?function(){if(e.hasOwnProperty(a))return null!=(k=
e[a])}:function(){if(d.length>b)return null!=(k=d[b++])};u(a="DECIMAL_PLACES")&&T(k,0,1E9,2,a)&&(m=k|0);c[a]=m;u(a="ROUNDING_MODE")&&T(k,0,8,2,a)&&(r=k|0);c[a]=r;u(a="EXPONENTIAL_AT")&&(p(k)?T(k[0],-1E9,0,2,a)&&T(k[1],0,1E9,2,a)&&(w=k[0]|0,A=k[1]|0):T(k,-1E9,1E9,2,a)&&(w=-(A=(0>k?-k:k)|0)));c[a]=[w,A];u(a="RANGE")&&(p(k)?T(k[0],-1E9,-1,2,a)&&T(k[1],1,1E9,2,a)&&(V=k[0]|0,S=k[1]|0):T(k,-1E9,1E9,2,a)&&(k|0?V=-(S=(0>k?-k:k)|0):R&&M(2,a+" cannot be zero",k)));c[a]=[V,S];u(a="ERRORS")&&(k===!!k||1===k||
0===k?(I=0,T=(R=!!k)?l:g):R&&M(2,a+" not a boolean or binary digit",k));c[a]=R;if(u(a="CRYPTO"))if(!0===k||!1===k||1===k||0===k)if(k){var k="undefined"==typeof crypto;!k&&crypto&&(crypto.getRandomValues||crypto.randomBytes)?ea=!0:R?M(2,"crypto unavailable",k?void 0:crypto):ea=!1}else ea=!1;else R&&M(2,a+" not a boolean or binary digit",k);c[a]=ea;u(a="MODULO_MODE")&&T(k,0,9,2,a)&&(fa=k|0);c[a]=fa;u(a="POW_PRECISION")&&T(k,0,1E9,2,a)&&(ca=k|0);c[a]=ca;u(a="FORMAT")&&("object"==typeof k?Z=k:R&&M(2,
a+" not an object",k));c[a]=Z;return c};q.max=function(){return L(arguments,D.lt)};q.min=function(){return L(arguments,D.gt)};q.random=function(){var a=9007199254740992*Math.random()&2097151?function(){return y(9007199254740992*Math.random())}:function(){return 8388608*(1073741824*Math.random()|0)+(8388608*Math.random()|0)};return function(b){var c,d=0,g=[],e=new q(u);b=null!=b&&T(b,0,1E9,14)?b|0:m;var k=C(b/14);if(ea)if(crypto.getRandomValues){for(c=crypto.getRandomValues(new Uint32Array(k*=2));d<
k;){var r=131072*c[d]+(c[d+1]>>>11);9E15<=r?(r=crypto.getRandomValues(new Uint32Array(2)),c[d]=r[0],c[d+1]=r[1]):(g.push(r%1E14),d+=2)}d=k/2}else if(crypto.randomBytes){for(c=crypto.randomBytes(k*=7);d<k;)r=281474976710656*(c[d]&31)+1099511627776*c[d+1]+4294967296*c[d+2]+16777216*c[d+3]+(c[d+4]<<16)+(c[d+5]<<8)+c[d+6],9E15<=r?crypto.randomBytes(7).copy(c,d):(g.push(r%1E14),d+=7);d=k/7}else ea=!1,R&&M(14,"crypto unavailable",crypto);if(!ea)for(;d<k;)r=a(),9E15>r&&(g[d++]=r%1E14);k=g[--d];b%=14;k&&
b&&(r=K[14-b],g[d]=y(k/r)*r);for(;0===g[d];g.pop(),d--);if(0>d)g=[b=0];else{for(b=-1;0===g[0];g.shift(),b-=14);d=1;for(r=g[0];10<=r;r/=10,d++);14>d&&(b-=14-d)}e.e=b;e.c=g;return e}}();var U=function(){function a(a,b,c){var d=0,m=a.length,g=b%1E7,e=b/1E7|0;for(a=a.slice();m--;){var k=a[m]%1E7;var u=a[m]/1E7|0;b=e*k+u*g;k=g*k+b%1E7*1E7+d;d=(k/c|0)+(b/1E7|0)+e*u;a[m]=k%c}d&&a.unshift(d);return a}function b(a,b,c,d){if(c!=d)var m=c>d?1:-1;else for(d=m=0;d<c;d++)if(a[d]!=b[d]){m=a[d]>b[d]?1:-1;break}return m}
function c(a,b,c,d){for(var m=0;c--;)a[c]-=m,m=a[c]<b[c]?1:0,a[c]=m*d+a[c]-b[c];for(;!a[0]&&1<a.length;a.shift());}return function(d,m,g,k,u){var r,p=d.s==m.s?1:-1;var n=d.c;var f=m.c;if(!(n&&n[0]&&f&&f[0]))return new q(d.s&&m.s&&(n?!f||n[0]!=f[0]:f)?n&&0==n[0]||!f?0*p:p/0:NaN);var t=new q(p);var v=t.c=[];var h=d.e-m.e;p=g+h+1;u||(u=1E14,h=e(d.e/14)-e(m.e/14),p=p/14|0);for(d=0;f[d]==(n[d]||0);d++);f[d]>(n[d]||0)&&h--;if(0>p)v.push(1),n=!0;else{var B=n.length;var w=f.length;d=0;p+=2;var x=y(u/(f[0]+
1));1<x&&(f=a(f,x,u),n=a(n,x,u),w=f.length,B=n.length);var G=w;var E=n.slice(0,w);for(r=E.length;r<w;E[r++]=0);var z=f.slice();z.unshift(0);var L=f[0];f[1]>=u/2&&L++;do{x=0;m=b(f,E,w,r);if(0>m){x=E[0];w!=r&&(x=x*u+(E[1]||0));x=y(x/L);if(1<x){x>=u&&(x=u-1);var C=a(f,x,u);var K=C.length;for(r=E.length;1==b(C,E,K,r);)x--,c(C,w<K?z:f,K,u),K=C.length,m=1}else 0==x&&(m=x=1),C=f.slice(),K=C.length;K<r&&C.unshift(0);c(E,C,r,u);r=E.length;if(-1==m)for(;1>b(f,E,w,r);)x++,c(E,w<r?z:f,r,u),r=E.length}else 0===
m&&(x++,E=[0]);v[d++]=x;E[0]?E[r++]=n[G]||0:(E=[n[G]],r=1)}while((G++<B||null!=E[0])&&p--);n=null!=E[0];v[0]||v.shift()}if(1E14==u){d=1;for(p=v[0];10<=p;p/=10,d++);N(t,g+(t.e=d+14*h-1)+1,k,n)}else t.e=h,t.r=+n;return t}}();h=function(){var a=/^(-?)0([xbo])(?=\w[\w.]*$)/i,b=/^([^.]+)\.$/,c=/^\.([^.]+)$/,d=/^-?(Infinity|NaN)$/,m=/^\s*\+(?=[\w.])|^\s+|\s+$/g;return function(g,e,k,u){var r=k?e:e.replace(m,"");if(d.test(r))g.s=isNaN(r)?null:0>r?-1:1;else{if(!k){r=r.replace(a,function(a,b,c){p="x"==(c=
c.toLowerCase())?16:"b"==c?2:8;return u&&u!=p?a:b});if(u){var p=u;r=r.replace(b,"$1").replace(c,"0.$1")}if(e!=r)return new q(r,p)}R&&M(I,"not a"+(u?" base "+u:"")+" number",e);g.s=null}g.c=g.e=null;I=0}}();D.absoluteValue=D.abs=function(){var a=new q(this);0>a.s&&(a.s=1);return a};D.ceil=function(){return N(new q(this),this.e+1,2)};D.comparedTo=D.cmp=function(a,b){I=1;return n(this,new q(a,b))};D.decimalPlaces=D.dp=function(){var a,b=this.c;if(!b)return null;var c=14*((a=b.length-1)-e(this.e/14));
if(a=b[a])for(;0==a%10;a/=10,c--);0>c&&(c=0);return c};D.dividedBy=D.div=function(a,b){I=3;return U(this,new q(a,b),m,r)};D.dividedToIntegerBy=D.divToInt=function(a,b){I=4;return U(this,new q(a,b),0,1)};D.equals=D.eq=function(a,b){I=5;return 0===n(this,new q(a,b))};D.floor=function(){return N(new q(this),this.e+1,3)};D.greaterThan=D.gt=function(a,b){I=6;return 0<n(this,new q(a,b))};D.greaterThanOrEqualTo=D.gte=function(a,b){I=7;return 1===(b=n(this,new q(a,b)))||0===b};D.isFinite=function(){return!!this.c};
D.isInteger=D.isInt=function(){return!!this.c&&e(this.e/14)>this.c.length-2};D.isNaN=function(){return!this.s};D.isNegative=D.isNeg=function(){return 0>this.s};D.isZero=function(){return!!this.c&&0==this.c[0]};D.lessThan=D.lt=function(a,b){I=8;return 0>n(this,new q(a,b))};D.lessThanOrEqualTo=D.lte=function(a,b){I=9;return-1===(b=n(this,new q(a,b)))||0===b};D.minus=D.sub=function(a,b){var c,d=this.s;I=10;a=new q(a,b);b=a.s;if(!d||!b)return new q(NaN);if(d!=b)return a.s=-b,this.plus(a);var m=this.e/
14;var g=a.e/14,k=this.c,u=a.c;if(!m||!g){if(!k||!u)return k?(a.s=-b,a):new q(u?this:NaN);if(!k[0]||!u[0])return u[0]?(a.s=-b,a):new q(k[0]?this:3==r?-0:0)}m=e(m);g=e(g);k=k.slice();if(d=m-g){(c=0>d)?(d=-d,m=k):(g=m,m=u);m.reverse();for(b=d;b--;m.push(0));m.reverse()}else for(m=(c=(d=k.length)<(b=u.length))?d:b,d=b=0;b<m;b++)if(k[b]!=u[b]){c=k[b]<u[b];break}c&&(m=k,k=u,u=m,a.s=-a.s);b=(m=u.length)-(c=k.length);if(0<b)for(;b--;k[c++]=0);for(b=1E14-1;m>d;){if(k[--m]<u[m]){for(c=m;c&&!k[--c];k[c]=b);
--k[c];k[m]+=1E14}k[m]-=u[m]}for(;0==k[0];k.shift(),--g);return k[0]?F(a,k,g):(a.s=3==r?-1:1,a.c=[a.e=0],a)};D.modulo=D.mod=function(a,b){I=11;a=new q(a,b);if(!this.c||!a.s||a.c&&!a.c[0])return new q(NaN);if(!a.c||this.c&&!this.c[0])return new q(this);if(9==fa){var c=a.s;a.s=1;var d=U(this,a,0,3);a.s=c;d.s*=c}else d=U(this,a,0,fa);return this.minus(d.times(a))};D.negated=D.neg=function(){var a=new q(this);a.s=-a.s||null;return a};D.plus=D.add=function(a,b){var c=this.s;I=12;a=new q(a,b);b=a.s;if(!c||
!b)return new q(NaN);if(c!=b)return a.s=-b,this.minus(a);var d=this.e/14;var m=a.e/14,g=this.c,k=a.c;if(!d||!m){if(!g||!k)return new q(c/0);if(!g[0]||!k[0])return k[0]?a:new q(g[0]?this:0*c)}d=e(d);m=e(m);g=g.slice();if(c=d-m){0<c?(m=d,d=k):(c=-c,d=g);for(d.reverse();c--;d.push(0));d.reverse()}c=g.length;b=k.length;0>c-b&&(d=k,k=g,g=d,b=c);for(c=0;b;)c=(g[--b]=g[b]+k[b]+c)/1E14|0,g[b]=1E14===g[b]?0:g[b]%1E14;c&&(g.unshift(c),++m);return F(a,g,m)};D.precision=D.sd=function(a){var b=this.c;null!=a&&
a!==!!a&&1!==a&&0!==a&&(R&&M(13,"argument not a boolean or binary digit",a),a!=!!a&&(a=null));if(!b)return null;var c=b.length-1;var d=14*c+1;if(c=b[c]){for(;0==c%10;c/=10,d--);for(c=b[0];10<=c;c/=10,d++);}a&&this.e+1>d&&(d=this.e+1);return d};D.round=function(a,b){var c=new q(this);(null==a||T(a,0,1E9,15))&&N(c,~~a+this.e+1,null!=b&&T(b,0,8,15,"rounding mode")?b|0:r);return c};D.shift=function(a){return T(a,-9007199254740991,9007199254740991,16,"argument")?this.times("1e"+t(a)):new q(this.c&&this.c[0]&&
(-9007199254740991>a||9007199254740991<a)?this.s*(0>a?0:1/0):this)};D.squareRoot=D.sqrt=function(){var a=this.c;var b=this.s,d=this.e,g=m+4,k=new q("0.5");if(1!==b||!a||!a[0])return new q(!b||0>b&&(!a||a[0])?NaN:a?this:1/0);b=Math.sqrt(+this);if(0==b||b==1/0){a=c(a);0==(a.length+d)%2&&(a+="0");b=Math.sqrt(a);d=e((d+1)/2)-(0>d||d%2);b==1/0?a="1e"+d:(a=b.toExponential(),a=a.slice(0,a.indexOf("e")+1)+d);var u=new q(a)}else u=new q(b+"");if(u.c[0])for(d=u.e,b=d+g,3>b&&(b=0);;){var p=u;u=k.times(p.plus(U(this,
p,g,1)));if(c(p.c).slice(0,b)===(a=c(u.c)).slice(0,b))if(u.e<d&&--b,a=a.slice(b-3,b+1),"9999"==a||!n&&"4999"==a){if(!n&&(N(p,p.e+m+2,0),p.times(p).eq(this))){u=p;break}g+=4;b+=4;var n=1}else{if(!+a||!+a.slice(1)&&"5"==a.charAt(0)){N(u,u.e+m+2,1);var f=!u.times(u).eq(this)}break}}return N(u,u.e+m+1,r,f)};D.times=D.mul=function(a,b){var c=this.c,d=(I=17,a=new q(a,b)).c;if(!(c&&d&&c[0]&&d[0]))return!this.s||!a.s||c&&!c[0]&&!d||d&&!d[0]&&!c?a.c=a.e=a.s=null:(a.s*=this.s,c&&d?(a.c=[0],a.e=0):a.c=a.e=null),
a;var m=e(this.e/14)+e(a.e/14);a.s*=this.s;var g=c.length;var k=d.length;if(g<k){var u=c;c=d;d=u;var r=g;g=k;k=r}r=g+k;for(u=[];r--;u.push(0));for(r=k;0<=--r;){var p=0;var n=d[r]%1E7;var f=d[r]/1E7|0;var t=g;for(k=r+t;k>r;){var v=c[--t]%1E7;var h=c[t]/1E7|0;var B=f*v+h*n;v=n*v+B%1E7*1E7+u[k]+p;p=(v/1E14|0)+(B/1E7|0)+f*h;u[k--]=v%1E14}u[k]=p}p?++m:u.shift();return F(a,u,m)};D.toDigits=function(a,b){var c=new q(this);a=null!=a&&T(a,1,1E9,18,"precision")?a|0:null;b=null!=b&&T(b,0,8,18,"rounding mode")?
b|0:r;return a?N(c,a,b):c};D.toExponential=function(a,b){return B(this,null!=a&&T(a,0,1E9,19)?~~a+1:null,b,19)};D.toFixed=function(a,b){return B(this,null!=a&&T(a,0,1E9,20)?~~a+this.e+1:null,b,20)};D.toFormat=function(a,b){var c=B(this,null!=a&&T(a,0,1E9,21)?~~a+this.e+1:null,b,21);if(this.c){var d=c.split(".");var c=+Z.groupSize,m=+Z.secondaryGroupSize,g=Z.groupSeparator,e=d[0],k=d[1],u=0>this.s,r=u?e.slice(1):e,p=r.length;m&&(d=c,c=m,m=d,p-=d);if(0<c&&0<p){d=p%c||c;for(e=r.substr(0,d);d<p;d+=c)e+=
g+r.substr(d,c);0<m&&(e+=g+r.slice(d));u&&(e="-"+e)}c=k?e+Z.decimalSeparator+((m=+Z.fractionGroupSize)?k.replace(new RegExp("\\d{"+m+"}\\B","g"),"$&"+Z.fractionGroupSeparator):k):e}return c};D.toFraction=function(a){var b,d,m;var g=R;var e=this.c;var k=new q(u),p=b=new q(u),n=m=new q(u);if(null!=a){R=!1;var f=new q(a);R=g;if(!(g=f.isInt())||f.lt(u))R&&M(22,"max denominator "+(g?"out of range":"not an integer"),a),a=!g&&f.c&&N(f,f.e+1,1).gte(u)?f:null}if(!e)return this.toString();e=c(e);g=k.e=e.length-
this.e-1;k.c[0]=K[0>(d=g%14)?14+d:d];a=!a||0<f.cmp(k)?0<g?k:p:f;d=S;S=1/0;f=new q(e);for(m.c[0]=0;;){var t=U(f,k,0,1);e=b.plus(t.times(n));if(1==e.cmp(a))break;b=n;n=e;p=m.plus(t.times(e=p));m=e;k=f.minus(t.times(e=k));f=e}e=U(a.minus(b),n,0,1);m=m.plus(e.times(p));b=b.plus(e.times(n));m.s=p.s=this.s;g*=2;a=1>U(p,n,g,r).minus(this).abs().cmp(U(m,b,g,r).minus(this).abs())?[p.toString(),n.toString()]:[m.toString(),b.toString()];S=d;return a};D.toNumber=function(){return+this};D.toPower=D.pow=function(a,
b){var c,d=y(0>a?-a:+a),m=this;null!=b&&(I=23,b=new q(b));if(!T(a,-9007199254740991,9007199254740991,23,"exponent")&&(!isFinite(a)||9007199254740991<d&&(a/=0)||parseFloat(a)!=a&&!(a=NaN))||0==a){var g=Math.pow(+m,a);return new q(b?g%b:g)}if(b)if(1<a&&m.gt(u)&&m.isInt()&&b.gt(u)&&b.isInt())m=m.mod(b);else{var e=b;b=null}else ca&&(g=C(ca/14+2));for(c=new q(u);;){if(d%2){c=c.times(m);if(!c.c)break;g?c.c.length>g&&(c.c.length=g):b&&(c=c.mod(b))}d=y(d/2);if(!d)break;m=m.times(m);g?m.c&&m.c.length>g&&(m.c.length=
g):b&&(m=m.mod(b))}if(b)return c;0>a&&(c=u.div(c));return e?c.mod(e):g?N(c,ca,r):c};D.toPrecision=function(a,b){return B(this,null!=a&&T(a,1,1E9,24,"precision")?a|0:null,b,24)};D.toString=function(a){var b=this.s,m=this.e;if(null===m)if(b){var g="Infinity";0>b&&(g="-"+g)}else g="NaN";else g=c(this.c),g=null!=a&&T(a,2,64,25,"base")?v(d(g,m),a|0,10,b):m<=w||m>=A?f(g,m):d(g,m),0>b&&this.c[0]&&(g="-"+g);return g};D.truncated=D.trunc=function(){return N(new q(this),this.e+1,1)};D.valueOf=D.toJSON=function(){var a=
this.e;if(null===a)return this.toString();var b=c(this.c);b=a<=w||a>=A?f(b,a):d(b,a);return 0>this.s?"-"+b:b};null!=b&&q.config(b);return q}function e(a){var b=a|0;return 0<a||a===b?b:b-1}function c(a){for(var b,c,d=1,g=a.length,e=a[0]+"";d<g;){b=a[d++]+"";for(c=14-b.length;c--;b="0"+b);e+=b}for(g=e.length;48===e.charCodeAt(--g););return e.slice(0,g+1||1)}function n(a,b){var c=a.c,d=b.c,g=a.s,e=b.s,k=a.e,p=b.e;if(!g||!e)return null;var n=c&&!c[0];var f=d&&!d[0];if(n||f)return n?f?0:-e:g;if(g!=e)return g;
n=0>g;f=k==p;if(!c||!d)return f?0:!c^n?1:-1;if(!f)return k>p^n?1:-1;e=(k=c.length)<(p=d.length)?k:p;for(g=0;g<e;g++)if(c[g]!=d[g])return c[g]>d[g]^n?1:-1;return k==p?0:k>p^n?1:-1}function g(a,b,c){return(a=t(a))>=b&&a<=c}function p(a){return"[object Array]"==Object.prototype.toString.call(a)}function k(a,b,c){for(var d,g=[0],e=0,k=a.length;e<k;){for(d=g.length;d--;g[d]*=b);for(g[d=0]+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".indexOf(a.charAt(e++));d<g.length;d++)g[d]>c-1&&
(null==g[d+1]&&(g[d+1]=0),g[d+1]+=g[d]/c|0,g[d]%=c)}return g.reverse()}function f(a,b){return(1<a.length?a.charAt(0)+"."+a.slice(1):a)+(0>b?"e":"e+")+b}function d(a,b){var c;if(0>b){for(c="0.";++b;c+="0");a=c+a}else{var d=a.length;if(++b>d){c="0";for(b-=d;--b;c+="0");a+=c}else b<d&&(a=a.slice(0,b)+"."+a.slice(b))}return a}function t(a){a=parseFloat(a);return 0>a?C(a):y(a)}var h,z=/^-?(\d+(\.\d*)?|\.\d+)(e[+-]?\d+)?$/i,C=Math.ceil,y=Math.floor,K=[1,10,100,1E3,1E4,1E5,1E6,1E7,1E8,1E9,1E10,1E11,1E12,
1E13];var q=a();q["default"]=q.BigNumber=q;"undefined"!=typeof l&&l.exports?l.exports=q:(b||(b="undefined"!=typeof self?self:Function("return this")()),b.BigNumber=q)})(this)},{}],22:[function(f,l,h){h.Commented=f("./commented");h.Diagnose=f("./diagnose");h.Decoder=f("./decoder");h.Encoder=f("./encoder");h.Simple=f("./simple");h.Tagged=f("./tagged");h.comment=h.Commented.comment;h.decodeAll=h.Decoder.decodeAll;h.decodeFirst=h.Decoder.decodeFirst;h.decodeAllSync=h.Decoder.decodeAllSync;h.decodeFirstSync=
h.Decoder.decodeFirstSync;h.diagnose=h.Diagnose.diagnose;h.encode=h.Encoder.encode;h.decode=h.Decoder.decodeFirstSync;h.leveldb={decode:h.Decoder.decodeAllSync,encode:h.Encoder.encode,buffer:!0,name:"cbor"}},{"./commented":23,"./decoder":25,"./diagnose":26,"./encoder":27,"./simple":28,"./tagged":29}],23:[function(f,l,h){(function(b){var a=f("stream"),e=f("util");f("./utils");f("./simple");var c=f("./decoder"),n=f("./constants"),g=f("bignumber.js"),p=f("nofilter"),k=n.MT,v=n.NUMBYTES,d=n.SYMS,t=function(b){b=
b||{};b.readableObjectMode=!1;b.writableObjectMode=!1;var d=null!=b.max_depth?b.max_depth:10;delete b.max_depth;var g=a.Transform.call(this,b)||this;g.depth=1;g.max_depth=d;g.all=new p;g.parser=new c(b);g.parser.on("value",g._on_value.bind(g));g.parser.on("start",g._on_start.bind(g));g.parser.on("start-string",g._on_start_string.bind(g));g.parser.on("stop",g._on_stop.bind(g));g.parser.on("more-bytes",g._on_more.bind(g));g.parser.on("error",g._on_error.bind(g));g.parser.on("data",g._on_data.bind(g));
g.parser.bs.on("read",g._on_read.bind(g));return g};$jscomp.inherits(t,a.Transform);t.prototype._transform=function(a,b,c){this.parser.write(a,b,function(a){c(a)})};t.prototype._flush=function(a){return this.parser._flush(a)};t.comment=function(a,b,c){if(null==a)throw Error("input required");var d="string"===typeof a?"hex":void 0,g=10;switch(typeof b){case "function":c=b;break;case "string":d=b;break;case "number":g=b;break;case "object":var e,k,d=null!=(e=b.encoding)?e:d,g=null!=(k=b.max_depth)?
k:g;break;case "undefined":break;default:throw Error("Unknown option type");}var n=new p,f=new t({max_depth:g});b=null;"function"===typeof c?(f.on("end",function(){return c(null,n.toString("utf8"))}),f.on("error",c)):b=new Promise(function(a,b){f.on("end",function(){return a(n.toString("utf8"))});return f.on("error",b)});f.pipe(n);f.end(a,d);return b};t.prototype._on_error=function(a){return this.push("ERROR: ")&&this.push(a.toString())&&this.push("\n")};t.prototype._on_read=function(a){this.all.write(a);
a=a.toString("hex");this.push(Array(this.depth+1).join("  "));this.push(a);var b=2*(this.max_depth-this.depth),b=b-a.length;1>b&&(b=1);this.push(Array(b+1).join(" "));return this.push("-- ")};t.prototype._on_more=function(a,b,c,d){this.depth++;c="";switch(a){case k.POS_INT:c="Positive number,";break;case k.NEG_INT:c="Negative number,";break;case k.ARRAY:c="Array, length";break;case k.MAP:c="Map, count";break;case k.BYTE_STRING:c="Bytes, length";break;case k.UTF8_STRING:c="String, length";break;case k.SIMPLE_FLOAT:c=
1===b?"Simple value,":"Float,"}return this.push(c+" next "+b+" byte"+(1<b?"s":"")+"\n")};t.prototype._on_start_string=function(a,b,c,d){this.depth++;c="";switch(a){case k.BYTE_STRING:c="Bytes, length: "+b;break;case k.UTF8_STRING:c="String, length: "+b.toString()}return this.push(c+"\n")};t.prototype._on_start=function(a,b,c,g){this.depth++;b!==d.BREAK&&this.push(function(){switch(c){case k.ARRAY:return"["+g+"], ";case k.MAP:return g%2?"{Val:"+Math.floor(g/2)+"}, ":"{Key:"+Math.floor(g/2)+"}, "}}());
this.push(function(){switch(a){case k.TAG:return"Tag #"+b;case k.ARRAY:return b===d.STREAM?"Array (streaming)":"Array, "+b+" item"+(1<b?"s":"");case k.MAP:return b===d.STREAM?"Map (streaming)":"Map, "+b+" pair"+(1<b?"s":"");case k.BYTE_STRING:return"Bytes (streaming)";case k.UTF8_STRING:return"String (streaming)"}}());return this.push("\n")};t.prototype._on_stop=function(a){return this.depth--};t.prototype._on_value=function(a,c,p,n){a!==d.BREAK&&this.push(function(){switch(c){case k.ARRAY:return"["+
p+"], ";case k.MAP:return p%2?"{Val:"+Math.floor(p/2)+"}, ":"{Key:"+Math.floor(p/2)+"}, "}}());a===d.BREAK?this.push("BREAK\n"):a===d.NULL?this.push("null\n"):a===d.UNDEFINED?this.push("undefined\n"):"string"===typeof a?(this.depth--,0<a.length&&(this.push(JSON.stringify(a)),this.push("\n"))):b.isBuffer(a)?(this.depth--,0<a.length&&(this.push(a.toString("hex")),this.push("\n"))):(a instanceof g?this.push(a.toString()):this.push(e.inspect(a)),this.push("\n"));switch(n){case v.ONE:case v.TWO:case v.FOUR:case v.EIGHT:this.depth--}};
t.prototype._on_data=function(){this.push("0x");this.push(this.all.read().toString("hex"));return this.push("\n")};l.exports=t}).call(this,{isBuffer:f("../../../../../../../../usr/local/lib/node_modules/browserify/node_modules/is-buffer/index.js")})},{"../../../../../../../../usr/local/lib/node_modules/browserify/node_modules/is-buffer/index.js":134,"./constants":24,"./decoder":25,"./simple":28,"./utils":30,"bignumber.js":21,nofilter:98,stream:153,util:160}],24:[function(f,l,h){h.MT={POS_INT:0,NEG_INT:1,
BYTE_STRING:2,UTF8_STRING:3,ARRAY:4,MAP:5,TAG:6,SIMPLE_FLOAT:7};h.TAG={DATE_STRING:0,DATE_EPOCH:1,POS_BIGINT:2,NEG_BIGINT:3,DECIMAL_FRAC:4,BIGFLOAT:5,BASE64URL_EXPECTED:21,BASE64_EXPECTED:22,BASE16_EXPECTED:23,CBOR:24,URI:32,BASE64URL:33,BASE64:34,REGEXP:35,MIME:36};h.NUMBYTES={ZERO:0,ONE:24,TWO:25,FOUR:26,EIGHT:27,INDEFINITE:31};h.SIMPLE={FALSE:20,TRUE:21,NULL:22,UNDEFINED:23};$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();h.SYMS={NULL:Symbol("null"),
UNDEFINED:Symbol("undef"),PARENT:Symbol("parent"),BREAK:Symbol("break"),STREAM:Symbol("stream")};h.SHIFT32=Math.pow(2,32)},{}],25:[function(f,l,h){(function(b){function a(a,b,c){var d=[];d[y]=c;d[h.PARENT]=a;d[K]=b;return d}var e=f("../vendor/binary-parse-stream"),c=f("./tagged"),n=f("./simple"),g=f("./utils"),p=f("bignumber.js"),k=f("nofilter"),v=f("./constants"),d=v.MT,t=v.NUMBYTES,h=v.SYMS,z=new p(-1),C=z.sub(new p(Number.MAX_SAFE_INTEGER.toString(16),16));$jscomp.initSymbol();var y=Symbol("count");
$jscomp.initSymbol();Symbol("pending_key");$jscomp.initSymbol();var K=Symbol("major type");$jscomp.initSymbol();var q=Symbol("error");$jscomp.initSymbol();var L=Symbol("not found"),x=function(a){a=a||{};var b=a.tags;delete a.tags;var c=null!=a.max_depth?a.max_depth:-1;delete a.max_depth;a=e.call(this,a)||this;a.running=!0;a.max_depth=c;a.tags=b;return a};$jscomp.inherits(x,e);x.nullcheck=function(a){switch(a){case h.NULL:return null;case h.UNDEFINED:break;case L:throw Error("Value not found");default:return a}};
x.decodeFirstSync=function(a,b){b=b||{encoding:"hex"};var c={};switch(typeof b){case "string":var d=b;break;case "object":c=g.extend({},b),d=c.encoding,delete c.encoding}c=new x(c);d=new k(a,null!=d?d:g.guessEncoding(a));for(var c=c._parse(),e=c.next();!e.done;){var p=d.read(e.value);if(null==p||p.length!==e.value)throw Error("Insufficient data");e=c.next(p)}return x.nullcheck(e.value)};x.decodeAllSync=function(a,b){b=b||{encoding:"hex"};var c={};switch(typeof b){case "string":var d=b;break;case "object":c=
g.extend({},b),d=c.encoding,delete c.encoding}c=new x(c);d=new k(a,null!=d?d:g.guessEncoding(a));for(var e=[];0<d.length;){for(var p=c._parse(),n=p.next();!n.done;){var f=d.read(n.value);if(null==f||f.length!==n.value)throw Error("Insufficient data");n=p.next(f)}e.push(x.nullcheck(n.value))}return e};x.decodeFirst=function(a,b,c){var d={},e=!1,k="hex";switch(typeof b){case "function":c=b;k=g.guessEncoding(a);break;case "string":k=b;break;case "object":d=g.extend({},b),k=null!=d.encoding?d.encoding:
g.guessEncoding(a),delete d.encoding,e=null!=d.required?d.required:!1,delete d.required}var p=new x(d),n=L;p.on("data",function(a){n=x.nullcheck(a);p.close()});if("function"===typeof c)p.once("error",function(a){var b=n;n=q;p.close();return c(a,b)}),p.once("end",function(){switch(n){case L:return e?c(Error("No CBOR found")):c(null,n);case q:break;default:return c(null,n)}});else var f=new Promise(function(a,b){p.once("error",function(a){n=q;p.close();return b(a)});return p.once("end",function(){switch(n){case L:return e?
b(Error("No CBOR found")):a(n);case q:break;default:return a(n)}})});p.end(a,k);return f};x.decodeAll=function(a,b,c){var d={},e="hex";switch(typeof b){case "function":c=b;e=g.guessEncoding(a);break;case "string":e=b;break;case "object":d=g.extend({},b),e=null!=d.encoding?d.encoding:g.guessEncoding(a),delete d.encoding}var k=new x(d),p=[];k.on("data",function(a){return p.push(x.nullcheck(a))});if("function"===typeof c)k.on("error",function(a){return c(a)}),k.on("end",function(){return c(null,p)});
else var n=new Promise(function(a,b){k.on("error",function(a){return b(a)});return k.on("end",function(){return a(p)})});k.end(a,e);return n};x.prototype.close=function(){this.running=!1;this.__fresh=!0};x.prototype._parse=function(){function e(e,E){for(;;)switch(f){case 0:O=null,ga=0,P=null;case 1:if(!(0<=X.max_depth&&ga>X.max_depth)){f=3;break}f=-1;throw Error("Maximum depth "+X.max_depth+" exceeded");case 3:return f=4,{value:1,done:!1};case 4:if(void 0===E){f=5;break}f=-1;throw E;case 5:ja=e;ha=
ja[0];if(X.running){f=6;break}f=-1;throw Error("Unexpected data: 0x"+ha.toString(16));case 6:W=ha>>5;aa=ha&31;Y=null!=O?O[K]:void 0;ba=null!=O?O.length:void 0;U=!1;Z=aa;if(!U&&Z!==t.ONE){f=8;break}U=!0;X.emit("more-bytes",W,1,Y,ba);f=9;return{value:1,done:!1};case 9:if(void 0===E){f=10;break}f=-1;throw E;case 10:ca=e;P=ca[0];f=7;break;case 8:if(U||Z===t.TWO)U=!0;if(U||Z===t.FOUR)U=!0;if(!U&&Z!==t.EIGHT){f=11;break}U=!0;fa=1<<aa-24;X.emit("more-bytes",W,fa,Y,ba);f=12;return{value:fa,done:!1};case 12:if(void 0===
E){f=13;break}f=-1;throw E;case 13:T=ea=e;P=W===d.SIMPLE_FLOAT?T:g.parseCBORint(aa,T);f=7;break;case 11:if(U||28===Z)U=!0;if(U||29===Z)U=!0;if(!U&&30!==Z){f=14;break}U=!0;X.running=!1;f=-1;throw Error("Additional info not implemented: "+aa);case 14:if(!U&&Z!==t.INDEFINITE){f=15;break}U=!0;P=-1;f=7;break;case 15:U=!0,P=aa;case 7:R=!1;S=W;if(!R&&S!==d.POS_INT){f=17;break}R=!0;f=16;break;case 17:if(!R&&S!==d.NEG_INT){f=18;break}R=!0;P=P===Number.MAX_SAFE_INTEGER?C:P instanceof p?z.sub(P):-1-P;f=16;break;
case 18:if(R||S===d.BYTE_STRING)R=!0;if(!R&&S!==d.UTF8_STRING){f=19;break}R=!0;V=!1;A=P;if(!V&&0!==A){f=21;break}V=!0;X.emit("start-string",W,P,Y,ba);P=W===d.BYTE_STRING?new b(0):"";f=20;break;case 21:if(!V&&-1!==A){f=22;break}V=!0;X.emit("start",W,h.STREAM,Y,ba);var J=O,G=W,M=new k;M[h.PARENT]=J;M[K]=G;O=M;ga++;f=1;break;case 22:return V=!0,X.emit("start-string",W,P,Y,ba),f=23,{value:P,done:!1};case 23:if(void 0===E){f=24;break}f=-1;throw E;case 24:P=w=e,W===d.UTF8_STRING&&(P=P.toString("utf-8"));
case 20:f=16;break;case 19:if(R||S===d.ARRAY)R=!0;if(!R&&S!==d.MAP){f=25;break}R=!0;r=!1;m=P;if(!r&&0!==m){f=27;break}r=!0;P=W===d.MAP?{}:[];P[h.PARENT]=O;f=26;break;case 27:if(!r&&-1!==m){f=28;break}r=!0;X.emit("start",W,h.STREAM,Y,ba);O=a(O,W,-1);ga++;f=1;break;case 28:r=!0;X.emit("start",W,P,Y,ba);O=a(O,W,P*(W-3));ga++;f=1;break;case 26:f=16;break;case 25:if(!R&&S!==d.TAG){f=29;break}R=!0;X.emit("start",W,P,Y,ba);O=a(O,W,1);O.push(P);ga++;f=1;break;case 29:if(R||S===d.SIMPLE_FLOAT)R=!0,P="number"===
typeof P?n.decode(P,null!=O):g.parseCBORfloat(P);case 16:X.emit("value",P,Y,ba,aa),u=!1;case 30:if(null==O){f=31;break}l=D=!1;if(!D&&l!==(P!==h.BREAK)){f=33;break}D=!0;O[y]=1;f=32;break;case 33:if(!D&&l!==!Array.isArray(O)){f=34;break}D=!0;O.push(P);f=32;break;case 34:if(!D&&l!==!(O instanceof k)){f=35;break}D=!0;L=O[K];if(null==L||L===W){f=36;break}X.running=!1;f=-1;throw Error("Invalid major type in indefinite encoding");case 36:O.write(P);case 35:case 32:if(0===--O[y]){f=37;break}u=!0;f=31;break;
case 37:--ga;delete O[y];X.emit("stop",O[K]);if(!Array.isArray(O)){f=38;break}x=!1;B=O[K];if(!x&&B!==d.ARRAY){f=41;break}x=!0;P=O;f=40;break;case 41:if(!x&&B!==d.MAP){f=42;break}v=x=!0;if(0===O.length%2){f=43;break}f=-1;throw Error("Invalid map length: "+O.length);case 43:G=0;for(J=O.length;G<J;G+=2)if("string"!==typeof O[G]){v=!1;break}if(v)for(P={},G=0,J=O.length;G<J;G+=2)P[O[G]]=O[G+1];else for(P=new Map,G=0,J=O.length;G<J;G+=2)P.set(O[G],O[G+1]);f=40;break;case 42:if(!x&&B!==d.TAG){f=44;break}x=
!0;q=new c(O[0],O[1]);P=q.convert(X.tags);f=40;break;case 44:case 40:f=39;break;case 38:if(O instanceof k)switch(O[K]){case d.BYTE_STRING:P=O.slice();case d.UTF8_STRING:P=O.toString("utf-8")}case 39:O=O[h.PARENT];f=30;break;case 31:if(u){f=45;break}f=-1;return{value:P,done:!0};case 45:f=1;break;case 2:f=-1;default:return{value:void 0,done:!0}}}var f=0,q,v,B,x,L,l,D,u,m,r,w,A,V,S,R,T,ea,fa,ca,Z,U,ba,Y,aa,W,ha,ja,P,ga,O,X=this,da={next:function(a){return e(a,void 0)},"throw":function(a){return e(void 0,
a)},"return":function(a){throw Error("Not yet implemented");}};$jscomp.initSymbolIterator();da[Symbol.iterator]=function(){return this};return da};x.NOT_FOUND=L;l.exports=x}).call(this,f("buffer").Buffer)},{"../vendor/binary-parse-stream":31,"./constants":24,"./simple":28,"./tagged":29,"./utils":30,"bignumber.js":21,buffer:129,nofilter:98}],26:[function(f,l,h){(function(b){var a=f("stream"),e=f("util"),c=f("./decoder");f("./simple");var n=f("./utils"),g=f("./constants"),p=f("bignumber.js"),k=f("nofilter"),
h=g.MT,d=g.SYMS,t=function(b){b=b||{};var d=null!=b.separator?b.separator:"\n";delete b.separator;var g=null!=b.stream_errors?b.stream_errors:!1;delete b.stream_errors;b.readableObjectMode=!1;b.writableObjectMode=!1;var e=a.Transform.call(this,b)||this;e.float_bytes=-1;e.separator=d;e.stream_errors=g;e.parser=new c(b);e.parser.on("more-bytes",e._on_more.bind(e));e.parser.on("value",e._on_value.bind(e));e.parser.on("start",e._on_start.bind(e));e.parser.on("stop",e._on_stop.bind(e));e.parser.on("data",
e._on_data.bind(e));e.parser.on("error",e._on_error.bind(e));return e};$jscomp.inherits(t,a.Transform);t.prototype._transform=function(a,b,c){return this.parser.write(a,b,c)};t.prototype._flush=function(a){var b=this;return this.parser._flush(function(c){return b.stream_errors?(b._on_error(c),a()):a(c)})};t.diagnose=function(a,b,c){if(null==a)throw Error("input required");var d={},g="hex";switch(typeof b){case "function":c=b;g=n.guessEncoding(a);break;case "object":d=n.extend({},b);g=null!=d.encoding?
d.encoding:n.guessEncoding(a);delete d.encoding;break;default:g=null!=b?b:"hex"}var e=new k,p=new t(d);b=null;"function"===typeof c?(p.on("end",function(){return c(null,e.toString("utf8"))}),p.on("error",c)):b=new Promise(function(a,b){p.on("end",function(){return a(e.toString("utf8"))});return p.on("error",b)});p.pipe(e);p.end(a,g);return b};t.prototype._on_error=function(a){return this.stream_errors?this.push(a.toString()):this.emit("error",a)};t.prototype._on_more=function(a,b,c,d){if(a===h.SIMPLE_FLOAT)return this.float_bytes=
function(){switch(b){case 2:return 1;case 4:return 2;case 8:return 3}}()};t.prototype._fore=function(a,b){switch(a){case h.BYTE_STRING:case h.UTF8_STRING:case h.ARRAY:if(0<b)return this.push(", ");break;case h.MAP:if(0<b)return b%2?this.push(": "):this.push(", ")}};t.prototype._on_value=function(a,c,g){if(a!==d.BREAK)return this._fore(c,g),this.push(function(){switch(!1){case a!==d.NULL:return"null";case a!==d.UNDEFINED:return"undefined";case "string"!==typeof a:return JSON.stringify(a);case !(0<
this.float_bytes):var c=this.float_bytes;this.float_bytes=-1;return e.inspect(a)+"_"+c;case !b.isBuffer(a):return"h'"+a.toString("hex")+"'";case !(a instanceof p):return a.toString();default:return e.inspect(a)}}.call(this))};t.prototype._on_start=function(a,b,c,g){this._fore(c,g);this.push(function(){switch(a){case h.TAG:return b+"(";case h.ARRAY:return"[";case h.MAP:return"{";case h.BYTE_STRING:case h.UTF8_STRING:return"(";default:throw Error("Unknown diagnostic type: "+a);}}());if(b===d.STREAM)return this.push("_ ")};
t.prototype._on_stop=function(a){return this.push(function(){switch(a){case h.TAG:return")";case h.ARRAY:return"]";case h.MAP:return"}";case h.BYTE_STRING:case h.UTF8_STRING:return")";default:throw Error("Unknown diagnostic type: "+a);}}())};t.prototype._on_data=function(){return this.push(this.separator)};l.exports=t}).call(this,{isBuffer:f("../../../../../../../../usr/local/lib/node_modules/browserify/node_modules/is-buffer/index.js")})},{"../../../../../../../../usr/local/lib/node_modules/browserify/node_modules/is-buffer/index.js":134,
"./constants":24,"./decoder":25,"./simple":28,"./utils":30,"bignumber.js":21,nofilter:98,stream:153,util:160}],27:[function(f,l,h){(function(b){var a=f("stream"),e=f("url"),c=f("bignumber.js"),n=f("nofilter");f("./tagged");f("./simple");var g=f("./utils"),p=f("./constants"),k=p.MT,h=p.NUMBYTES,d=p.SHIFT32,t=p.SYMS,B=p.TAG,z=p.MT.SIMPLE_FLOAT<<5|p.NUMBYTES.TWO,C=p.MT.SIMPLE_FLOAT<<5|p.NUMBYTES.FOUR,y=p.MT.SIMPLE_FLOAT<<5|p.NUMBYTES.EIGHT,K=p.MT.SIMPLE_FLOAT<<5|p.SIMPLE.TRUE,q=p.MT.SIMPLE_FLOAT<<5|
p.SIMPLE.FALSE,L=p.MT.SIMPLE_FLOAT<<5|p.SIMPLE.UNDEFINED,x=p.MT.SIMPLE_FLOAT<<5|p.SIMPLE.NULL,E=new c("0x20000000000000"),G=new b("f97e00","hex"),J=new b("f9fc00","hex"),Q=new b("f97c00","hex"),F=function(d){d=d||{};d.readableObjectMode=!1;d.writableObjectMode=!0;var g=a.Transform.call(this,d)||this;g.canonical=d.canonical;g.semanticTypes=[Array,g._pushArray,Date,g._pushDate,b,g._pushBuffer,Map,g._pushMap,n,g._pushNoFilter,RegExp,g._pushRegexp,Set,g._pushSet,e.Url,g._pushUrl,c,g._pushBigNumber];d=
d.genTypes||[];for(var k=0,p=d.length;k<p;k+=2)g.addSemanticType(d[k],d[k+1]);return g};$jscomp.inherits(F,a.Transform);F.prototype._transform=function(a,b,c){a=this.pushAny(a);return c(!1===a?Error("Push Error"):void 0)};F.prototype._flush=function(a){return a()};F.prototype.addSemanticType=function(a,b){for(var c=0,d=this.semanticTypes.length;c<d;c+=2)if(this.semanticTypes[c]===a)return d=this.semanticTypes[c+1],this.semanticTypes[c+1]=b,d;this.semanticTypes.push(a,b);return null};F.prototype._pushUInt8=
function(a){var c=new b(1);c.writeUInt8(a);return this.push(c)};F.prototype._pushUInt16BE=function(a){var c=new b(2);c.writeUInt16BE(a);return this.push(c)};F.prototype._pushUInt32BE=function(a){var c=new b(4);c.writeUInt32BE(a);return this.push(c)};F.prototype._pushDoubleBE=function(a){var c=new b(8);c.writeDoubleBE(a);return this.push(c)};F.prototype._pushNaN=function(){return this.push(G)};F.prototype._pushInfinity=function(a){return this.push(0>a?J:Q)};F.prototype._pushFloat=function(a){if(this.canonical){var c=
new b(2);if(g.writeHalf(c,a)&&g.parseHalf(c)===a)return this._pushUInt8(z)&&this.push(c);c=new b(4);c.writeFloatBE(a);if(c.readFloatBE()===a)return this._pushUInt8(C)&&this.push(c)}return this._pushUInt8(y)&&this._pushDoubleBE(a)};F.prototype._pushInt=function(a,b,c){var g=b<<5;switch(!1){case !(24>a):return this._pushUInt8(g|a);case !(255>=a):return this._pushUInt8(g|h.ONE)&&this._pushUInt8(a);case !(65535>=a):return this._pushUInt8(g|h.TWO)&&this._pushUInt16BE(a);case !(4294967295>=a):return this._pushUInt8(g|
h.FOUR)&&this._pushUInt32BE(a);case !(a<=Number.MAX_SAFE_INTEGER):return this._pushUInt8(g|h.EIGHT)&&this._pushUInt32BE(Math.floor(a/d))&&this._pushUInt32BE(a%d);default:return b===k.NEG_INT?this._pushFloat(c):this._pushFloat(a)}};F.prototype._pushIntNum=function(a){return 0>a?this._pushInt(-a-1,k.NEG_INT,a):this._pushInt(a,k.POS_INT)};F.prototype._pushNumber=function(a){switch(!1){case !isNaN(a):return this._pushNaN(a);case isFinite(a):return this._pushInfinity(a);case Math.round(a)!==a:return this._pushIntNum(a);
default:return this._pushFloat(a)}};F.prototype._pushString=function(a){var c=b.byteLength(a,"utf8");return this._pushInt(c,k.UTF8_STRING)&&this.push(a,"utf8")};F.prototype._pushBoolean=function(a){return this._pushUInt8(a?K:q)};F.prototype._pushUndefined=function(a){return this._pushUInt8(L)};F.prototype._pushNull=function(a){return this._pushUInt8(x)};F.prototype._pushArray=function(a,b){var c=b.length;if(!a._pushInt(c,k.ARRAY))return!1;for(var d=0;d<c;d++)if(!a.pushAny(b[d]))return!1;return!0};
F.prototype._pushTag=function(a){return this._pushInt(a,k.TAG)};F.prototype._pushDate=function(a,b){return a._pushTag(B.DATE_EPOCH)&&a.pushAny(b/1E3)};F.prototype._pushBuffer=function(a,b){return a._pushInt(b.length,k.BYTE_STRING)&&a.push(b)};F.prototype._pushNoFilter=function(a,b){return a._pushBuffer(a,b.slice())};F.prototype._pushRegexp=function(a,b){return a._pushTag(B.REGEXP)&&a.pushAny(b.source)};F.prototype._pushSet=function(a,b){if(!a._pushInt(b.size,k.ARRAY))return!1;for(var c=$jscomp.makeIterator(b),
d=c.next();!d.done;d=c.next())if(!a.pushAny(d.value))return!1;return!0};F.prototype._pushUrl=function(a,b){return a._pushTag(B.URI)&&a.pushAny(b.format())};F.prototype._pushBigint=function(a){var c=B.POS_BIGINT;a.isNegative()&&(a=a.negated().minus(1),c=B.NEG_BIGINT);a=a.toString(16);a.length%2&&(a="0"+a);a=new b(a,"hex");return this._pushTag(c)&&this._pushBuffer(this,a)};F.prototype._pushBigNumber=function(a,b){if(b.isNaN())return a._pushNaN();if(!b.isFinite())return a._pushInfinity(b.isNegative()?
-Infinity:Infinity);if(b.isInteger())return a._pushBigint(b);if(!a._pushTag(B.DECIMAL_FRAC)||!a._pushInt(2,k.ARRAY))return!1;var d=b.decimalPlaces(),g=b.mul((new c(10)).pow(d));return a._pushIntNum(-d)?g.abs().lessThan(E)?a._pushIntNum(g.toNumber()):a._pushBigint(g):!1};F.prototype._pushMap=function(a,b){if(!a._pushInt(b.size,k.MAP))return!1;if(a.canonical){for(var c=[],d=$jscomp.makeIterator(b.entries()),g=d.next();!g.done;g=d.next())c.push(g.value);c.sort(function(a,b){var c=F.encode(a[0]),d=F.encode(b[0]);
return c.compare(d)});c=$jscomp.makeIterator(c)}else c=$jscomp.makeIterator(b);for(d=c.next();!d.done;d=c.next())if(d=d.value,!a.pushAny(d[0])||!a.pushAny(d[1]))return!1;return!0};F.prototype._pushObject=function(a){if(!a)return this._pushNull(a);for(var b=0,c=this.semanticTypes.length;b<c;b+=2)if(a instanceof this.semanticTypes[b])return this.semanticTypes[b+1].call(a,this,a);b=a.encodeCBOR;if("function"===typeof b)return b.call(a,this);var b=Object.keys(a),d={};this.canonical&&b.sort(function(a,
b){var c=d[a]||(d[a]=F.encode(a)),g=d[b]||(d[b]=F.encode(b));return c.compare(g)});if(!this._pushInt(b.length,k.MAP))return!1;for(var g,c=0,m=b.length;c<m;c++){var e=b[c];if(this.canonical&&(g=d[e])){if(!this.push(g))return!1}else if(!this._pushString(e))return!1;if(!this.pushAny(a[e]))return!1}return!0};F.prototype.pushAny=function(a){switch(typeof a){case "number":return this._pushNumber(a);case "string":return this._pushString(a);case "boolean":return this._pushBoolean(a);case "undefined":return this._pushUndefined(a);
case "object":return this._pushObject(a);case "symbol":switch(a){case t.NULL:return this._pushNull(null);case t.UNDEFINED:return this._pushUndefined(void 0);default:throw Error("Unknown symbol: "+a.toString());}default:throw Error("Unknown type: "+typeof a+", "+(a?a.toString():""));}};F.prototype._pushAny=function(a){return this.pushAny(a)};F.encode=function(){var a=Array.prototype.slice.apply(arguments),b=new F,c=new n;b.pipe(c);for(var a=$jscomp.makeIterator(a),d=a.next();!d.done;d=a.next())d=d.value,
"undefined"===typeof d?b._pushUndefined():null===d?b._pushNull(null):b.write(d);b.end();return c.read()};l.exports=F}).call(this,f("buffer").Buffer)},{"./constants":24,"./simple":28,"./tagged":29,"./utils":30,"bignumber.js":21,buffer:129,nofilter:98,stream:153,url:155}],28:[function(f,l,h){f=f("./constants");var b=f.MT,a=f.SIMPLE,e=f.SYMS,c=function(a){if("number"!==typeof a)throw Error("Invalid Simple type: "+typeof a);if(0>a||255<a||(a|0)!==a)throw Error("value must be a small positive integer: "+
a);this.value=a};c.prototype.toString=function(){return"simple("+this.value+")"};c.prototype.inspect=function(a,b){return"simple("+this.value+")"};c.prototype.encodeCBOR=function(a){return a._pushInt(this.value,b.SIMPLE_FLOAT)};c.isSimple=function(a){return a instanceof c};c.decode=function(b,g){null==g&&(g=!0);switch(b){case a.FALSE:return!1;case a.TRUE:return!0;case a.NULL:return g?null:e.NULL;case a.UNDEFINED:if(g)break;return e.UNDEFINED;case -1:if(!g)throw Error("Invalid BREAK");return e.BREAK;
default:return new c(b)}};l.exports=c},{"./constants":24}],29:[function(f,l,h){h=f("bignumber.js");var b=f("./utils"),a=f("url"),e=new h(-1),c=new h(10),n=new h(2),g=function(a,b,c){this.tag=a;this.value=b;this.err=c;if("number"!==typeof this.tag)throw Error("Invalid tag type ("+typeof this.tag+")");if(0>this.tag||(this.tag|0)!==this.tag)throw Error("Tag must be a positive integer: "+this.tag);};g.prototype.toString=function(){return this.tag+"("+JSON.stringify(this.value)+")"};g.prototype.encodeCBOR=
function(a){a._pushTag(this.tag);return a.pushAny(this.value)};g.prototype.convert=function(a){a=null!=a?a[this.tag]:void 0;if("function"!==typeof a&&(a=g["_tag_"+this.tag],"function"!==typeof a))return this;try{return a.call(g,this.value)}catch(k){return this.err=k,this}};g._tag_0=function(a){return new Date(a)};g._tag_1=function(a){return new Date(1E3*a)};g._tag_2=function(a){return b.bufferToBignumber(a)};g._tag_3=function(a){return e.minus(b.bufferToBignumber(a))};g._tag_4=function(a){return c.pow(a[0]).times(a[1])};
g._tag_5=function(a){return n.pow(a[0]).times(a[1])};g._tag_32=function(b){return a.parse(b)};g._tag_35=function(a){return new RegExp(a)};l.exports=g},{"./utils":30,"bignumber.js":21,url:155}],30:[function(f,l,h){(function(b,a){function e(a){if(null!=a)return console.log(a)}var c=f("fs"),n=f("stream"),g=f("bignumber.js"),p=f("./constants"),k=p.NUMBYTES,v=p.SHIFT32;h.parseCBORint=function(a,b){switch(a){case k.ONE:return b.readUInt8(0,!0);case k.TWO:return b.readUInt16BE(0,!0);case k.FOUR:return b.readUInt32BE(0,
!0);case k.EIGHT:var c=b.readUInt32BE(0);var d=b.readUInt32BE(4);return 2097151<c?(new g(c)).times(v).plus(d):c*v+d;default:throw Error("Invalid additional info for int: "+a);}};h.writeHalf=function(b,c){var d=new a(4);d.writeFloatBE(c);var g=d.readUInt32BE();if(0!==(g&8191))return!1;var d=g>>16&32768,e=g>>23&255,g=g&8388607;if(113<=e&&142>=e)d+=(e-112<<10)+(g>>13);else if(103<=e&&113>e){if(g&(1<<126-e)-1)return!1;d+=g+8388608>>126-e}else return!1;b.writeUInt16BE(d);return!0};h.parseHalf=function(a){var b=
a[0]&128?-1:1;var c=(a[0]&124)>>2;a=(a[0]&3)<<8|a[1];return c?31===c?b*(a?0/0:Infinity):b*Math.pow(2,c-25)*(1024+a):5.9604644775390625E-8*b*a};h.parseCBORfloat=function(a){switch(a.length){case 2:return h.parseHalf(a);case 4:return a.readFloatBE(0,!0);case 8:return a.readDoubleBE(0,!0);default:throw Error("Invalid float size: "+a.length);}};h.hex=function(b){return new a(b.replace(/^0x/,""),"hex")};h.bin=function(b){var c;b=b.replace(/\s/g,"");var d=0;var g=b.length%8||8;for(c=[];g<=b.length;)c.push(parseInt(b.slice(d,
g),2)),d=g,g+=8;return new a(c)};h.extend=function(){var a,b;var c=arguments[0];var g=2<=arguments.length?Array.prototype.slice.call(arguments,1):[];null==c&&(c={});var e=0;for(b=g.length;e<b;e++){var k=g[e];for(a in k){var f=k[a];c[a]=f}}return c};h.arrayEqual=function(a,b){return null==a&&null==b?!0:null==a||null==b?!1:a.length===b.length&&a.every(function(a,c){return a===b[c]})};h.bufferEqual=function(b,c){var d,g;if(null==b&&null==c)return!0;if(null==b||null==c||!a.isBuffer(b)||!a.isBuffer(c)||
b.length!==c.length)return!1;var e=!0;var k=d=0;for(g=b.length;d<g;k=++d){var f=b[k];e&=c[k]===f}return!!e};h.bufferToBignumber=function(a){return new g(a.toString("hex"),16)};p=function(b){var c=n.Readable.call(this)||this;(b=b.replace(/^0x/,""))&&c.push(new a(b,"hex"));c.push(null);return c};$jscomp.inherits(p,n.Readable);h.DeHexStream=p;p=function(a){return n.Transform.call(this,a)||this};$jscomp.inherits(p,n.Transform);p.prototype._transform=function(a,b,c){this.push(a.toString("hex"));return c()};
h.HexStream=p;h.streamFiles=function(a,g,k){null==k&&(k=e);var d=a.shift();if(!d)return k();var f=g();f.on("end",function(){return h.streamFiles(a,g,k)});f.on("error",k);d="-"===d?b.stdin:d instanceof n.Stream?d:c.createReadStream(d);d.on("error",k);return d.pipe(f)};h.guessEncoding=function(b){switch(!1){case "string"!==typeof b:return"hex";case !a.isBuffer(b):break;default:throw Error("Unknown input type");}}}).call(this,f("_process"),f("buffer").Buffer)},{"./constants":24,_process:137,"bignumber.js":21,
buffer:129,fs:127,stream:153}],31:[function(f,l,h){function b(b){a.call(this,b);this._writableState.objectMode=!1;this._readableState.objectMode=!0;this.bs=new e;this.__restart()}h=l.exports=b;var a=f("stream").Transform;l=f("util").inherits;var e=f("nofilter");h.One=-1;l(b,a);b.prototype._transform=function(a,b,g){for(this.bs.write(a);this.bs.length>=this.__needed;){a=null===this.__needed?void 0:this.bs.read(this.__needed);try{var c=this.__parser.next(a)}catch(k){return g(k)}this.__needed&&(this.__fresh=
!1);c.done?(this.push(c.value),this.__restart()):this.__needed=c.value|0}return g()};b.prototype.__restart=function(){this.__needed=null;this.__parser=this._parse();this.__fresh=!0};b.prototype._flush=function(a){a(this.__fresh?null:Error("unexpected end of input"))}},{nofilter:98,stream:153,util:160}],32:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){var a=
b.lib.BlockCipher,e=b.algo,c=[],f=[],g=[],p=[],k=[],h=[],d=[],t=[],B=[],l=[];(function(){for(var a=[],b=0;256>b;b++)a[b]=128>b?b<<1:b<<1^283;for(var e=0,n=0,b=0;256>b;b++){var v=n^n<<1^n<<2^n<<3^n<<4,v=v>>>8^v&255^99;c[e]=v;f[v]=e;var E=a[e],z=a[E],C=a[z],Q=257*a[v]^16843008*v;g[e]=Q<<24|Q>>>8;p[e]=Q<<16|Q>>>16;k[e]=Q<<8|Q>>>24;h[e]=Q;Q=16843009*C^65537*z^257*E^16843008*e;d[v]=Q<<24|Q>>>8;t[v]=Q<<16|Q>>>16;B[v]=Q<<8|Q>>>24;l[v]=Q;e?(e=E^a[a[a[C^E]]],n^=a[a[n]]):e=n=1}})();var C=[0,1,2,4,8,16,32,64,
128,27,54],e=e.AES=a.extend({_doReset:function(){var a;if(!this._nRounds||this._keyPriorReset!==this._key){var b=this._keyPriorReset=this._key;var g=b.words,e=b.sigBytes/4,k=4*((this._nRounds=e+6)+1),f=this._keySchedule=[];for(a=0;a<k;a++)a<e?f[a]=g[a]:(b=f[a-1],a%e?6<e&&4==a%e&&(b=c[b>>>24]<<24|c[b>>>16&255]<<16|c[b>>>8&255]<<8|c[b&255]):(b=b<<8|b>>>24,b=c[b>>>24]<<24|c[b>>>16&255]<<16|c[b>>>8&255]<<8|c[b&255],b^=C[a/e|0]<<24),f[a]=f[a-e]^b);g=this._invKeySchedule=[];for(e=0;e<k;e++)a=k-e,b=e%4?
f[a]:f[a-4],g[e]=4>e||4>=a?b:d[c[b>>>24]]^t[c[b>>>16&255]]^B[c[b>>>8&255]]^l[c[b&255]]}},encryptBlock:function(a,b){this._doCryptBlock(a,b,this._keySchedule,g,p,k,h,c)},decryptBlock:function(a,b){var c=a[b+1];a[b+1]=a[b+3];a[b+3]=c;this._doCryptBlock(a,b,this._invKeySchedule,d,t,B,l,f);c=a[b+1];a[b+1]=a[b+3];a[b+3]=c},_doCryptBlock:function(a,b,c,d,g,e,k,f){var p=this._nRounds,n=a[b]^c[0],q=a[b+1]^c[1],h=a[b+2]^c[2];var t=a[b+3]^c[3];for(var v=4,u=1;u<p;u++){var m=d[n>>>24]^g[q>>>16&255]^e[h>>>8&
255]^k[t&255]^c[v++];var r=d[q>>>24]^g[h>>>16&255]^e[t>>>8&255]^k[n&255]^c[v++];var w=d[h>>>24]^g[t>>>16&255]^e[n>>>8&255]^k[q&255]^c[v++];t=d[t>>>24]^g[n>>>16&255]^e[q>>>8&255]^k[h&255]^c[v++];n=m;q=r;h=w}m=(f[n>>>24]<<24|f[q>>>16&255]<<16|f[h>>>8&255]<<8|f[t&255])^c[v++];r=(f[q>>>24]<<24|f[h>>>16&255]<<16|f[t>>>8&255]<<8|f[n&255])^c[v++];w=(f[h>>>24]<<24|f[t>>>16&255]<<16|f[n>>>8&255]<<8|f[q&255])^c[v++];t=(f[t>>>24]<<24|f[n>>>16&255]<<16|f[q>>>8&255]<<8|f[h&255])^c[v++];a[b]=m;a[b+1]=r;a[b+2]=
w;a[b+3]=t},keySize:8});b.AES=a._createHelper(e)})();return b.AES})},{"./cipher-core":33,"./core":34,"./enc-base64":35,"./evpkdf":37,"./md5":42}],33:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){b.lib.Cipher||function(a){var e=b.lib,c=e.Base,f=e.WordArray,g=e.BufferedBlockAlgorithm,p=b.enc.Base64,k=b.algo.EvpKDF,h=e.Cipher=g.extend({cfg:c.extend(),createEncryptor:function(a,b){return this.create(this._ENC_XFORM_MODE,a,b)},createDecryptor:function(a,
b){return this.create(this._DEC_XFORM_MODE,a,b)},init:function(a,b,c){this.cfg=this.cfg.extend(c);this._xformMode=a;this._key=b;this.reset()},reset:function(){g.reset.call(this);this._doReset()},process:function(a){this._append(a);return this._process()},finalize:function(a){a&&this._append(a);return this._doFinalize()},keySize:4,ivSize:4,_ENC_XFORM_MODE:1,_DEC_XFORM_MODE:2,_createHelper:function(){return function(a){return{encrypt:function(b,c,d){return("string"==typeof c?y:C).encrypt(a,b,c,d)},
decrypt:function(b,c,d){return("string"==typeof c?y:C).decrypt(a,b,c,d)}}}}()});e.StreamCipher=h.extend({_doFinalize:function(){return this._process(!0)},blockSize:1});var d=b.mode={},t=e.BlockCipherMode=c.extend({createEncryptor:function(a,b){return this.Encryptor.create(a,b)},createDecryptor:function(a,b){return this.Decryptor.create(a,b)},init:function(a,b){this._cipher=a;this._iv=b}}),d=d.CBC=function(){function b(b,c,d){var g;(g=this._iv)?this._iv=a:g=this._prevBlock;for(var e=0;e<d;e++)b[c+
e]^=g[e]}var c=t.extend();c.Encryptor=c.extend({processBlock:function(a,c){var d=this._cipher,g=d.blockSize;b.call(this,a,c,g);d.encryptBlock(a,c);this._prevBlock=a.slice(c,c+g)}});c.Decryptor=c.extend({processBlock:function(a,c){var d=this._cipher,g=d.blockSize,e=a.slice(c,c+g);d.decryptBlock(a,c);b.call(this,a,c,g);this._prevBlock=e}});return c}(),B=(b.pad={}).Pkcs7={pad:function(a,b){for(var c=4*b,c=c-a.sigBytes%c,d=c<<24|c<<16|c<<8|c,g=[],e=0;e<c;e+=4)g.push(d);c=f.create(g,c);a.concat(c)},unpad:function(a){a.sigBytes-=
a.words[a.sigBytes-1>>>2]&255}};e.BlockCipher=h.extend({cfg:h.cfg.extend({mode:d,padding:B}),reset:function(){h.reset.call(this);var a=this.cfg;var b=a.iv,c=a.mode;this._xformMode==this._ENC_XFORM_MODE?a=c.createEncryptor:(a=c.createDecryptor,this._minBufferSize=1);this._mode=a.call(c,this,b&&b.words)},_doProcessBlock:function(a,b){this._mode.processBlock(a,b)},_doFinalize:function(){var a=this.cfg.padding;if(this._xformMode==this._ENC_XFORM_MODE){a.pad(this._data,this.blockSize);var b=this._process(!0)}else b=
this._process(!0),a.unpad(b);return b},blockSize:4});var l=e.CipherParams=c.extend({init:function(a){this.mixIn(a)},toString:function(a){return(a||this.formatter).stringify(this)}}),d=(b.format={}).OpenSSL={stringify:function(a){var b=a.ciphertext;a=a.salt;return(a?f.create([1398893684,1701076831]).concat(a).concat(b):b).toString(p)},parse:function(a){a=p.parse(a);var b=a.words;if(1398893684==b[0]&&1701076831==b[1]){var c=f.create(b.slice(2,4));b.splice(0,4);a.sigBytes-=16}return l.create({ciphertext:a,
salt:c})}},C=e.SerializableCipher=c.extend({cfg:c.extend({format:d}),encrypt:function(a,b,c,d){d=this.cfg.extend(d);var g=a.createEncryptor(c,d);b=g.finalize(b);g=g.cfg;return l.create({ciphertext:b,key:c,iv:g.iv,algorithm:a,mode:g.mode,padding:g.padding,blockSize:a.blockSize,formatter:d.format})},decrypt:function(a,b,c,d){d=this.cfg.extend(d);b=this._parse(b,d.format);return a.createDecryptor(c,d).finalize(b.ciphertext)},_parse:function(a,b){return"string"==typeof a?b.parse(a,this):a}}),c=(b.kdf=
{}).OpenSSL={execute:function(a,b,c,d){d||(d=f.random(8));a=k.create({keySize:b+c}).compute(a,d);c=f.create(a.words.slice(b),4*c);a.sigBytes=4*b;return l.create({key:a,iv:c,salt:d})}},y=e.PasswordBasedCipher=C.extend({cfg:C.cfg.extend({kdf:c}),encrypt:function(a,b,c,d){d=this.cfg.extend(d);c=d.kdf.execute(c,a.keySize,a.ivSize);d.iv=c.iv;a=C.encrypt.call(this,a,b,c.key,d);a.mixIn(c);return a},decrypt:function(a,b,c,d){d=this.cfg.extend(d);b=this._parse(b,d.format);c=d.kdf.execute(c,a.keySize,a.ivSize,
b.salt);d.iv=c.iv;return C.decrypt.call(this,a,b,c.key,d)}})}()})},{"./core":34}],34:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a():b.CryptoJS=a()})(this,function(){var b=b||function(a,b){var c=Object.create||function(){function a(){}return function(b){a.prototype=b;b=new a;a.prototype=null;return b}}(),e={},g=e.lib={},f=g.Base=function(){return{extend:function(a){var b=c(this);a&&b.mixIn(a);b.hasOwnProperty("init")&&this.init!==b.init||(b.init=function(){b.$super.init.apply(this,
arguments)});b.init.prototype=b;b.$super=this;return b},create:function(){var a=this.extend();a.init.apply(a,arguments);return a},init:function(){},mixIn:function(a){for(var b in a)a.hasOwnProperty(b)&&(this[b]=a[b]);a.hasOwnProperty("toString")&&(this.toString=a.toString)},clone:function(){return this.init.prototype.extend(this)}}}(),k=g.WordArray=f.extend({init:function(a,c){a=this.words=a||[];this.sigBytes=c!=b?c:4*a.length},toString:function(a){return(a||d).stringify(this)},concat:function(a){var b=
this.words,c=a.words,d=this.sigBytes;a=a.sigBytes;this.clamp();if(d%4)for(var g=0;g<a;g++)b[d+g>>>2]|=(c[g>>>2]>>>24-g%4*8&255)<<24-(d+g)%4*8;else for(g=0;g<a;g+=4)b[d+g>>>2]=c[g>>>2];this.sigBytes+=a;return this},clamp:function(){var b=this.words,c=this.sigBytes;b[c>>>2]&=4294967295<<32-c%4*8;b.length=a.ceil(c/4)},clone:function(){var a=f.clone.call(this);a.words=this.words.slice(0);return a},random:function(b){for(var c=[],d=function(b){var c=987654321;return function(){c=36969*(c&65535)+(c>>16)&
4294967295;b=18E3*(b&65535)+(b>>16)&4294967295;return(((c<<16)+b&4294967295)/4294967296+.5)*(.5<a.random()?1:-1)}},g=0,e;g<b;g+=4){var f=d(4294967296*(e||a.random()));e=987654071*f();c.push(4294967296*f()|0)}return new k.init(c,b)}}),h=e.enc={},d=h.Hex={stringify:function(a){var b=a.words;a=a.sigBytes;for(var c=[],d=0;d<a;d++){var g=b[d>>>2]>>>24-d%4*8&255;c.push((g>>>4).toString(16));c.push((g&15).toString(16))}return c.join("")},parse:function(a){for(var b=a.length,c=[],d=0;d<b;d+=2)c[d>>>3]|=parseInt(a.substr(d,
2),16)<<24-d%8*4;return new k.init(c,b/2)}},t=h.Latin1={stringify:function(a){var b=a.words;a=a.sigBytes;for(var c=[],d=0;d<a;d++)c.push(String.fromCharCode(b[d>>>2]>>>24-d%4*8&255));return c.join("")},parse:function(a){for(var b=a.length,c=[],d=0;d<b;d++)c[d>>>2]|=(a.charCodeAt(d)&255)<<24-d%4*8;return new k.init(c,b)}},B=h.Utf8={stringify:function(a){try{return decodeURIComponent(escape(t.stringify(a)))}catch(K){throw Error("Malformed UTF-8 data");}},parse:function(a){return t.parse(unescape(encodeURIComponent(a)))}},
l=g.BufferedBlockAlgorithm=f.extend({reset:function(){this._data=new k.init;this._nDataBytes=0},_append:function(a){"string"==typeof a&&(a=B.parse(a));this._data.concat(a);this._nDataBytes+=a.sigBytes},_process:function(b){var c,d=this._data,g=d.words,e=d.sigBytes,f=this.blockSize,p=e/(4*f),p=b?a.ceil(p):a.max((p|0)-this._minBufferSize,0);b=p*f;e=a.min(4*b,e);if(b){for(c=0;c<b;c+=f)this._doProcessBlock(g,c);c=g.splice(0,b);d.sigBytes-=e}return new k.init(c,e)},clone:function(){var a=f.clone.call(this);
a._data=this._data.clone();return a},_minBufferSize:0});g.Hasher=l.extend({cfg:f.extend(),init:function(a){this.cfg=this.cfg.extend(a);this.reset()},reset:function(){l.reset.call(this);this._doReset()},update:function(a){this._append(a);this._process();return this},finalize:function(a){a&&this._append(a);return this._doFinalize()},blockSize:16,_createHelper:function(a){return function(b,c){return(new a.init(c)).finalize(b)}},_createHmacHelper:function(a){return function(b,c){return(new C.HMAC.init(a,
c)).finalize(b)}}});var C=e.algo={};return e}(Math);return b})},{}],35:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib.WordArray;b.enc.Base64={stringify:function(a){var b=a.words,e=a.sigBytes,g=this._map;a.clamp();a=[];for(var f=0;f<e;f+=3)for(var k=(b[f>>>2]>>>24-f%4*8&255)<<16|(b[f+1>>>2]>>>24-(f+1)%4*8&255)<<8|b[f+2>>>2]>>>24-(f+2)%4*8&255,h=0;4>h&&f+.75*h<e;h++)a.push(g.charAt(k>>>6*(3-h)&63));if(b=g.charAt(64))for(;a.length%
4;)a.push(b);return a.join("")},parse:function(b){var c=b.length,e=this._map,g=this._reverseMap;if(!g)for(var g=this._reverseMap=[],f=0;f<e.length;f++)g[e.charCodeAt(f)]=f;if(e=e.charAt(64))e=b.indexOf(e),-1!==e&&(c=e);for(var e=[],k=f=0;k<c;k++)if(k%4){var h=g[b.charCodeAt(k-1)]<<k%4*2,d=g[b.charCodeAt(k)]>>>6-k%4*2;e[f>>>2]|=(h|d)<<24-f%4*8;f++}return a.create(e,f)},_map:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="}})();return b.enc.Base64})},{"./core":34}],36:[function(f,
l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){function a(a){return a<<8&4278255360|a>>>8&16711935}var e=b.lib.WordArray,c=b.enc;c.Utf16=c.Utf16BE={stringify:function(a){var b=a.words;a=a.sigBytes;for(var c=[],e=0;e<a;e+=2)c.push(String.fromCharCode(b[e>>>2]>>>16-e%4*8&65535));return c.join("")},parse:function(a){for(var b=a.length,c=[],k=0;k<b;k++)c[k>>>1]|=a.charCodeAt(k)<<16-k%2*16;return e.create(c,2*b)}};c.Utf16LE={stringify:function(b){var c=
b.words;b=b.sigBytes;for(var e=[],k=0;k<b;k+=2){var f=a(c[k>>>2]>>>16-k%4*8&65535);e.push(String.fromCharCode(f))}return e.join("")},parse:function(b){for(var c=b.length,f=[],k=0;k<c;k++)f[k>>>1]|=a(b.charCodeAt(k)<<16-k%2*16);return e.create(f,2*c)}}})();return b.enc.Utf16})},{"./core":34}],37:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./sha1"),f("./hmac")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib,e=a.Base,c=a.WordArray,a=b.algo,f=a.EvpKDF=
e.extend({cfg:e.extend({keySize:4,hasher:a.MD5,iterations:1}),init:function(a){this.cfg=this.cfg.extend(a)},compute:function(a,b){for(var g=this.cfg,e=g.hasher.create(),d=c.create(),f=d.words,p=g.keySize,g=g.iterations;f.length<p;){n&&e.update(n);var n=e.update(a).finalize(b);e.reset();for(var h=1;h<g;h++)n=e.finalize(n),e.reset();d.concat(n)}d.sigBytes=4*p;return d}});b.EvpKDF=function(a,b,c){return f.create(c).compute(a,b)}})();return b.EvpKDF})},{"./core":34,"./hmac":39,"./sha1":58}],38:[function(f,
l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(a){var e=b.lib.CipherParams,c=b.enc.Hex;b.format.Hex={stringify:function(a){return a.ciphertext.toString(c)},parse:function(a){a=c.parse(a);return e.create({ciphertext:a})}}})();return b.format.Hex})},{"./cipher-core":33,"./core":34}],39:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.enc.Utf8;
b.algo.HMAC=b.lib.Base.extend({init:function(b,c){b=this._hasher=new b.init;"string"==typeof c&&(c=a.parse(c));var e=b.blockSize,g=4*e;c.sigBytes>g&&(c=b.finalize(c));c.clamp();for(var f=this._oKey=c.clone(),k=this._iKey=c.clone(),h=f.words,d=k.words,t=0;t<e;t++)h[t]^=1549556828,d[t]^=909522486;f.sigBytes=k.sigBytes=g;this.reset()},reset:function(){var a=this._hasher;a.reset();a.update(this._iKey)},update:function(a){this._hasher.update(a);return this},finalize:function(a){var b=this._hasher;a=b.finalize(a);
b.reset();return b.finalize(this._oKey.clone().concat(a))}})})()})},{"./core":34}],40:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./x64-core"),f("./lib-typedarrays"),f("./enc-utf16"),f("./enc-base64"),f("./md5"),f("./sha1"),f("./sha256"),f("./sha224"),f("./sha512"),f("./sha384"),f("./sha3"),f("./ripemd160"),f("./hmac"),f("./pbkdf2"),f("./evpkdf"),f("./cipher-core"),f("./mode-cfb"),f("./mode-ctr"),f("./mode-ctr-gladman"),f("./mode-ofb"),f("./mode-ecb"),f("./pad-ansix923"),
f("./pad-iso10126"),f("./pad-iso97971"),f("./pad-zeropadding"),f("./pad-nopadding"),f("./format-hex"),f("./aes"),f("./tripledes"),f("./rc4"),f("./rabbit"),f("./rabbit-legacy")):b.CryptoJS=a(b.CryptoJS)})(this,function(b){return b})},{"./aes":32,"./cipher-core":33,"./core":34,"./enc-base64":35,"./enc-utf16":36,"./evpkdf":37,"./format-hex":38,"./hmac":39,"./lib-typedarrays":41,"./md5":42,"./mode-cfb":43,"./mode-ctr":45,"./mode-ctr-gladman":44,"./mode-ecb":46,"./mode-ofb":47,"./pad-ansix923":48,"./pad-iso10126":49,
"./pad-iso97971":50,"./pad-nopadding":51,"./pad-zeropadding":52,"./pbkdf2":53,"./rabbit":55,"./rabbit-legacy":54,"./rc4":56,"./ripemd160":57,"./sha1":58,"./sha224":59,"./sha256":60,"./sha3":61,"./sha384":62,"./sha512":63,"./tripledes":64,"./x64-core":65}],41:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){if("function"==typeof ArrayBuffer){var a=b.lib.WordArray,e=a.init;(a.init=function(a){a instanceof ArrayBuffer&&(a=new Uint8Array(a));
if(a instanceof Int8Array||"undefined"!==typeof Uint8ClampedArray&&a instanceof Uint8ClampedArray||a instanceof Int16Array||a instanceof Uint16Array||a instanceof Int32Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array)a=new Uint8Array(a.buffer,a.byteOffset,a.byteLength);if(a instanceof Uint8Array){for(var b=a.byteLength,c=[],f=0;f<b;f++)c[f>>>2]|=a[f]<<24-f%4*8;e.call(this,c,b)}else e.apply(this,arguments)}).prototype=a}})();return b.lib.WordArray})},{"./core":34}],
42:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(a){function e(a,b,c,d,g,e,k){a=a+(b&c|~b&d)+g+k;return(a<<e|a>>>32-e)+b}function c(a,b,c,d,g,e,k){a=a+(b&d|c&~d)+g+k;return(a<<e|a>>>32-e)+b}function f(a,b,c,d,g,e,k){a=a+(b^c^d)+g+k;return(a<<e|a>>>32-e)+b}function g(a,b,c,d,g,e,k){a=a+(c^(b|~d))+g+k;return(a<<e|a>>>32-e)+b}var p=b.lib,k=p.WordArray,h=p.Hasher,p=b.algo,d=[];(function(){for(var b=0;64>b;b++)d[b]=4294967296*
a.abs(a.sin(b+1))|0})();p=p.MD5=h.extend({_doReset:function(){this._hash=new k.init([1732584193,4023233417,2562383102,271733878])},_doProcessBlock:function(a,b){for(var k=0;16>k;k++){var p=b+k,n=a[p];a[p]=(n<<8|n>>>24)&16711935|(n<<24|n>>>8)&4278255360}var k=this._hash.words,p=a[b+0],n=a[b+1],h=a[b+2],t=a[b+3],v=a[b+4],B=a[b+5],l=a[b+6],G=a[b+7],J=a[b+8],Q=a[b+9],F=a[b+10],M=a[b+11],N=a[b+12],I=a[b+13],D=a[b+14],u=a[b+15],m=k[0],r=k[1],w=k[2],A=k[3],m=e(m,r,w,A,p,7,d[0]),A=e(A,m,r,w,n,12,d[1]),w=
e(w,A,m,r,h,17,d[2]),r=e(r,w,A,m,t,22,d[3]),m=e(m,r,w,A,v,7,d[4]),A=e(A,m,r,w,B,12,d[5]),w=e(w,A,m,r,l,17,d[6]),r=e(r,w,A,m,G,22,d[7]),m=e(m,r,w,A,J,7,d[8]),A=e(A,m,r,w,Q,12,d[9]),w=e(w,A,m,r,F,17,d[10]),r=e(r,w,A,m,M,22,d[11]),m=e(m,r,w,A,N,7,d[12]),A=e(A,m,r,w,I,12,d[13]),w=e(w,A,m,r,D,17,d[14]),r=e(r,w,A,m,u,22,d[15]),m=c(m,r,w,A,n,5,d[16]),A=c(A,m,r,w,l,9,d[17]),w=c(w,A,m,r,M,14,d[18]),r=c(r,w,A,m,p,20,d[19]),m=c(m,r,w,A,B,5,d[20]),A=c(A,m,r,w,F,9,d[21]),w=c(w,A,m,r,u,14,d[22]),r=c(r,w,A,m,v,
20,d[23]),m=c(m,r,w,A,Q,5,d[24]),A=c(A,m,r,w,D,9,d[25]),w=c(w,A,m,r,t,14,d[26]),r=c(r,w,A,m,J,20,d[27]),m=c(m,r,w,A,I,5,d[28]),A=c(A,m,r,w,h,9,d[29]),w=c(w,A,m,r,G,14,d[30]),r=c(r,w,A,m,N,20,d[31]),m=f(m,r,w,A,B,4,d[32]),A=f(A,m,r,w,J,11,d[33]),w=f(w,A,m,r,M,16,d[34]),r=f(r,w,A,m,D,23,d[35]),m=f(m,r,w,A,n,4,d[36]),A=f(A,m,r,w,v,11,d[37]),w=f(w,A,m,r,G,16,d[38]),r=f(r,w,A,m,F,23,d[39]),m=f(m,r,w,A,I,4,d[40]),A=f(A,m,r,w,p,11,d[41]),w=f(w,A,m,r,t,16,d[42]),r=f(r,w,A,m,l,23,d[43]),m=f(m,r,w,A,Q,4,d[44]),
A=f(A,m,r,w,N,11,d[45]),w=f(w,A,m,r,u,16,d[46]),r=f(r,w,A,m,h,23,d[47]),m=g(m,r,w,A,p,6,d[48]),A=g(A,m,r,w,G,10,d[49]),w=g(w,A,m,r,D,15,d[50]),r=g(r,w,A,m,B,21,d[51]),m=g(m,r,w,A,N,6,d[52]),A=g(A,m,r,w,t,10,d[53]),w=g(w,A,m,r,F,15,d[54]),r=g(r,w,A,m,n,21,d[55]),m=g(m,r,w,A,J,6,d[56]),A=g(A,m,r,w,u,10,d[57]),w=g(w,A,m,r,l,15,d[58]),r=g(r,w,A,m,I,21,d[59]),m=g(m,r,w,A,v,6,d[60]),A=g(A,m,r,w,M,10,d[61]),w=g(w,A,m,r,h,15,d[62]),r=g(r,w,A,m,Q,21,d[63]);k[0]=k[0]+m|0;k[1]=k[1]+r|0;k[2]=k[2]+w|0;k[3]=k[3]+
A|0},_doFinalize:function(){var b=this._data,c=b.words,d=8*this._nDataBytes,g=8*b.sigBytes;c[g>>>5]|=128<<24-g%32;var e=a.floor(d/4294967296);c[(g+64>>>9<<4)+15]=(e<<8|e>>>24)&16711935|(e<<24|e>>>8)&4278255360;c[(g+64>>>9<<4)+14]=(d<<8|d>>>24)&16711935|(d<<24|d>>>8)&4278255360;b.sigBytes=4*(c.length+1);this._process();b=this._hash;c=b.words;for(d=0;4>d;d++)g=c[d],c[d]=(g<<8|g>>>24)&16711935|(g<<24|g>>>8)&4278255360;return b},clone:function(){var a=h.clone.call(this);a._hash=this._hash.clone();return a}});
b.MD5=h._createHelper(p);b.HmacMD5=h._createHmacHelper(p)})(Math);return b.MD5})},{"./core":34}],43:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.CFB=function(){function a(a,b,g,e){var c;(c=this._iv)?(c=c.slice(0),this._iv=void 0):c=this._prevBlock;e.encryptBlock(c,0);for(e=0;e<g;e++)a[b+e]^=c[e]}var e=b.lib.BlockCipherMode.extend();e.Encryptor=e.extend({processBlock:function(b,e){var c=this._cipher,f=c.blockSize;
a.call(this,b,e,f,c);this._prevBlock=b.slice(e,e+f)}});e.Decryptor=e.extend({processBlock:function(b,e){var c=this._cipher,f=c.blockSize,k=b.slice(e,e+f);a.call(this,b,e,f,c);this._prevBlock=k}});return e}();return b.mode.CFB})},{"./cipher-core":33,"./core":34}],44:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.CTRGladman=function(){function a(a){if(255===(a>>24&255)){var b=a>>16&255,c=a>>8&255;a&=255;255===
b?(b=0,255===c?(c=0,255===a?a=0:++a):++c):++b;a=0+(b<<16)+(c<<8)+a}else a+=16777216;return a}var e=b.lib.BlockCipherMode.extend(),c=e.Encryptor=e.extend({processBlock:function(b,c){var g=this._cipher,e=g.blockSize,f=this._iv,d=this._counter;f&&(d=this._counter=f.slice(0),this._iv=void 0);f=d;0===(f[0]=a(f[0]))&&(f[1]=a(f[1]));d=d.slice(0);g.encryptBlock(d,0);for(g=0;g<e;g++)b[c+g]^=d[g]}});e.Decryptor=c;return e}();return b.mode.CTRGladman})},{"./cipher-core":33,"./core":34}],45:[function(f,l,h){(function(b,
a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.CTR=function(){var a=b.lib.BlockCipherMode.extend(),e=a.Encryptor=a.extend({processBlock:function(a,b){var c=this._cipher,e=c.blockSize,k=this._iv,f=this._counter;k&&(f=this._counter=k.slice(0),this._iv=void 0);k=f.slice(0);c.encryptBlock(k,0);f[e-1]=f[e-1]+1|0;for(c=0;c<e;c++)a[b+c]^=k[c]}});a.Decryptor=e;return a}();return b.mode.CTR})},{"./cipher-core":33,"./core":34}],46:[function(f,
l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.mode.ECB=function(){var a=b.lib.BlockCipherMode.extend();a.Encryptor=a.extend({processBlock:function(a,b){this._cipher.encryptBlock(a,b)}});a.Decryptor=a.extend({processBlock:function(a,b){this._cipher.decryptBlock(a,b)}});return a}();return b.mode.ECB})},{"./cipher-core":33,"./core":34}],47:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):
a(b.CryptoJS)})(this,function(b){b.mode.OFB=function(){var a=b.lib.BlockCipherMode.extend(),e=a.Encryptor=a.extend({processBlock:function(a,b){var c=this._cipher,e=c.blockSize,k=this._iv,f=this._keystream;k&&(f=this._keystream=k.slice(0),this._iv=void 0);c.encryptBlock(f,0);for(c=0;c<e;c++)a[b+c]^=f[c]}});a.Decryptor=e;return a}();return b.mode.OFB})},{"./cipher-core":33,"./core":34}],48:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,
function(b){b.pad.AnsiX923={pad:function(a,b){var c=a.sigBytes,e=4*b,e=e-c%e,c=c+e-1;a.clamp();a.words[c>>>2]|=e<<24-c%4*8;a.sigBytes+=e},unpad:function(a){a.sigBytes-=a.words[a.sigBytes-1>>>2]&255}};return b.pad.Ansix923})},{"./cipher-core":33,"./core":34}],49:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.pad.Iso10126={pad:function(a,e){var c=4*e,c=c-a.sigBytes%c;a.concat(b.lib.WordArray.random(c-1)).concat(b.lib.WordArray.create([c<<
24],1))},unpad:function(a){a.sigBytes-=a.words[a.sigBytes-1>>>2]&255}};return b.pad.Iso10126})},{"./cipher-core":33,"./core":34}],50:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.pad.Iso97971={pad:function(a,e){a.concat(b.lib.WordArray.create([2147483648],1));b.pad.ZeroPadding.pad(a,e)},unpad:function(a){b.pad.ZeroPadding.unpad(a);a.sigBytes--}};return b.pad.Iso97971})},{"./cipher-core":33,"./core":34}],51:[function(f,
l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.pad.NoPadding={pad:function(){},unpad:function(){}};return b.pad.NoPadding})},{"./cipher-core":33,"./core":34}],52:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){b.pad.ZeroPadding={pad:function(a,b){var c=4*b;a.clamp();a.sigBytes+=c-(a.sigBytes%c||c)},unpad:function(a){for(var b=a.words,c=a.sigBytes-
1;!(b[c>>>2]>>>24-c%4*8&255);)c--;a.sigBytes=c+1}};return b.pad.ZeroPadding})},{"./cipher-core":33,"./core":34}],53:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./sha1"),f("./hmac")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib,e=a.Base,c=a.WordArray,a=b.algo,f=a.HMAC,g=a.PBKDF2=e.extend({cfg:e.extend({keySize:4,hasher:a.SHA1,iterations:1}),init:function(a){this.cfg=this.cfg.extend(a)},compute:function(a,b){for(var g=this.cfg,d=f.create(g.hasher,a),
e=c.create(),k=c.create([1]),p=e.words,n=k.words,h=g.keySize,g=g.iterations;p.length<h;){var l=d.update(b).finalize(k);d.reset();for(var q=l.words,L=q.length,x=l,E=1;E<g;E++){x=d.finalize(x);d.reset();for(var G=x.words,J=0;J<L;J++)q[J]^=G[J]}e.concat(l);n[0]++}e.sigBytes=4*h;return e}});b.PBKDF2=function(a,b,c){return g.create(c).compute(a,b)}})();return b.PBKDF2})},{"./core":34,"./hmac":39,"./sha1":58}],54:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./enc-base64"),
f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(){for(var a=this._X,b=this._C,c=0;8>c;c++)f[c]=b[c];b[0]=b[0]+1295307597+this._b|0;b[1]=b[1]+3545052371+(b[0]>>>0<f[0]>>>0?1:0)|0;b[2]=b[2]+886263092+(b[1]>>>0<f[1]>>>0?1:0)|0;b[3]=b[3]+1295307597+(b[2]>>>0<f[2]>>>0?1:0)|0;b[4]=b[4]+3545052371+(b[3]>>>0<f[3]>>>0?1:0)|0;b[5]=b[5]+886263092+(b[4]>>>0<f[4]>>>0?1:0)|0;b[6]=b[6]+1295307597+(b[5]>>>0<f[5]>>>0?1:0)|0;b[7]=b[7]+3545052371+(b[6]>>>0<f[6]>>>
0?1:0)|0;this._b=b[7]>>>0<f[7]>>>0?1:0;for(c=0;8>c;c++){var e=a[c]+b[c],p=e&65535,n=e>>>16;g[c]=((p*p>>>17)+p*n>>>15)+n*n^((e&4294901760)*e|0)+((e&65535)*e|0)}a[0]=g[0]+(g[7]<<16|g[7]>>>16)+(g[6]<<16|g[6]>>>16)|0;a[1]=g[1]+(g[0]<<8|g[0]>>>24)+g[7]|0;a[2]=g[2]+(g[1]<<16|g[1]>>>16)+(g[0]<<16|g[0]>>>16)|0;a[3]=g[3]+(g[2]<<8|g[2]>>>24)+g[1]|0;a[4]=g[4]+(g[3]<<16|g[3]>>>16)+(g[2]<<16|g[2]>>>16)|0;a[5]=g[5]+(g[4]<<8|g[4]>>>24)+g[3]|0;a[6]=g[6]+(g[5]<<16|g[5]>>>16)+(g[4]<<16|g[4]>>>16)|0;a[7]=g[7]+(g[6]<<
8|g[6]>>>24)+g[5]|0}var e=b.lib.StreamCipher,c=[],f=[],g=[],p=b.algo.RabbitLegacy=e.extend({_doReset:function(){for(var b=this._key.words,c=this.cfg.iv,d=this._X=[b[0],b[3]<<16|b[2]>>>16,b[1],b[0]<<16|b[3]>>>16,b[2],b[1]<<16|b[0]>>>16,b[3],b[2]<<16|b[1]>>>16],b=this._C=[b[2]<<16|b[2]>>>16,b[0]&4294901760|b[1]&65535,b[3]<<16|b[3]>>>16,b[1]&4294901760|b[2]&65535,b[0]<<16|b[0]>>>16,b[2]&4294901760|b[3]&65535,b[1]<<16|b[1]>>>16,b[3]&4294901760|b[0]&65535],g=this._b=0;4>g;g++)a.call(this);for(g=0;8>g;g++)b[g]^=
d[g+4&7];if(c){var d=c.words,c=d[0],d=d[1],c=(c<<8|c>>>24)&16711935|(c<<24|c>>>8)&4278255360,d=(d<<8|d>>>24)&16711935|(d<<24|d>>>8)&4278255360,g=c>>>16|d&4294901760,e=d<<16|c&65535;b[0]^=c;b[1]^=g;b[2]^=d;b[3]^=e;b[4]^=c;b[5]^=g;b[6]^=d;b[7]^=e;for(g=0;4>g;g++)a.call(this)}},_doProcessBlock:function(b,g){var d=this._X;a.call(this);c[0]=d[0]^d[5]>>>16^d[3]<<16;c[1]=d[2]^d[7]>>>16^d[5]<<16;c[2]=d[4]^d[1]>>>16^d[7]<<16;c[3]=d[6]^d[3]>>>16^d[1]<<16;for(d=0;4>d;d++)c[d]=(c[d]<<8|c[d]>>>24)&16711935|(c[d]<<
24|c[d]>>>8)&4278255360,b[g+d]^=c[d]},blockSize:4,ivSize:2});b.RabbitLegacy=e._createHelper(p)})();return b.RabbitLegacy})},{"./cipher-core":33,"./core":34,"./enc-base64":35,"./evpkdf":37,"./md5":42}],55:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(){for(var a=this._X,b=this._C,c=0;8>c;c++)f[c]=b[c];b[0]=b[0]+1295307597+this._b|0;b[1]=b[1]+3545052371+
(b[0]>>>0<f[0]>>>0?1:0)|0;b[2]=b[2]+886263092+(b[1]>>>0<f[1]>>>0?1:0)|0;b[3]=b[3]+1295307597+(b[2]>>>0<f[2]>>>0?1:0)|0;b[4]=b[4]+3545052371+(b[3]>>>0<f[3]>>>0?1:0)|0;b[5]=b[5]+886263092+(b[4]>>>0<f[4]>>>0?1:0)|0;b[6]=b[6]+1295307597+(b[5]>>>0<f[5]>>>0?1:0)|0;b[7]=b[7]+3545052371+(b[6]>>>0<f[6]>>>0?1:0)|0;this._b=b[7]>>>0<f[7]>>>0?1:0;for(c=0;8>c;c++){var e=a[c]+b[c],p=e&65535,n=e>>>16;g[c]=((p*p>>>17)+p*n>>>15)+n*n^((e&4294901760)*e|0)+((e&65535)*e|0)}a[0]=g[0]+(g[7]<<16|g[7]>>>16)+(g[6]<<16|g[6]>>>
16)|0;a[1]=g[1]+(g[0]<<8|g[0]>>>24)+g[7]|0;a[2]=g[2]+(g[1]<<16|g[1]>>>16)+(g[0]<<16|g[0]>>>16)|0;a[3]=g[3]+(g[2]<<8|g[2]>>>24)+g[1]|0;a[4]=g[4]+(g[3]<<16|g[3]>>>16)+(g[2]<<16|g[2]>>>16)|0;a[5]=g[5]+(g[4]<<8|g[4]>>>24)+g[3]|0;a[6]=g[6]+(g[5]<<16|g[5]>>>16)+(g[4]<<16|g[4]>>>16)|0;a[7]=g[7]+(g[6]<<8|g[6]>>>24)+g[5]|0}var e=b.lib.StreamCipher,c=[],f=[],g=[],p=b.algo.Rabbit=e.extend({_doReset:function(){for(var b=this._key.words,c=this.cfg.iv,d=0;4>d;d++)b[d]=(b[d]<<8|b[d]>>>24)&16711935|(b[d]<<24|b[d]>>>
8)&4278255360;for(var g=this._X=[b[0],b[3]<<16|b[2]>>>16,b[1],b[0]<<16|b[3]>>>16,b[2],b[1]<<16|b[0]>>>16,b[3],b[2]<<16|b[1]>>>16],b=this._C=[b[2]<<16|b[2]>>>16,b[0]&4294901760|b[1]&65535,b[3]<<16|b[3]>>>16,b[1]&4294901760|b[2]&65535,b[0]<<16|b[0]>>>16,b[2]&4294901760|b[3]&65535,b[1]<<16|b[1]>>>16,b[3]&4294901760|b[0]&65535],d=this._b=0;4>d;d++)a.call(this);for(d=0;8>d;d++)b[d]^=g[d+4&7];if(c){var d=c.words,c=d[0],d=d[1],c=(c<<8|c>>>24)&16711935|(c<<24|c>>>8)&4278255360,d=(d<<8|d>>>24)&16711935|(d<<
24|d>>>8)&4278255360,g=c>>>16|d&4294901760,e=d<<16|c&65535;b[0]^=c;b[1]^=g;b[2]^=d;b[3]^=e;b[4]^=c;b[5]^=g;b[6]^=d;b[7]^=e;for(d=0;4>d;d++)a.call(this)}},_doProcessBlock:function(b,g){var d=this._X;a.call(this);c[0]=d[0]^d[5]>>>16^d[3]<<16;c[1]=d[2]^d[7]>>>16^d[5]<<16;c[2]=d[4]^d[1]>>>16^d[7]<<16;c[3]=d[6]^d[3]>>>16^d[1]<<16;for(d=0;4>d;d++)c[d]=(c[d]<<8|c[d]>>>24)&16711935|(c[d]<<24|c[d]>>>8)&4278255360,b[g+d]^=c[d]},blockSize:4,ivSize:2});b.Rabbit=e._createHelper(p)})();return b.Rabbit})},{"./cipher-core":33,
"./core":34,"./enc-base64":35,"./evpkdf":37,"./md5":42}],56:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(){for(var a=this._S,b=this._i,c=this._j,e=0,d=0;4>d;d++){var b=(b+1)%256,c=(c+a[b])%256,f=a[b];a[b]=a[c];a[c]=f;e|=a[(a[b]+a[c])%256]<<24-8*d}this._i=b;this._j=c;return e}var e=b.lib.StreamCipher,c=b.algo,f=c.RC4=e.extend({_doReset:function(){for(var a=
this._key,b=a.words,a=a.sigBytes,c=this._S=[],e=0;256>e;e++)c[e]=e;for(var d=e=0;256>e;e++){var f=e%a,d=(d+c[e]+(b[f>>>2]>>>24-f%4*8&255))%256,f=c[e];c[e]=c[d];c[d]=f}this._i=this._j=0},_doProcessBlock:function(b,c){b[c]^=a.call(this)},keySize:8,ivSize:0});b.RC4=e._createHelper(f);c=c.RC4Drop=f.extend({cfg:f.cfg.extend({drop:192}),_doReset:function(){f._doReset.call(this);for(var b=this.cfg.drop;0<b;b--)a.call(this)}});b.RC4Drop=e._createHelper(c)})();return b.RC4})},{"./cipher-core":33,"./core":34,
"./enc-base64":35,"./evpkdf":37,"./md5":42}],57:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(a){function e(a,b){return a<<b|a>>>32-b}a=b.lib;var c=a.WordArray,f=a.Hasher;a=b.algo;var g=c.create([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,7,4,13,1,10,6,15,3,12,0,9,5,2,14,11,8,3,10,14,4,9,15,8,1,2,7,0,6,13,11,5,12,1,9,11,10,0,8,12,4,13,3,7,15,14,5,6,2,4,0,5,9,7,12,2,10,14,1,3,8,11,6,15,13]),p=c.create([5,14,7,0,9,2,11,4,13,6,15,
8,1,10,3,12,6,11,3,7,0,13,5,10,14,15,8,12,4,9,1,2,15,5,1,3,7,14,6,9,11,8,12,2,10,0,4,13,8,6,4,1,3,11,15,0,5,12,2,13,9,7,10,14,12,15,10,4,1,5,8,7,6,2,13,14,0,3,9,11]),k=c.create([11,14,15,12,5,8,7,9,11,13,14,15,6,7,9,8,7,6,8,13,11,9,7,15,7,12,15,9,11,7,13,12,11,13,6,7,14,9,13,15,14,8,13,6,5,12,7,5,11,12,14,15,14,15,9,8,9,14,5,6,8,6,5,12,9,15,5,11,6,8,13,12,5,12,13,14,11,8,5,6]),h=c.create([8,9,9,11,13,15,15,5,7,7,8,11,14,14,12,6,9,13,15,7,12,8,9,11,7,7,12,7,6,15,13,11,9,7,15,11,8,6,6,14,12,13,5,14,
13,13,7,5,15,5,8,11,14,14,6,14,6,9,12,9,12,5,15,8,8,5,12,9,12,5,14,6,8,13,6,5,15,13,11,11]),d=c.create([0,1518500249,1859775393,2400959708,2840853838]),t=c.create([1352829926,1548603684,1836072691,2053994217,0]);a=a.RIPEMD160=f.extend({_doReset:function(){this._hash=c.create([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(a,b){for(var c=0;16>c;c++){var f=b+c,n=a[f];a[f]=(n<<8|n>>>24)&16711935|(n<<24|n>>>8)&4278255360}var f=this._hash.words,n=d.words,q=t.words,v=
g.words,l=p.words,E=k.words,B=h.words,J,z,F,M,N;var I=J=f[0];var D=z=f[1];var u=F=f[2];var m=M=f[3];var r=N=f[4];for(var w,c=0;80>c;c+=1)w=J+a[b+v[c]]|0,w=16>c?w+((z^F^M)+n[0]):32>c?w+((z&F|~z&M)+n[1]):48>c?w+(((z|~F)^M)+n[2]):64>c?w+((z&M|F&~M)+n[3]):w+((z^(F|~M))+n[4]),w|=0,w=e(w,E[c]),w=w+N|0,J=N,N=M,M=e(F,10),F=z,z=w,w=I+a[b+l[c]]|0,w=16>c?w+((D^(u|~m))+q[0]):32>c?w+((D&m|u&~m)+q[1]):48>c?w+(((D|~u)^m)+q[2]):64>c?w+((D&u|~D&m)+q[3]):w+((D^u^m)+q[4]),w|=0,w=e(w,B[c]),w=w+r|0,I=r,r=m,m=e(u,10),
u=D,D=w;w=f[1]+F+m|0;f[1]=f[2]+M+r|0;f[2]=f[3]+N+I|0;f[3]=f[4]+J+D|0;f[4]=f[0]+z+u|0;f[0]=w},_doFinalize:function(){var a=this._data,b=a.words,c=8*this._nDataBytes,d=8*a.sigBytes;b[d>>>5]|=128<<24-d%32;b[(d+64>>>9<<4)+14]=(c<<8|c>>>24)&16711935|(c<<24|c>>>8)&4278255360;a.sigBytes=4*(b.length+1);this._process();a=this._hash;b=a.words;for(c=0;5>c;c++)d=b[c],b[c]=(d<<8|d>>>24)&16711935|(d<<24|d>>>8)&4278255360;return a},clone:function(){var a=f.clone.call(this);a._hash=this._hash.clone();return a}});
b.RIPEMD160=f._createHelper(a);b.HmacRIPEMD160=f._createHmacHelper(a)})(Math);return b.RIPEMD160})},{"./core":34}],58:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib,e=a.WordArray,c=a.Hasher,f=[],a=b.algo.SHA1=c.extend({_doReset:function(){this._hash=new e.init([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(a,b){for(var c=this._hash.words,g=c[0],d=c[1],e=c[2],p=c[3],h=c[4],n=
0;80>n;n++){if(16>n)f[n]=a[b+n]|0;else{var l=f[n-3]^f[n-8]^f[n-14]^f[n-16];f[n]=l<<1|l>>>31}l=(g<<5|g>>>27)+h+f[n];l=20>n?l+((d&e|~d&p)+1518500249):40>n?l+((d^e^p)+1859775393):60>n?l+((d&e|d&p|e&p)-1894007588):l+((d^e^p)-899497514);h=p;p=e;e=d<<30|d>>>2;d=g;g=l}c[0]=c[0]+g|0;c[1]=c[1]+d|0;c[2]=c[2]+e|0;c[3]=c[3]+p|0;c[4]=c[4]+h|0},_doFinalize:function(){var a=this._data,b=a.words,c=8*this._nDataBytes,e=8*a.sigBytes;b[e>>>5]|=128<<24-e%32;b[(e+64>>>9<<4)+14]=Math.floor(c/4294967296);b[(e+64>>>9<<4)+
15]=c;a.sigBytes=4*b.length;this._process();return this._hash},clone:function(){var a=c.clone.call(this);a._hash=this._hash.clone();return a}});b.SHA1=c._createHelper(a);b.HmacSHA1=c._createHmacHelper(a)})();return b.SHA1})},{"./core":34}],59:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./sha256")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.lib.WordArray,e=b.algo,c=e.SHA256,e=e.SHA224=c.extend({_doReset:function(){this._hash=new a.init([3238371032,914150663,
812702999,4144912697,4290775857,1750603025,1694076839,3204075428])},_doFinalize:function(){var a=c._doFinalize.call(this);a.sigBytes-=4;return a}});b.SHA224=c._createHelper(e);b.HmacSHA224=c._createHmacHelper(e)})();return b.SHA224})},{"./core":34,"./sha256":60}],60:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(a){var e=b.lib,c=e.WordArray,f=e.Hasher,e=b.algo,g=[],p=[];(function(){function b(b){for(var c=a.sqrt(b),d=2;d<=
c;d++)if(!(b%d))return!1;return!0}function c(a){return 4294967296*(a-(a|0))|0}for(var e=2,f=0;64>f;)b(e)&&(8>f&&(g[f]=c(a.pow(e,.5))),p[f]=c(a.pow(e,1/3)),f++),e++})();var k=[],e=e.SHA256=f.extend({_doReset:function(){this._hash=new c.init(g.slice(0))},_doProcessBlock:function(a,b){for(var c=this._hash.words,d=c[0],g=c[1],e=c[2],f=c[3],h=c[4],n=c[5],v=c[6],l=c[7],E=0;64>E;E++){if(16>E)k[E]=a[b+E]|0;else{var G=k[E-15],J=k[E-2];k[E]=((G<<25|G>>>7)^(G<<14|G>>>18)^G>>>3)+k[E-7]+((J<<15|J>>>17)^(J<<13|
J>>>19)^J>>>10)+k[E-16]}G=l+((h<<26|h>>>6)^(h<<21|h>>>11)^(h<<7|h>>>25))+(h&n^~h&v)+p[E]+k[E];J=((d<<30|d>>>2)^(d<<19|d>>>13)^(d<<10|d>>>22))+(d&g^d&e^g&e);l=v;v=n;n=h;h=f+G|0;f=e;e=g;g=d;d=G+J|0}c[0]=c[0]+d|0;c[1]=c[1]+g|0;c[2]=c[2]+e|0;c[3]=c[3]+f|0;c[4]=c[4]+h|0;c[5]=c[5]+n|0;c[6]=c[6]+v|0;c[7]=c[7]+l|0},_doFinalize:function(){var b=this._data,c=b.words,g=8*this._nDataBytes,e=8*b.sigBytes;c[e>>>5]|=128<<24-e%32;c[(e+64>>>9<<4)+14]=a.floor(g/4294967296);c[(e+64>>>9<<4)+15]=g;b.sigBytes=4*c.length;
this._process();return this._hash},clone:function(){var a=f.clone.call(this);a._hash=this._hash.clone();return a}});b.SHA256=f._createHelper(e);b.HmacSHA256=f._createHmacHelper(e)})(Math);return b.SHA256})},{"./core":34}],61:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./x64-core")):a(b.CryptoJS)})(this,function(b){(function(a){var e=b.lib,c=e.WordArray,f=e.Hasher,g=b.x64.Word,e=b.algo,p=[],k=[],h=[];(function(){for(var a=1,b=0,c=0;24>c;c++){p[a+5*b]=(c+1)*(c+
2)/2%64;var d=(2*a+3*b)%5,a=b%5,b=d}for(a=0;5>a;a++)for(b=0;5>b;b++)k[a+5*b]=b+(2*a+3*b)%5*5;a=1;for(b=0;24>b;b++){for(var e=d=c=0;7>e;e++){if(a&1){var f=(1<<e)-1;32>f?d^=1<<f:c^=1<<f-32}a=a&128?a<<1^113:a<<1}h[b]=g.create(c,d)}})();var d=[];(function(){for(var a=0;25>a;a++)d[a]=g.create()})();e=e.SHA3=f.extend({cfg:f.cfg.extend({outputLength:512}),_doReset:function(){for(var a=this._state=[],b=0;25>b;b++)a[b]=new g.init;this.blockSize=(1600-2*this.cfg.outputLength)/32},_doProcessBlock:function(a,
b){var c,g,e,f=this._state,n=this.blockSize/2;for(c=0;c<n;c++){var t=a[b+2*c];var v=a[b+2*c+1];t=(t<<8|t>>>24)&16711935|(t<<24|t>>>8)&4278255360;v=(v<<8|v>>>24)&16711935|(v<<24|v>>>8)&4278255360;var l=f[c];l.high^=v;l.low^=t}for(n=0;24>n;n++){for(t=0;5>t;t++){for(g=e=c=0;5>g;g++)l=f[t+5*g],c^=l.high,e^=l.low;l=d[t];l.high=c;l.low=e}for(t=0;5>t;t++)for(v=d[(t+4)%5],c=d[(t+1)%5],l=c.high,g=c.low,c=v.high^(l<<1|g>>>31),e=v.low^(g<<1|l>>>31),g=0;5>g;g++)l=f[t+5*g],l.high^=c,l.low^=e;for(v=1;25>v;v++)l=
f[v],t=l.high,g=l.low,l=p[v],32>l?(c=t<<l|g>>>32-l,e=g<<l|t>>>32-l):(c=g<<l-32|t>>>64-l,e=t<<l-32|g>>>64-l),l=d[k[v]],l.high=c,l.low=e;l=d[0];c=f[0];l.high=c.high;l.low=c.low;for(t=0;5>t;t++)for(g=0;5>g;g++)v=t+5*g,l=f[v],c=d[v],v=d[(t+1)%5+5*g],e=d[(t+2)%5+5*g],l.high=c.high^~v.high&e.high,l.low=c.low^~v.low&e.low;l=f[0];c=h[n];l.high^=c.high;l.low^=c.low}},_doFinalize:function(){var b=this._data,d=b.words,g=8*b.sigBytes,e=32*this.blockSize;d[g>>>5]|=1<<24-g%32;d[(a.ceil((g+1)/e)*e>>>5)-1]|=128;
b.sigBytes=4*d.length;this._process();for(var b=this._state,d=this.cfg.outputLength/8,g=d/8,e=[],f=0;f<g;f++){var k=b[f],p=k.high,k=k.low,p=(p<<8|p>>>24)&16711935|(p<<24|p>>>8)&4278255360,k=(k<<8|k>>>24)&16711935|(k<<24|k>>>8)&4278255360;e.push(k);e.push(p)}return new c.init(e,d)},clone:function(){for(var a=f.clone.call(this),b=a._state=this._state.slice(0),c=0;25>c;c++)b[c]=b[c].clone();return a}});b.SHA3=f._createHelper(e);b.HmacSHA3=f._createHmacHelper(e)})(Math);return b.SHA3})},{"./core":34,
"./x64-core":65}],62:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./x64-core"),f("./sha512")):a(b.CryptoJS)})(this,function(b){(function(){var a=b.x64,e=a.Word,c=a.WordArray,a=b.algo,f=a.SHA512,a=a.SHA384=f.extend({_doReset:function(){this._hash=new c.init([new e.init(3418070365,3238371032),new e.init(1654270250,914150663),new e.init(2438529370,812702999),new e.init(355462360,4144912697),new e.init(1731405415,4290775857),new e.init(2394180231,1750603025),new e.init(3675008525,
1694076839),new e.init(1203062813,3204075428)])},_doFinalize:function(){var a=f._doFinalize.call(this);a.sigBytes-=16;return a}});b.SHA384=f._createHelper(a);b.HmacSHA384=f._createHmacHelper(a)})();return b.SHA384})},{"./core":34,"./sha512":63,"./x64-core":65}],63:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./x64-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(){return f.create.apply(f,arguments)}var e=b.lib.Hasher,c=b.x64,f=c.Word,g=c.WordArray,
c=b.algo,p=[a(1116352408,3609767458),a(1899447441,602891725),a(3049323471,3964484399),a(3921009573,2173295548),a(961987163,4081628472),a(1508970993,3053834265),a(2453635748,2937671579),a(2870763221,3664609560),a(3624381080,2734883394),a(310598401,1164996542),a(607225278,1323610764),a(1426881987,3590304994),a(1925078388,4068182383),a(2162078206,991336113),a(2614888103,633803317),a(3248222580,3479774868),a(3835390401,2666613458),a(4022224774,944711139),a(264347078,2341262773),a(604807628,2007800933),
a(770255983,1495990901),a(1249150122,1856431235),a(1555081692,3175218132),a(1996064986,2198950837),a(2554220882,3999719339),a(2821834349,766784016),a(2952996808,2566594879),a(3210313671,3203337956),a(3336571891,1034457026),a(3584528711,2466948901),a(113926993,3758326383),a(338241895,168717936),a(666307205,1188179964),a(773529912,1546045734),a(1294757372,1522805485),a(1396182291,2643833823),a(1695183700,2343527390),a(1986661051,1014477480),a(2177026350,1206759142),a(2456956037,344077627),a(2730485921,
1290863460),a(2820302411,3158454273),a(3259730800,3505952657),a(3345764771,106217008),a(3516065817,3606008344),a(3600352804,1432725776),a(4094571909,1467031594),a(275423344,851169720),a(430227734,3100823752),a(506948616,1363258195),a(659060556,3750685593),a(883997877,3785050280),a(958139571,3318307427),a(1322822218,3812723403),a(1537002063,2003034995),a(1747873779,3602036899),a(1955562222,1575990012),a(2024104815,1125592928),a(2227730452,2716904306),a(2361852424,442776044),a(2428436474,593698344),
a(2756734187,3733110249),a(3204031479,2999351573),a(3329325298,3815920427),a(3391569614,3928383900),a(3515267271,566280711),a(3940187606,3454069534),a(4118630271,4000239992),a(116418474,1914138554),a(174292421,2731055270),a(289380356,3203993006),a(460393269,320620315),a(685471733,587496836),a(852142971,1086792851),a(1017036298,365543100),a(1126000580,2618297676),a(1288033470,3409855158),a(1501505948,4234509866),a(1607167915,987167468),a(1816402316,1246189591)],k=[];(function(){for(var b=0;80>b;b++)k[b]=
a()})();c=c.SHA512=e.extend({_doReset:function(){this._hash=new g.init([new f.init(1779033703,4089235720),new f.init(3144134277,2227873595),new f.init(1013904242,4271175723),new f.init(2773480762,1595750129),new f.init(1359893119,2917565137),new f.init(2600822924,725511199),new f.init(528734635,4215389547),new f.init(1541459225,327033209)])},_doProcessBlock:function(a,b){for(var c,d,g,e,f,h,n,l,v,E=this._hash.words,G=E[0],J=E[1],Q=E[2],F=E[3],M=E[4],N=E[5],I=E[6],E=E[7],D=G.high,u=G.low,m=J.high,
r=J.low,w=Q.high,A=Q.low,V=F.high,S=F.low,R=M.high,T=M.low,ea=N.high,fa=N.low,ca=I.high,Z=I.low,U=E.high,ba=E.low,Y=D,aa=u,W=m,ha=r,ja=w,P=A,ga=V,O=S,X=R,da=T,na=ea,ka=fa,oa=ca,la=Z,pa=U,ma=ba,ia=0;80>ia;ia++){v=k[ia];16>ia?(d=v.high=a[b+2*ia]|0,e=v.low=a[b+2*ia+1]|0):(d=k[ia-15],e=d.high,c=d.low,d=(e>>>1|c<<31)^(e>>>8|c<<24)^e>>>7,l=(c>>>1|e<<31)^(c>>>8|e<<24)^(c>>>7|e<<25),c=k[ia-2],e=c.high,f=c.low,c=(e>>>19|f<<13)^(e<<3|f>>>29)^e>>>6,f=(f>>>19|e<<13)^(f<<3|e>>>29)^(f>>>6|e<<26),e=k[ia-7],n=e.high,
e=e.low,g=k[ia-16],h=g.high,g=g.low,e=l+e,d=d+n+(e>>>0<l>>>0?1:0),e+=f,d=d+c+(e>>>0<f>>>0?1:0),e+=g,d=d+h+(e>>>0<g>>>0?1:0),v.high=d,v.low=e);n=X&na^~X&oa;g=da&ka^~da&la;v=Y&W^Y&ja^W&ja;var ra=aa&ha^aa&P^ha&P;c=(Y>>>28|aa<<4)^(Y<<30|aa>>>2)^(Y<<25|aa>>>7);l=(aa>>>28|Y<<4)^(aa<<30|Y>>>2)^(aa<<25|Y>>>7);f=p[ia];var sa=f.high,qa=f.low;f=ma+((da>>>14|X<<18)^(da>>>18|X<<14)^(da<<23|X>>>9));h=pa+((X>>>14|da<<18)^(X>>>18|da<<14)^(X<<23|da>>>9))+(f>>>0<ma>>>0?1:0);f+=g;h=h+n+(f>>>0<g>>>0?1:0);f+=qa;h=h+sa+
(f>>>0<qa>>>0?1:0);f+=e;h=h+d+(f>>>0<e>>>0?1:0);e=l+ra;v=c+v+(e>>>0<l>>>0?1:0);pa=oa;ma=la;oa=na;la=ka;na=X;ka=da;da=O+f|0;X=ga+h+(da>>>0<O>>>0?1:0)|0;ga=ja;O=P;ja=W;P=ha;W=Y;ha=aa;aa=f+e|0;Y=h+v+(aa>>>0<f>>>0?1:0)|0}u=G.low=u+aa;G.high=D+Y+(u>>>0<aa>>>0?1:0);r=J.low=r+ha;J.high=m+W+(r>>>0<ha>>>0?1:0);A=Q.low=A+P;Q.high=w+ja+(A>>>0<P>>>0?1:0);S=F.low=S+O;F.high=V+ga+(S>>>0<O>>>0?1:0);T=M.low=T+da;M.high=R+X+(T>>>0<da>>>0?1:0);fa=N.low=fa+ka;N.high=ea+na+(fa>>>0<ka>>>0?1:0);Z=I.low=Z+la;I.high=ca+
oa+(Z>>>0<la>>>0?1:0);ba=E.low=ba+ma;E.high=U+pa+(ba>>>0<ma>>>0?1:0)},_doFinalize:function(){var a=this._data,b=a.words,c=8*this._nDataBytes,g=8*a.sigBytes;b[g>>>5]|=128<<24-g%32;b[(g+128>>>10<<5)+30]=Math.floor(c/4294967296);b[(g+128>>>10<<5)+31]=c;a.sigBytes=4*b.length;this._process();return this._hash.toX32()},clone:function(){var a=e.clone.call(this);a._hash=this._hash.clone();return a},blockSize:32});b.SHA512=e._createHelper(c);b.HmacSHA512=e._createHmacHelper(c)})();return b.SHA512})},{"./core":34,
"./x64-core":65}],64:[function(f,l,h){(function(b,a,e){"object"===typeof h?l.exports=h=a(f("./core"),f("./enc-base64"),f("./md5"),f("./evpkdf"),f("./cipher-core")):a(b.CryptoJS)})(this,function(b){(function(){function a(a,b){var c=(this._lBlock>>>a^this._rBlock)&b;this._rBlock^=c;this._lBlock^=c<<a}function e(a,b){var c=(this._rBlock>>>a^this._lBlock)&b;this._lBlock^=c;this._rBlock^=c<<a}var c=b.lib,f=c.WordArray,c=c.BlockCipher,g=b.algo,p=[57,49,41,33,25,17,9,1,58,50,42,34,26,18,10,2,59,51,43,35,
27,19,11,3,60,52,44,36,63,55,47,39,31,23,15,7,62,54,46,38,30,22,14,6,61,53,45,37,29,21,13,5,28,20,12,4],k=[14,17,11,24,1,5,3,28,15,6,21,10,23,19,12,4,26,8,16,7,27,20,13,2,41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,36,29,32],h=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28],d=[{0:8421888,268435456:32768,536870912:8421378,805306368:2,1073741824:512,1342177280:8421890,1610612736:8389122,1879048192:8388608,2147483648:514,2415919104:8389120,2684354560:33280,2952790016:8421376,3221225472:32770,
3489660928:8388610,3758096384:0,4026531840:33282,134217728:0,402653184:8421890,671088640:33282,939524096:32768,1207959552:8421888,1476395008:512,1744830464:8421378,2013265920:2,2281701376:8389120,2550136832:33280,2818572288:8421376,3087007744:8389122,3355443200:8388610,3623878656:32770,3892314112:514,4160749568:8388608,1:32768,268435457:2,536870913:8421888,805306369:8388608,1073741825:8421378,1342177281:33280,1610612737:512,1879048193:8389122,2147483649:8421890,2415919105:8421376,2684354561:8388610,
2952790017:33282,3221225473:514,3489660929:8389120,3758096385:32770,4026531841:0,134217729:8421890,402653185:8421376,671088641:8388608,939524097:512,1207959553:32768,1476395009:8388610,1744830465:2,2013265921:33282,2281701377:32770,2550136833:8389122,2818572289:514,3087007745:8421888,3355443201:8389120,3623878657:0,3892314113:33280,4160749569:8421378},{0:1074282512,16777216:16384,33554432:524288,50331648:1074266128,67108864:1073741840,83886080:1074282496,100663296:1073758208,117440512:16,134217728:540672,
150994944:1073758224,167772160:1073741824,184549376:540688,201326592:524304,218103808:0,234881024:16400,251658240:1074266112,8388608:1073758208,25165824:540688,41943040:16,58720256:1073758224,75497472:1074282512,92274688:1073741824,109051904:524288,125829120:1074266128,142606336:524304,159383552:0,176160768:16384,192937984:1074266112,209715200:1073741840,226492416:540672,243269632:1074282496,260046848:16400,268435456:0,285212672:1074266128,301989888:1073758224,318767104:1074282496,335544320:1074266112,
352321536:16,369098752:540688,385875968:16384,402653184:16400,419430400:524288,436207616:524304,452984832:1073741840,469762048:540672,486539264:1073758208,503316480:1073741824,520093696:1074282512,276824064:540688,293601280:524288,310378496:1074266112,327155712:16384,343932928:1073758208,360710144:1074282512,377487360:16,394264576:1073741824,411041792:1074282496,427819008:1073741840,444596224:1073758224,461373440:524304,478150656:0,494927872:16400,511705088:1074266128,528482304:540672},{0:260,1048576:0,
2097152:67109120,3145728:65796,4194304:65540,5242880:67108868,6291456:67174660,7340032:67174400,8388608:67108864,9437184:67174656,10485760:65792,11534336:67174404,12582912:67109124,13631488:65536,14680064:4,15728640:256,524288:67174656,1572864:67174404,2621440:0,3670016:67109120,4718592:67108868,5767168:65536,6815744:65540,7864320:260,8912896:4,9961472:256,11010048:67174400,12058624:65796,13107200:65792,14155776:67109124,15204352:67174660,16252928:67108864,16777216:67174656,17825792:65540,18874368:65536,
19922944:67109120,20971520:256,22020096:67174660,23068672:67108868,24117248:0,25165824:67109124,26214400:67108864,27262976:4,28311552:65792,29360128:67174400,30408704:260,31457280:65796,32505856:67174404,17301504:67108864,18350080:260,19398656:67174656,20447232:0,21495808:65540,22544384:67109120,23592960:256,24641536:67174404,25690112:65536,26738688:67174660,27787264:65796,28835840:67108868,29884416:67109124,30932992:67174400,31981568:4,33030144:65792},{0:2151682048,65536:2147487808,131072:4198464,
196608:2151677952,262144:0,327680:4198400,393216:2147483712,458752:4194368,524288:2147483648,589824:4194304,655360:64,720896:2147487744,786432:2151678016,851968:4160,917504:4096,983040:2151682112,32768:2147487808,98304:64,163840:2151678016,229376:2147487744,294912:4198400,360448:2151682112,425984:0,491520:2151677952,557056:4096,622592:2151682048,688128:4194304,753664:4160,819200:2147483648,884736:4194368,950272:4198464,1015808:2147483712,1048576:4194368,1114112:4198400,1179648:2147483712,1245184:0,
1310720:4160,1376256:2151678016,1441792:2151682048,1507328:2147487808,1572864:2151682112,1638400:2147483648,1703936:2151677952,1769472:4198464,1835008:2147487744,1900544:4194304,1966080:64,2031616:4096,1081344:2151677952,1146880:2151682112,1212416:0,1277952:4198400,1343488:4194368,1409024:2147483648,1474560:2147487808,1540096:64,1605632:2147483712,1671168:4096,1736704:2147487744,1802240:2151678016,1867776:4160,1933312:2151682048,1998848:4194304,2064384:4198464},{0:128,4096:17039360,8192:262144,12288:536870912,
16384:537133184,20480:16777344,24576:553648256,28672:262272,32768:16777216,36864:537133056,40960:536871040,45056:553910400,49152:553910272,53248:0,57344:17039488,61440:553648128,2048:17039488,6144:553648256,10240:128,14336:17039360,18432:262144,22528:537133184,26624:553910272,30720:536870912,34816:537133056,38912:0,43008:553910400,47104:16777344,51200:536871040,55296:553648128,59392:16777216,63488:262272,65536:262144,69632:128,73728:536870912,77824:553648256,81920:16777344,86016:553910272,90112:537133184,
94208:16777216,98304:553910400,102400:553648128,106496:17039360,110592:537133056,114688:262272,118784:536871040,122880:0,126976:17039488,67584:553648256,71680:16777216,75776:17039360,79872:537133184,83968:536870912,88064:17039488,92160:128,96256:553910272,100352:262272,104448:553910400,108544:0,112640:553648128,116736:16777344,120832:262144,124928:537133056,129024:536871040},{0:268435464,256:8192,512:270532608,768:270540808,1024:268443648,1280:2097152,1536:2097160,1792:268435456,2048:0,2304:268443656,
2560:2105344,2816:8,3072:270532616,3328:2105352,3584:8200,3840:270540800,128:270532608,384:270540808,640:8,896:2097152,1152:2105352,1408:268435464,1664:268443648,1920:8200,2176:2097160,2432:8192,2688:268443656,2944:270532616,3200:0,3456:270540800,3712:2105344,3968:268435456,4096:268443648,4352:270532616,4608:270540808,4864:8200,5120:2097152,5376:268435456,5632:268435464,5888:2105344,6144:2105352,6400:0,6656:8,6912:270532608,7168:8192,7424:268443656,7680:270540800,7936:2097160,4224:8,4480:2105344,
4736:2097152,4992:268435464,5248:268443648,5504:8200,5760:270540808,6016:270532608,6272:270540800,6528:270532616,6784:8192,7040:2105352,7296:2097160,7552:0,7808:268435456,8064:268443656},{0:1048576,16:33555457,32:1024,48:1049601,64:34604033,80:0,96:1,112:34603009,128:33555456,144:1048577,160:33554433,176:34604032,192:34603008,208:1025,224:1049600,240:33554432,8:34603009,24:0,40:33555457,56:34604032,72:1048576,88:33554433,104:33554432,120:1025,136:1049601,152:33555456,168:34603008,184:1048577,200:1024,
216:34604033,232:1,248:1049600,256:33554432,272:1048576,288:33555457,304:34603009,320:1048577,336:33555456,352:34604032,368:1049601,384:1025,400:34604033,416:1049600,432:1,448:0,464:34603008,480:33554433,496:1024,264:1049600,280:33555457,296:34603009,312:1,328:33554432,344:1048576,360:1025,376:34604032,392:33554433,408:34603008,424:0,440:34604033,456:1049601,472:1024,488:33555456,504:1048577},{0:134219808,1:131072,2:134217728,3:32,4:131104,5:134350880,6:134350848,7:2048,8:134348800,9:134219776,10:133120,
11:134348832,12:2080,13:0,14:134217760,15:133152,2147483648:2048,2147483649:134350880,2147483650:134219808,2147483651:134217728,2147483652:134348800,2147483653:133120,2147483654:133152,2147483655:32,2147483656:134217760,2147483657:2080,2147483658:131104,2147483659:134350848,2147483660:0,2147483661:134348832,2147483662:134219776,2147483663:131072,16:133152,17:134350848,18:32,19:2048,20:134219776,21:134217760,22:134348832,23:131072,24:0,25:131104,26:134348800,27:134219808,28:134350880,29:133120,30:2080,
31:134217728,2147483664:131072,2147483665:2048,2147483666:134348832,2147483667:133152,2147483668:32,2147483669:134348800,2147483670:134217728,2147483671:134219808,2147483672:134350880,2147483673:134217760,2147483674:134219776,2147483675:0,2147483676:133120,2147483677:2080,2147483678:131104,2147483679:134350848}],t=[4160749569,528482304,33030144,2064384,129024,8064,504,2147483679],l=g.DES=c.extend({_doReset:function(){for(var a=this._key.words,b=[],c=0;56>c;c++){var d=p[c]-1;b[c]=a[d>>>5]>>>31-d%32&
1}a=this._subKeys=[];for(d=0;16>d;d++){for(var g=a[d]=[],e=h[d],c=0;24>c;c++)g[c/6|0]|=b[(k[c]-1+e)%28]<<31-c%6,g[4+(c/6|0)]|=b[28+(k[c+24]-1+e)%28]<<31-c%6;g[0]=g[0]<<1|g[0]>>>31;for(c=1;7>c;c++)g[c]>>>=4*(c-1)+3;g[7]=g[7]<<5|g[7]>>>27}b=this._invSubKeys=[];for(c=0;16>c;c++)b[c]=a[15-c]},encryptBlock:function(a,b){this._doCryptBlock(a,b,this._subKeys)},decryptBlock:function(a,b){this._doCryptBlock(a,b,this._invSubKeys)},_doCryptBlock:function(b,c,g){this._lBlock=b[c];this._rBlock=b[c+1];a.call(this,
4,252645135);a.call(this,16,65535);e.call(this,2,858993459);e.call(this,8,16711935);a.call(this,1,1431655765);for(var f=0;16>f;f++){for(var k=g[f],p=this._lBlock,h=this._rBlock,n=0,l=0;8>l;l++)n|=d[l][((h^k[l])&t[l])>>>0];this._lBlock=h;this._rBlock=p^n}g=this._lBlock;this._lBlock=this._rBlock;this._rBlock=g;a.call(this,1,1431655765);e.call(this,8,16711935);e.call(this,2,858993459);a.call(this,16,65535);a.call(this,4,252645135);b[c]=this._lBlock;b[c+1]=this._rBlock},keySize:2,ivSize:2,blockSize:2});
b.DES=c._createHelper(l);g=g.TripleDES=c.extend({_doReset:function(){var a=this._key.words;this._des1=l.createEncryptor(f.create(a.slice(0,2)));this._des2=l.createEncryptor(f.create(a.slice(2,4)));this._des3=l.createEncryptor(f.create(a.slice(4,6)))},encryptBlock:function(a,b){this._des1.encryptBlock(a,b);this._des2.decryptBlock(a,b);this._des3.encryptBlock(a,b)},decryptBlock:function(a,b){this._des3.decryptBlock(a,b);this._des2.encryptBlock(a,b);this._des1.decryptBlock(a,b)},keySize:6,ivSize:2,blockSize:2});
b.TripleDES=c._createHelper(g)})();return b.TripleDES})},{"./cipher-core":33,"./core":34,"./enc-base64":35,"./evpkdf":37,"./md5":42}],65:[function(f,l,h){(function(b,a){"object"===typeof h?l.exports=h=a(f("./core")):a(b.CryptoJS)})(this,function(b){(function(a){var e=b.lib,c=e.Base,f=e.WordArray,e=b.x64={};e.Word=c.extend({init:function(a,b){this.high=a;this.low=b}});e.WordArray=c.extend({init:function(b,c){b=this.words=b||[];this.sigBytes=c!=a?c:8*b.length},toX32:function(){for(var a=this.words,
b=a.length,c=[],e=0;e<b;e++){var d=a[e];c.push(d.high);c.push(d.low)}return f.create(c,this.sigBytes)},clone:function(){for(var a=c.clone.call(this),b=a.words=this.words.slice(0),e=b.length,f=0;f<e;f++)b[f]=b[f].clone();return a}})})();return b})},{"./core":34}],66:[function(f,l,h){function b(){if(!(this instanceof b))return new b}(function(a){function b(a){for(var b in g)a[b]=g[b];return a}function c(a,b){function g(a){return a!==b&&a.originalListener!==b}var d;if(arguments.length)if(b){if(d=f(this,
a,!0)){d=d.filter(g);if(!d.length)return c.call(this,a);this.listeners[a]=d}}else{if(d=this.listeners)if(delete d[a],!Object.keys(d).length)return c.call(this)}else delete this.listeners;return this}function f(a,b,c){if(!c||a.listeners)return a=a.listeners||(a.listeners={}),a[b]||(a[b]=[])}"undefined"!==typeof l&&(l.exports=a);var g={on:function(a,b){f(this,a).push(b);return this},once:function(a,b){function g(){c.call(d,a,g);b.apply(this,arguments)}var d=this;g.originalListener=b;f(d,a).push(g);
return d},off:c,emit:function(a,b){function c(a){a.call(e)}function d(a){a.call(e,b)}function g(a){a.apply(e,h)}var e=this,k=f(e,a,!0);if(!k)return!1;var p=arguments.length;if(1===p)k.forEach(c);else if(2===p)k.forEach(d);else{var h=Array.prototype.slice.call(arguments,1);k.forEach(g)}return!!k.length}};b(a.prototype);a.mixin=b})(b)},{}],67:[function(f,l,h){h.read=function(b,a,e,c,f){var g=8*f-c-1;var p=(1<<g)-1,k=p>>1,h=-7;f=e?f-1:0;var d=e?-1:1,n=b[a+f];f+=d;e=n&(1<<-h)-1;n>>=-h;for(h+=g;0<h;e=
256*e+b[a+f],f+=d,h-=8);g=e&(1<<-h)-1;e>>=-h;for(h+=c;0<h;g=256*g+b[a+f],f+=d,h-=8);if(0===e)e=1-k;else{if(e===p)return g?NaN:Infinity*(n?-1:1);g+=Math.pow(2,c);e-=k}return(n?-1:1)*g*Math.pow(2,e-c)};h.write=function(b,a,e,c,f,g){var h,k=8*g-f-1,n=(1<<k)-1,d=n>>1,l=23===f?Math.pow(2,-24)-Math.pow(2,-77):0;g=c?0:g-1;var B=c?1:-1,z=0>a||0===a&&0>1/a?1:0;a=Math.abs(a);isNaN(a)||Infinity===a?(a=isNaN(a)?1:0,c=n):(c=Math.floor(Math.log(a)/Math.LN2),1>a*(h=Math.pow(2,-c))&&(c--,h*=2),a=1<=c+d?a+l/h:a+l*
Math.pow(2,1-d),2<=a*h&&(c++,h/=2),c+d>=n?(a=0,c=n):1<=c+d?(a=(a*h-1)*Math.pow(2,f),c+=d):(a=a*Math.pow(2,d-1)*Math.pow(2,f),c=0));for(;8<=f;b[e+g]=a&255,g+=B,a/=256,f-=8);c=c<<f|a;for(k+=f;0<k;b[e+g]=c&255,g+=B,c/=256,k-=8);b[e+g-B]|=128*z}},{}],68:[function(f,l,h){(function(b){!function(a){function e(b,e,p){function n(a,b,c,d){if(!(this instanceof n))return new n(a,b,c,d);y&&K&&(a instanceof K&&(a=new y(a)),c instanceof K&&(c=new y(c)));if(a||b||c||x){if(!h(a,b)){var e=x||Array;d=b;c=a;b=0;a=new e(8)}this.buffer=
a;this.offset=b|=0;if("undefined"!==typeof c)if("string"===typeof c){d=d||10;var e=0,g=c.length,m=0,f=0;"-"===c[0]&&e++;for(var u=e;e<g;){var r=parseInt(c[e++],d);if(!(0<=r))break;f=f*d+r;m=m*d+Math.floor(f/4294967296);f%=4294967296}u&&(m=~m,f?f=4294967296-f:m++);E(a,b+G,m);E(a,b+D,f)}else h(c,d)?k(a,b,c,d):"number"===typeof d?(E(a,b+G,c),E(a,b+D,d)):0<c?A(a,b,c):0>c?L(a,b,c):k(a,b,q,0)}else this.buffer=Array.prototype.slice.call(q,0,8)}function v(){var a=this.buffer,b=this.offset,c=J(a,b+G),a=J(a,
b+D);p||(c|=0);return c?4294967296*c+a:a}function E(a,b,c){a[b+w]=c&255;c>>=8;a[b+r]=c&255;c>>=8;a[b+m]=c&255;a[b+u]=c>>8&255}function J(a,b){return 16777216*a[b+u]+(a[b+m]<<16)+(a[b+r]<<8)+a[b+w]}var G=e?0:4,D=e?4:0,u=e?0:3,m=e?1:2,r=e?2:1,w=e?3:0,A=e?l:t,L=e?d:B;e=n.prototype;var z="is"+b,R="_"+z;e.buffer=void 0;e.offset=0;e[R]=!0;e.toNumber=v;e.toString=function(a){var b=this.buffer,c=this.offset,d=J(b,c+G),b=J(b,c+D),c="",e=!p&&d&2147483648;e&&(d=~d,b=4294967296-b);for(a=a||10;;){var g=d%a*4294967296+
b,d=Math.floor(d/a),b=Math.floor(g/a),c=(g%a).toString(a)+c;if(!d&&!b)break}e&&(c="-"+c);return c};e.toJSON=v;e.toArray=c;C&&(e.toBuffer=f);y&&(e.toArrayBuffer=g);n[z]=function(a){return!(!a||!a[R])};return a[b]=n}function c(a){var b=this.buffer,c=this.offset;x=null;return!1!==a&&0===c&&8===b.length&&L(b)?b:Array.prototype.slice.call(b,c,c+8)}function f(a){var c=this.buffer,d=this.offset;x=C;if(!1!==a&&0===d&&8===c.length&&b.isBuffer(c))return c;a=new C(8);k(a,0,c,d);return a}function g(a){var b=
this.buffer,c=this.offset,d=b.buffer;x=y;if(!1!==a&&0===c&&d instanceof K&&8===d.byteLength)return d;a=new y(8);k(a,0,b,c);return a.buffer}function h(a,b){var c=a&&a.length;b|=0;return c&&b+8<=c&&"string"!==typeof a[b]}function k(a,b,c,d){b|=0;d|=0;for(var e=0;8>e;e++)a[b++]=c[d++]&255}function l(a,b,c){for(var d=b+8;d>b;)a[--d]=c&255,c/=256}function d(a,b,c){var d=b+8;for(c++;d>b;)a[--d]=-c&255^255,c/=256}function t(a,b,c){for(var d=b+8;b<d;)a[b++]=c&255,c/=256}function B(a,b,c){var d=b+8;for(c++;b<
d;)a[b++]=-c&255^255,c/=256}function z(a){return!!a&&"[object Array]"==Object.prototype.toString.call(a)}var C="undefined"!==typeof b&&b,y="undefined"!==typeof Uint8Array&&Uint8Array,K="undefined"!==typeof ArrayBuffer&&ArrayBuffer,q=[0,0,0,0,0,0,0,0],L=Array.isArray||z,x;e("Uint64BE",!0,!0);e("Int64BE",!0,!1);e("Uint64LE",!1,!0);e("Int64LE",!1,!1)}("object"===typeof h&&"string"!==typeof h.nodeName?h:this||{})}).call(this,f("buffer").Buffer)},{buffer:129}],69:[function(f,l,h){var b={}.toString;l.exports=
Array.isArray||function(a){return"[object Array]"==b.call(a)}},{}],70:[function(f,l,h){h.encode=f("./encode").encode;h.decode=f("./decode").decode;h.Encoder=f("./encoder").Encoder;h.Decoder=f("./decoder").Decoder;h.createCodec=f("./ext").createCodec;h.codec=f("./codec").codec},{"./codec":79,"./decode":81,"./decoder":82,"./encode":84,"./encoder":85,"./ext":89}],71:[function(f,l,h){(function(b){function a(a){return a&&a.isBuffer&&a}l.exports=a("undefined"!==typeof b&&b)||a(this.Buffer)||a("undefined"!==
typeof window&&window.Buffer)||this.Buffer}).call(this,f("buffer").Buffer)},{buffer:129}],72:[function(f,l,h){h.copy=function(b,a,e,c){e||(e=0);c||0===c||(c=this.length);a||(a=0);var f=c-e;if(b===this&&e<a&&a<c)for(c=f-1;0<=c;c--)b[c+a]=this[c+e];else for(c=0;c<f;c++)b[c+a]=this[c+e];return f};h.toString=function(b,a,e){b=a|0;e||(e=this.length);a="";for(var c;b<e;)c=this[b++],128>c?a+=String.fromCharCode(c):(192===(c&224)?c=(c&31)<<6|this[b++]&63:224===(c&240)?c=(c&15)<<12|(this[b++]&63)<<6|this[b++]&
63:240===(c&248)&&(c=(c&7)<<18|(this[b++]&63)<<12|(this[b++]&63)<<6|this[b++]&63),65536<=c?(c-=65536,a+=String.fromCharCode((c>>>10)+55296,(c&1023)+56320)):a+=String.fromCharCode(c));return a};h.write=function(b,a){for(var e=a||(a|=0),c=b.length,f,g=0;g<c;)f=b.charCodeAt(g++),128>f?this[e++]=f:(2048>f?this[e++]=192|f>>>6:(55296>f||57343<f?this[e++]=224|f>>>12:(f=(f-55296<<10|b.charCodeAt(g++)-56320)+65536,this[e++]=240|f>>>18,this[e++]=128|f>>>12&63),this[e++]=128|f>>>6&63),this[e++]=128|f&63);return e-
a}},{}],73:[function(f,l,h){var b=f("./bufferish");h=l.exports=[];h.alloc=function(a){return Array(a)};h.concat=b.concat;h.from=function(a){if(!b.isBuffer(a)&&b.isView(a))a=b.Uint8Array.from(a);else if(b.isArrayBuffer(a))a=new Uint8Array(a);else{if("string"===typeof a)return b.from.call(h,a);if("number"===typeof a)throw new TypeError('"value" argument must not be a number');}return Array.prototype.slice.call(a)}},{"./bufferish":77}],74:[function(f,l,h){function b(a){return new e(a)}var a=f("./bufferish"),
e=a.global;h=l.exports=a.hasBuffer?b(0):[];h.alloc=a.hasBuffer&&e.alloc||b;h.concat=a.concat;h.from=function(b){if(!a.isBuffer(b)&&a.isView(b))b=a.Uint8Array.from(b);else if(a.isArrayBuffer(b))b=new Uint8Array(b);else{if("string"===typeof b)return a.from.call(h,b);if("number"===typeof b)throw new TypeError('"value" argument must not be a number');}return e.from&&1!==e.from.length?e.from(b):new e(b)}},{"./bufferish":77}],75:[function(f,l,h){function b(b,f,h,d){var k=c.isBuffer(this),p=c.isBuffer(b);
if(k&&p)return this.copy(b,f,h,d);if(g||k||p||!c.isView(this)||!c.isView(b))return e.copy.call(this,b,f,h,d);h=h||null!=d?a.call(this,h,d):this;b.set(h,f);return h.length}function a(a,e){var f=this.slice||!g&&this.subarray;if(f)return f.call(this,a,e);f=c.alloc.call(this,e-a);b.call(this,f,0,a,e);return f}var e=f("./buffer-lite");h.copy=b;h.slice=a;h.toString=function(a,b,g){return(!n&&c.isBuffer(this)?this.toString:e.toString).apply(this,arguments)};h.write=function(a){return function(){return(this[a]||
e[a]).apply(this,arguments)}}("write");var c=f("./bufferish");f=c.global;var n=c.hasBuffer&&"TYPED_ARRAY_SUPPORT"in f,g=n&&!f.TYPED_ARRAY_SUPPORT},{"./buffer-lite":72,"./bufferish":77}],76:[function(f,l,h){function b(a){return new Uint8Array(a)}var a=f("./bufferish");h=l.exports=a.hasArrayBuffer?b(0):[];h.alloc=b;h.concat=a.concat;h.from=function(b){if(a.isView(b)){var c=b.byteOffset,e=b.byteLength;b=b.buffer;b.byteLength!==e&&(b.slice?b=b.slice(c,c+e):(b=new Uint8Array(b),b.byteLength!==e&&(b=Array.prototype.slice.call(b,
c,c+e))))}else{if("string"===typeof b)return a.from.call(h,b);if("number"===typeof b)throw new TypeError('"value" argument must not be a number');}return new Uint8Array(b)}},{"./bufferish":77}],77:[function(f,l,h){function b(a){return e(this).alloc(a)}function a(a){return a instanceof ArrayBuffer||y(a)}function e(a){return v(a)?B:d(a)?z:k(a)?t:g?B:p?z:t}function c(){return!1}function n(a,b){a="[object "+a+"]";return function(c){return null!=c&&{}.toString.call(b?c[b]:c)===a}}l=h.global=f("./buffer-global");
var g=h.hasBuffer=l&&!!l.isBuffer,p=h.hasArrayBuffer="undefined"!==typeof ArrayBuffer,k=h.isArray=f("isarray");h.isArrayBuffer=p?a:c;var v=h.isBuffer=g?l.isBuffer:c,d=h.isView=p?ArrayBuffer.isView||n("ArrayBuffer","buffer"):c;h.alloc=b;h.concat=function(a,c){function d(a){c+=a.length}c||(c=0,Array.prototype.forEach.call(a,d));var e=b.call(this!==h&&this||a[0],c),g=0;Array.prototype.forEach.call(a,function(a){g+=C.copy.call(a,e,g)});return e};h.from=function(a){if("string"===typeof a){var c=3*a.length,
d=b.call(this,c);a=C.write.call(d,a);c!==a&&(d=C.slice.call(d,0,a));return d}return e(this).from(a)};var t=h.Array=f("./bufferish-array"),B=h.Buffer=f("./bufferish-buffer"),z=h.Uint8Array=f("./bufferish-uint8array"),C=h.prototype=f("./bufferish-proto"),y=n("ArrayBuffer")},{"./buffer-global":71,"./bufferish-array":73,"./bufferish-buffer":74,"./bufferish-proto":75,"./bufferish-uint8array":76,isarray:69}],78:[function(f,l,h){function b(a){if(!(this instanceof b))return new b(a);this.options=a;this.init()}
function a(a,b){function c(){a.apply(this,arguments);return b.apply(this,arguments)}return a&&b?c:a||b}function e(a){function b(a,b){return b(a)}a=a.slice();return function(c){return a.reduce(b,c)}}function c(a){return new b(a)}var n=f("isarray");h.createCodec=c;h.install=function(c){for(var e in c)b.prototype[e]=a(b.prototype[e],c[e])};h.filter=function(a){return n(a)?e(a):a};var g=f("./bufferish");b.prototype.init=function(){var a=this.options;a&&a.uint8array&&(this.bufferish=g.Uint8Array);return this};
h.preset=c({preset:!0})},{"./bufferish":77,isarray:69}],79:[function(f,l,h){f("./read-core");f("./write-core");h.codec={preset:f("./codec-base").preset}},{"./codec-base":78,"./read-core":91,"./write-core":94}],80:[function(f,l,h){function b(a){if(!(this instanceof b))return new b(a);a&&(this.options=a,a.codec&&(a=this.codec=a.codec,a.bufferish&&(this.bufferish=a.bufferish)))}h.DecodeBuffer=b;l=f("./read-core").preset;f("./flex-buffer").FlexDecoder.mixin(b.prototype);b.prototype.codec=l;b.prototype.fetch=
function(){return this.codec.decode(this)}},{"./flex-buffer":90,"./read-core":91}],81:[function(f,l,h){h.decode=function(a,e){var c=new b(e);c.write(a);return c.read()};var b=f("./decode-buffer").DecodeBuffer},{"./decode-buffer":80}],82:[function(f,l,h){function b(e){if(!(this instanceof b))return new b(e);a.call(this,e)}h.Decoder=b;l=f("event-lite");var a=f("./decode-buffer").DecodeBuffer;b.prototype=new a;l.mixin(b.prototype);b.prototype.decode=function(a){arguments.length&&this.write(a);this.flush()};
b.prototype.push=function(a){this.emit("data",a)};b.prototype.end=function(a){this.decode(a);this.emit("end")}},{"./decode-buffer":80,"event-lite":66}],83:[function(f,l,h){function b(a){if(!(this instanceof b))return new b(a);a&&(this.options=a,a.codec&&(a=this.codec=a.codec,a.bufferish&&(this.bufferish=a.bufferish)))}h.EncodeBuffer=b;l=f("./write-core").preset;f("./flex-buffer").FlexEncoder.mixin(b.prototype);b.prototype.codec=l;b.prototype.write=function(a){this.codec.encode(this,a)}},{"./flex-buffer":90,
"./write-core":94}],84:[function(f,l,h){h.encode=function(a,e){var c=new b(e);c.write(a);return c.read()};var b=f("./encode-buffer").EncodeBuffer},{"./encode-buffer":83}],85:[function(f,l,h){function b(e){if(!(this instanceof b))return new b(e);a.call(this,e)}h.Encoder=b;l=f("event-lite");var a=f("./encode-buffer").EncodeBuffer;b.prototype=new a;l.mixin(b.prototype);b.prototype.encode=function(a){this.write(a);this.emit("data",this.read())};b.prototype.end=function(a){arguments.length&&this.encode(a);
this.flush();this.emit("end")}},{"./encode-buffer":83,"event-lite":66}],86:[function(f,l,h){function b(e,c){if(!(this instanceof b))return new b(e,c);this.buffer=a.from(e);this.type=c}h.ExtBuffer=b;var a=f("./bufferish")},{"./bufferish":77}],87:[function(f,l,h){function b(a){k||(k=f("./encode").encode);return k(a)}function a(a){return a.valueOf()}function e(a){a=RegExp.prototype.toString.call(a).split("/");a.shift();var b=[a.pop()];b.unshift(a.join("/"));return b}function c(a){var b={},c;for(c in v)b[c]=
a[c];return b}h.setExtPackers=function(d){d.addExtPacker(14,Error,[c,b]);d.addExtPacker(1,EvalError,[c,b]);d.addExtPacker(2,RangeError,[c,b]);d.addExtPacker(3,ReferenceError,[c,b]);d.addExtPacker(4,SyntaxError,[c,b]);d.addExtPacker(5,TypeError,[c,b]);d.addExtPacker(6,URIError,[c,b]);d.addExtPacker(10,RegExp,[e,b]);d.addExtPacker(11,Boolean,[a,b]);d.addExtPacker(12,String,[a,b]);d.addExtPacker(13,Date,[Number,b]);d.addExtPacker(15,Number,[a,b]);"undefined"!==typeof Uint8Array&&(d.addExtPacker(17,Int8Array,
p),d.addExtPacker(18,Uint8Array,p),d.addExtPacker(19,Int16Array,p),d.addExtPacker(20,Uint16Array,p),d.addExtPacker(21,Int32Array,p),d.addExtPacker(22,Uint32Array,p),d.addExtPacker(23,Float32Array,p),"undefined"!==typeof Float64Array&&d.addExtPacker(24,Float64Array,p),"undefined"!==typeof Uint8ClampedArray&&d.addExtPacker(25,Uint8ClampedArray,p),d.addExtPacker(26,ArrayBuffer,p),d.addExtPacker(29,DataView,p));n.hasBuffer&&d.addExtPacker(27,g,n.from)};var n=f("./bufferish"),g=n.global,p=n.Uint8Array.from,
k,v={name:1,message:1,stack:1,columnNumber:1,fileName:1,lineNumber:1}},{"./bufferish":77,"./encode":84}],88:[function(f,l,h){function b(a){k||(k=f("./decode").decode);return k(a)}function a(a){return RegExp.apply(null,a)}function e(a){return function(b){var c=new a,d;for(d in v)c[d]=b[d];return c}}function c(a){return function(b){return new a(b)}}function n(a){return(new Uint8Array(a)).buffer}h.setExtUnpackers=function(d){d.addExtUnpacker(14,[b,e(Error)]);d.addExtUnpacker(1,[b,e(EvalError)]);d.addExtUnpacker(2,
[b,e(RangeError)]);d.addExtUnpacker(3,[b,e(ReferenceError)]);d.addExtUnpacker(4,[b,e(SyntaxError)]);d.addExtUnpacker(5,[b,e(TypeError)]);d.addExtUnpacker(6,[b,e(URIError)]);d.addExtUnpacker(10,[b,a]);d.addExtUnpacker(11,[b,c(Boolean)]);d.addExtUnpacker(12,[b,c(String)]);d.addExtUnpacker(13,[b,c(Date)]);d.addExtUnpacker(15,[b,c(Number)]);"undefined"!==typeof Uint8Array&&(d.addExtUnpacker(17,c(Int8Array)),d.addExtUnpacker(18,c(Uint8Array)),d.addExtUnpacker(19,[n,c(Int16Array)]),d.addExtUnpacker(20,
[n,c(Uint16Array)]),d.addExtUnpacker(21,[n,c(Int32Array)]),d.addExtUnpacker(22,[n,c(Uint32Array)]),d.addExtUnpacker(23,[n,c(Float32Array)]),"undefined"!==typeof Float64Array&&d.addExtUnpacker(24,[n,c(Float64Array)]),"undefined"!==typeof Uint8ClampedArray&&d.addExtUnpacker(25,c(Uint8ClampedArray)),d.addExtUnpacker(26,n),d.addExtUnpacker(29,[n,c(DataView)]));g.hasBuffer&&d.addExtUnpacker(27,c(p))};var g=f("./bufferish"),p=g.global,k,v={name:1,message:1,stack:1,columnNumber:1,fileName:1,lineNumber:1}},
{"./bufferish":77,"./decode":81}],89:[function(f,l,h){f("./read-core");f("./write-core");h.createCodec=f("./codec-base").createCodec},{"./codec-base":78,"./read-core":91,"./write-core":94}],90:[function(f,l,h){function b(){if(!(this instanceof b))return new b}function a(){if(!(this instanceof a))return new a}function e(){throw Error("method not implemented: write()");}function c(){throw Error("method not implemented: fetch()");}function n(){if(!this.buffers||!this.buffers.length)return this.fetch();
this.flush();return this.pull()}function g(a){(this.buffers||(this.buffers=[])).push(a)}function p(){return(this.buffers||(this.buffers=[])).shift()}function k(a){return function(b){for(var c in a)b[c]=a[c];return b}}h.FlexDecoder=b;h.FlexEncoder=a;var v=f("./bufferish");b.mixin=k(function(){return{bufferish:v,write:function(a){var b=this.offset?v.prototype.slice.call(this.buffer,this.offset):this.buffer;this.buffer=b?a?this.bufferish.concat([b,a]):b:a;this.offset=0},fetch:c,flush:function(){for(;this.offset<
this.buffer.length;){var a=this.offset;try{var b=this.fetch()}catch(B){if(B&&"BUFFER_SHORTAGE"!=B.message)throw B;this.offset=a;break}this.push(b)}},push:g,pull:p,read:n,reserve:function(a){var b=this.offset;a=b+a;if(a>this.buffer.length)throw Error("BUFFER_SHORTAGE");this.offset=a;return b},offset:0}}());b.mixin(b.prototype);a.mixin=k(function(){return{bufferish:v,write:e,fetch:function(){var a=this.start;if(a<this.offset){var b=this.start=this.offset;return v.prototype.slice.call(this.buffer,a,
b)}},flush:function(){for(;this.start<this.offset;){var a=this.fetch();a&&this.push(a)}},push:g,pull:function(){var a=this.buffers||(this.buffers=[]),b=1<a.length?this.bufferish.concat(a):a[0];a.length=0;return b},read:n,reserve:function(a){var b=a|0;if(this.buffer){var c=this.buffer.length,d=this.offset|0,g=d+b;if(g<c)return this.offset=g,d;this.flush();a=Math.max(a,Math.min(2*c,this.maxBufferSize))}a=Math.max(a,this.minBufferSize);this.buffer=this.bufferish.alloc(a);this.start=0;this.offset=b;return 0},
send:function(a){var b=a.length;b>this.minBufferSize?(this.flush(),this.push(a)):(b=this.reserve(b),v.prototype.copy.call(a,this.buffer,b))},maxBufferSize:65536,minBufferSize:2048,offset:0,start:0}}());a.mixin(a.prototype)},{"./bufferish":77}],91:[function(f,l,h){function b(a){var b=g.getReadToken(a);return function(a){var c=n(a),d=b[c];if(!d)throw Error("Invalid type: "+(c?"0x"+c.toString(16):c));return d(a)}}function a(){var a=this.options;this.decode=b(a);a&&a.preset&&c.setExtUnpackers(this);return this}
var e=f("./ext-buffer").ExtBuffer,c=f("./ext-unpacker"),n=f("./read-format").readUint8,g=f("./read-token"),p=f("./codec-base");p.install({addExtUnpacker:function(a,b){(this.extUnpackers||(this.extUnpackers=[]))[a]=p.filter(b)},getExtUnpacker:function(a){function b(b){return new e(b,a)}return(this.extUnpackers||(this.extUnpackers=[]))[a]||b},init:a});h.preset=a.call(p.preset)},{"./codec-base":78,"./ext-buffer":86,"./ext-unpacker":88,"./read-format":92,"./read-token":93}],92:[function(f,l,h){function b(a,
b){var c={},d,g=Array(b),e=Array(b),f=a.codec.decode;for(d=0;d<b;d++)g[d]=f(a),e[d]=f(a);for(d=0;d<b;d++)c[g[d]]=e[d];return c}function a(a,b){var c=new Map,d,g=Array(b),e=Array(b),f=a.codec.decode;for(d=0;d<b;d++)g[d]=f(a),e[d]=f(a);for(d=0;d<b;d++)c.set(g[d],e[d]);return c}function e(a,b){for(var c=Array(b),d=a.codec.decode,g=0;g<b;g++)c[g]=d(a);return c}function c(a,b){var c=a.reserve(b);return M.toString.call(a.buffer,"utf-8",c,c+b)}function n(a,b){var c=a.reserve(b),c=M.slice.call(a.buffer,c,
c+b);return F.from(c)}function g(a,b){var c=a.reserve(b),c=M.slice.call(a.buffer,c,c+b);return F.Uint8Array.from(c).buffer}function p(a,b){var c=a.reserve(b+1),d=a.buffer[c++],g=c+b,e=a.codec.getExtUnpacker(d);if(!e)throw Error("Invalid ext type: "+(d?"0x"+d.toString(16):d));c=M.slice.call(a.buffer,c,g);return e(c)}function k(a){var b=a.reserve(1);return a.buffer[b]}function v(a){var b=a.reserve(1);a=a.buffer[b];return a&128?a-256:a}function d(a){var b=a.reserve(2);a=a.buffer;return a[b++]<<8|a[b]}
function t(a){var b=a.reserve(2);a=a.buffer;b=a[b++]<<8|a[b];return b&32768?b-65536:b}function B(a){var b=a.reserve(4);a=a.buffer;return 16777216*a[b++]+(a[b++]<<16)+(a[b++]<<8)+a[b]}function z(a){var b=a.reserve(4);a=a.buffer;return a[b++]<<24|a[b++]<<16|a[b++]<<8|a[b]}function C(a,b){return function(c){var d=c.reserve(a);return b.call(c.buffer,d,I)}}function y(a){return(new J(this,a)).toNumber()}function K(a){return(new Q(this,a)).toNumber()}function q(a){return new J(this,a)}function L(a){return new Q(this,
a)}function x(a){return G.read(this,a,!1,23,4)}function E(a){return G.read(this,a,!1,52,8)}var G=f("ieee754");l=f("int64-buffer");var J=l.Uint64BE,Q=l.Int64BE;h.getReadFormat=function(f){var u=f&&f.int64;return{map:N&&f&&f.usemap?a:b,array:e,str:c,bin:F.hasArrayBuffer&&f&&f.binarraybuffer?g:n,ext:p,uint8:k,uint16:d,uint32:B,uint64:C(8,u?q:y),int8:v,int16:t,int32:z,int64:C(8,u?L:K),float32:C(4,x),float64:C(8,E)}};h.readUint8=k;var F=f("./bufferish"),M=f("./bufferish-proto"),N="undefined"!==typeof Map,
I=!0},{"./bufferish":77,"./bufferish-proto":75,ieee754:67,"int64-buffer":68}],93:[function(f,l,h){function b(b){var g,f=Array(256);for(g=0;127>=g;g++)f[g]=a(g);for(g=128;143>=g;g++)f[g]=c(g-128,b.map);for(g=144;159>=g;g++)f[g]=c(g-144,b.array);for(g=160;191>=g;g++)f[g]=c(g-160,b.str);f[192]=a(null);f[193]=null;f[194]=a(!1);f[195]=a(!0);f[196]=e(b.uint8,b.bin);f[197]=e(b.uint16,b.bin);f[198]=e(b.uint32,b.bin);f[199]=e(b.uint8,b.ext);f[200]=e(b.uint16,b.ext);f[201]=e(b.uint32,b.ext);f[202]=b.float32;
f[203]=b.float64;f[204]=b.uint8;f[205]=b.uint16;f[206]=b.uint32;f[207]=b.uint64;f[208]=b.int8;f[209]=b.int16;f[210]=b.int32;f[211]=b.int64;f[212]=c(1,b.ext);f[213]=c(2,b.ext);f[214]=c(4,b.ext);f[215]=c(8,b.ext);f[216]=c(16,b.ext);f[217]=e(b.uint8,b.str);f[218]=e(b.uint16,b.str);f[219]=e(b.uint32,b.str);f[220]=e(b.uint16,b.array);f[221]=e(b.uint32,b.array);f[222]=e(b.uint16,b.map);f[223]=e(b.uint32,b.map);for(g=224;255>=g;g++)f[g]=a(g-256);return f}function a(a){return function(){return a}}function e(a,
b){return function(c){var e=a(c);return b(c,e)}}function c(a,b){return function(c){return b(c,a)}}var n=f("./read-format");h.getReadToken=function(a){var e=n.getReadFormat(a);if(a&&a.useraw){var g=b(e).slice();g[217]=g[196];g[218]=g[197];g[219]=g[198];for(a=160;191>=a;a++)g[a]=c(a-160,e.bin);return g}return b(e)}},{"./read-format":92}],94:[function(f,l,h){function b(a){var b=n.getWriteType(a);return function(a,c){var d=b[typeof c];if(!d)throw Error('Unsupported type "'+typeof c+'": '+c);d(a,c)}}function a(){var a=
this.options;this.encode=b(a);a&&a.preset&&c.setExtPackers(this);return this}var e=f("./ext-buffer").ExtBuffer,c=f("./ext-packer"),n=f("./write-type"),g=f("./codec-base");g.install({addExtPacker:function(a,b,c){function d(b){c&&(b=c(b));return new e(b,a)}c=g.filter(c);var f=b.name;f&&"Object"!==f?(this.extPackers||(this.extPackers={}))[f]=d:(this.extEncoderList||(this.extEncoderList=[])).unshift([b,d])},getExtPacker:function(a){var b=this.extPackers||(this.extPackers={});if(b=(a=a.constructor)&&a.name&&
b[a.name])return b;for(var b=this.extEncoderList||(this.extEncoderList=[]),c=b.length,d=0;d<c;d++){var e=b[d];if(a===e[0])return e[1]}},init:a});h.preset=a.call(g.preset)},{"./codec-base":78,"./ext-buffer":86,"./ext-packer":87,"./write-type":96}],95:[function(f,l,h){function b(){var b=z.slice();b[196]=a(196);b[197]=e(197);b[198]=c(198);b[199]=a(199);b[200]=e(200);b[201]=c(201);b[202]=n(202,4,q.writeFloatBE||k,!0);b[203]=n(203,8,q.writeDoubleBE||v,!0);b[204]=a(204);b[205]=e(205);b[206]=c(206);b[207]=
n(207,8,g);b[208]=a(208);b[209]=e(209);b[210]=c(210);b[211]=n(211,8,p);b[217]=a(217);b[218]=e(218);b[219]=c(219);b[220]=e(220);b[221]=c(221);b[222]=e(222);b[223]=c(223);return b}function a(a){return function(b,c){var d=b.reserve(2),e=b.buffer;e[d++]=a;e[d]=c}}function e(a){return function(b,c){var d=b.reserve(3),e=b.buffer;e[d++]=a;e[d++]=c>>>8;e[d]=c}}function c(a){return function(b,c){var d=b.reserve(5),e=b.buffer;e[d++]=a;e[d++]=c>>>24;e[d++]=c>>>16;e[d++]=c>>>8;e[d]=c}}function n(a,b,c,d){return function(e,
g){var f=e.reserve(b+1);e.buffer[f++]=a;c.call(e.buffer,g,f,d)}}function g(a,b){new t(this,b,a)}function p(a,b){new B(this,b,a)}function k(a,b){d.write(this,a,b,!1,23,4)}function v(a,b){d.write(this,a,b,!1,52,8)}var d=f("ieee754");l=f("int64-buffer");var t=l.Uint64BE,B=l.Int64BE,z=f("./write-uint8").uint8,C=f("./bufferish"),y=C.global,K=C.hasBuffer&&"TYPED_ARRAY_SUPPORT"in y&&!y.TYPED_ARRAY_SUPPORT,q=C.hasBuffer&&y.prototype||{};h.getWriteToken=function(a){return a&&a.uint8array?(a=b(),a[202]=n(202,
4,k),a[203]=n(203,8,v),a):K||C.hasBuffer&&a&&a.safe?(a=z.slice(),a[196]=n(196,1,y.prototype.writeUInt8),a[197]=n(197,2,y.prototype.writeUInt16BE),a[198]=n(198,4,y.prototype.writeUInt32BE),a[199]=n(199,1,y.prototype.writeUInt8),a[200]=n(200,2,y.prototype.writeUInt16BE),a[201]=n(201,4,y.prototype.writeUInt32BE),a[202]=n(202,4,y.prototype.writeFloatBE),a[203]=n(203,8,y.prototype.writeDoubleBE),a[204]=n(204,1,y.prototype.writeUInt8),a[205]=n(205,2,y.prototype.writeUInt16BE),a[206]=n(206,4,y.prototype.writeUInt32BE),
a[207]=n(207,8,g),a[208]=n(208,1,y.prototype.writeInt8),a[209]=n(209,2,y.prototype.writeInt16BE),a[210]=n(210,4,y.prototype.writeInt32BE),a[211]=n(211,8,p),a[217]=n(217,1,y.prototype.writeUInt8),a[218]=n(218,2,y.prototype.writeUInt16BE),a[219]=n(219,4,y.prototype.writeUInt32BE),a[220]=n(220,2,y.prototype.writeUInt16BE),a[221]=n(221,4,y.prototype.writeUInt32BE),a[222]=n(222,2,y.prototype.writeUInt16BE),a[223]=n(223,4,y.prototype.writeUInt32BE),a):b()}},{"./bufferish":77,"./write-uint8":97,ieee754:67,
"int64-buffer":68}],96:[function(f,l,h){var b=f("isarray");l=f("int64-buffer");var a=l.Uint64BE,e=l.Int64BE,c=f("./bufferish"),n=f("./bufferish-proto"),g=f("./write-token"),p=f("./write-uint8").uint8,k=f("./ext-buffer").ExtBuffer,v="undefined"!==typeof Uint8Array,d="undefined"!==typeof Map,t=[,212,213,,214,,,,215];t[16]=216;h.getWriteType=function(f){function h(a){return 32>a?1:255>=a?2:65535>=a?3:5}function l(a){return 32>a?1:65535>=a?3:5}function B(c,d){if(null===d)return q(c,d);if(M(d))return N(c,
d);if(b(d)){var g=d,f=g.length;J[16>f?144+f:65535>=f?220:221](c,f);for(var u=c.codec.encode,h=0;h<f;h++)u(c,g[h])}else if(a.isUint64BE(d))J[207](c,d.toArray());else if(e.isInt64BE(d))J[211](c,d.toArray());else(g=c.codec.getExtPacker(d))&&(d=g(d)),d instanceof k?(g=d,f=g.buffer,u=f.length,J[t[u]||(255>u?199:65535>=u?200:201)](c,u),p[g.type](c),c.send(f)):I(c,d)}function K(a,b){if(M(b)){var c=b.length;J[32>c?160+c:65535>=c?218:219](a,c);a.send(b)}else B(a,b)}function q(a,b){J[192](a,b)}function L(a,
b){var c=b.length;J[255>c?196:65535>=c?197:198](a,c);a.send(b)}function x(a,b){L(a,new Uint8Array(b))}function E(a,b){var c=Object.keys(b),d=c.length;J[16>d?128+d:65535>=d?222:223](a,d);var e=a.codec.encode;c.forEach(function(c){e(a,c);e(a,b[c])})}function G(a,b){if(!(b instanceof Map))return E(a,b);var c=b.size;J[16>c?128+c:65535>=c?222:223](a,c);var d=a.codec.encode;b.forEach(function(b,c,e){d(a,c);d(a,b)})}var J=g.getWriteToken(f),Q=f&&f.useraw,F=v&&f&&f.binarraybuffer,M=F?c.isArrayBuffer:c.isBuffer,
N=F?x:L,I=d&&f&&f.usemap?G:E;return{"boolean":function(a,b){J[b?195:194](a,b)},"function":q,number:function(a,b){var c=b|0;if(b!==c)J[203](a,b);else J[-32<=c&&127>=c?c&255:0<=c?255>=c?204:65535>=c?205:206:-128<=c?208:-32768<=c?209:210](a,c)},object:Q?K:B,string:function(a){return function(b,c){var d=c.length;b.offset=b.reserve(5+3*d);var e=b.buffer,g=a(d),f=b.offset+g,d=n.write.call(e,c,f),m=a(d);g!==m&&n.copy.call(e,e,f+m-g,f,f+d);J[1===m?160+d:3>=m?215+m:219](b,d);b.offset+=d}}(Q?l:h),symbol:q,
undefined:q}}},{"./bufferish":77,"./bufferish-proto":75,"./ext-buffer":86,"./write-token":95,"./write-uint8":97,"int64-buffer":68,isarray:69}],97:[function(f,l,h){function b(a){return function(b){var c=b.reserve(1);b.buffer[c]=a}}f=h.uint8=Array(256);for(l=0;255>=l;l++)f[l]=b(l)},{}],98:[function(f,l,h){(function(b){(function(){var a=function(a,b){function c(){this.constructor=a}for(var g in b)e.call(b,g)&&(a[g]=b[g]);c.prototype=b.prototype;a.prototype=new c;a.__super__=b.prototype;return a},e={}.hasOwnProperty;
var c=f("stream");var h=f("util");l.exports=function(c){function e(a,c,g){var d,f;null==g&&(g={});var h=d=void 0;switch(typeof a){case "object":b.isBuffer(a)?(d=a,null!=c&&"object"===typeof c&&(g=c)):g=a;break;case "string":d=a,null!=c&&"object"===typeof c?g=c:h=c}null==g&&(g={});null==d&&(d=g.input);null==h&&(h=g.inputEncoding);delete g.input;delete g.inputEncoding;a=null!=(f=g.watchPipe)?f:!0;delete g.watchPipe;e.__super__.constructor.call(this,g);if(a)this.on("pipe",function(a){return function(b){b=
b._readableState.objectMode;if(0<a.length&&b!==a._readableState.objectMode)throw Error("Do not switch objectMode in the middle of the stream");a._readableState.objectMode=b;return a._writableState.objectMode=b}}(this));null!=d&&this.end(d,h)}a(e,c);e.isNoFilter=function(a){return a instanceof this};e.compare=function(a,b){if(!(a instanceof this))throw new TypeError("Arguments must be NoFilters");return a===b?0:a.compare(b)};e.concat=function(a,c){if(!Array.isArray(a))throw new TypeError("list argument must be an Array of NoFilters");
if(0===a.length||0===c)return new b(0);null==c&&(c=a.reduce(function(a,b){if(!(b instanceof e))throw new TypeError("list argument must be an Array of NoFilters");return a+b.length},0));var d=a.map(function(a){if(!(a instanceof e))throw new TypeError("list argument must be an Array of NoFilters");if(a._readableState.objectMode)throw Error("NoFilter may not be in object mode for concat");return a.slice()});return b.concat(d,c)};e.prototype._transform=function(a,c,e){this._readableState.objectMode||
b.isBuffer(a)||(a=new b(a,c));this.push(a);return e()};e.prototype._bufArray=function(){var a=this._readableState.buffer;if(!Array.isArray(a)){var b=a.head;for(a=[];null!=b;)a.push(b.data),b=b.next}return a};e.prototype.read=function(a){a=e.__super__.read.call(this,a);null!=a&&this.emit("read",a);return a};e.prototype.promise=function(a){var b=!1;return new Promise(function(c){return function(d,e){c.on("finish",function(){var e=c.read();null==a||b||(b=!0,a(null,e));return d(e)});return c.on("error",
function(c){null==a||b||(b=!0,a(c));return e(c)})}}(this))};e.prototype.compare=function(a){if(!(a instanceof e))throw new TypeError("Arguments must be NoFilters");if(this._readableState.objectMode||a._readableState.objectMode)throw Error("Must not be in object mode to compare");return this===a?0:this.slice().compare(a.slice())};e.prototype.equals=function(a){return 0===this.compare(a)};e.prototype.slice=function(a,c){if(this._readableState.objectMode)return this._bufArray().slice(a,c);var d=this._bufArray();
switch(d.length){case 0:return new b(0);case 1:return d[0].slice(a,c);default:return d=b.concat(d),d.slice(a,c)}};e.prototype.get=function(a){return this.slice()[a]};e.prototype.toJSON=function(){var a=this.slice();return b.isBuffer(a)?a.toJSON():a};e.prototype.toString=function(a,b,c){return this.slice().toString(a,b,c)};e.prototype.inspect=function(a,c){var d=this._bufArray().map(function(a){return b.isBuffer(a)?null!=c&&c.stylize?c.stylize(a.toString("hex"),"string"):a.toString("hex"):h.inspect(a,
c)}).join(", ");return this.constructor.name+" ["+d+"]"};c=function(a,c){return function(d){d=this.read(c);return b.isBuffer(d)?d[a].call(d,0,!0):null}};var g=function(a,c){return function(d){var e=new b(c);e[a].call(e,d,0,!0);return this.push(e)}};e.prototype.writeUInt8=g("writeUInt8",1);e.prototype.writeUInt16LE=g("writeUInt16LE",2);e.prototype.writeUInt16BE=g("writeUInt16BE",2);e.prototype.writeUInt32LE=g("writeUInt32LE",4);e.prototype.writeUInt32BE=g("writeUInt32BE",4);e.prototype.writeInt8=g("writeInt8",
1);e.prototype.writeInt16LE=g("writeInt16LE",2);e.prototype.writeInt16BE=g("writeInt16BE",2);e.prototype.writeInt32LE=g("writeInt32LE",4);e.prototype.writeInt32BE=g("writeInt32BE",4);e.prototype.writeFloatLE=g("writeFloatLE",4);e.prototype.writeFloatBE=g("writeFloatBE",4);e.prototype.writeDoubleLE=g("writeDoubleLE",8);e.prototype.writeDoubleBE=g("writeDoubleBE",8);e.prototype.readUInt8=c("readUInt8",1);e.prototype.readUInt16LE=c("readUInt16LE",2);e.prototype.readUInt16BE=c("readUInt16BE",2);e.prototype.readUInt32LE=
c("readUInt32LE",4);e.prototype.readUInt32BE=c("readUInt32BE",4);e.prototype.readInt8=c("readInt8",1);e.prototype.readInt16LE=c("readInt16LE",2);e.prototype.readInt16BE=c("readInt16BE",2);e.prototype.readInt32LE=c("readInt32LE",4);e.prototype.readInt32BE=c("readInt32BE",4);e.prototype.readFloatLE=c("readFloatLE",4);e.prototype.readFloatBE=c("readFloatBE",4);e.prototype.readDoubleLE=c("readDoubleLE",8);e.prototype.readDoubleBE=c("readDoubleBE",8);(function(a){var b;var c=[];for(b in a){var g=a[b];
c.push(e.prototype.__defineGetter__(b,g))}return c})({length:function(){return this._readableState.length}});return e}(c.Transform)}).call(this)}).call(this,f("buffer").Buffer)},{buffer:129,stream:153,util:160}],99:[function(f,l,h){(function(b){b(function(a){function b(a){var b=1<arguments.length?k.call(arguments,1):[];return function(){return h(a,this,b.concat(k.call(arguments)))}}var c=a("./when"),f=c["try"],g=a("./lib/liftAll"),h=a("./lib/apply")(c.Promise),k=Array.prototype.slice;return{lift:b,
liftAll:function(a,c,e){return g(b,c,e,a)},call:f,apply:function(a,b){return h(a,this,null==b?[]:k.call(b))},compose:function(a){var b=k.call(arguments,1);return function(){var d=this,e=k.call(arguments),e=f.apply(d,[a].concat(e));return c.reduce(b,function(a,b){return b.call(d,a)},e)}}}})})(function(b){l.exports=b(f)})},{"./lib/apply":103,"./lib/liftAll":115,"./when":123}],100:[function(f,l,h){(function(b){b(function(a){var b=a("./makePromise"),c=a("./Scheduler");a=a("./env").asap;return b({scheduler:new c(a)})})})(function(b){l.exports=
b(f)})},{"./Scheduler":101,"./env":113,"./makePromise":116}],101:[function(f,l,h){(function(b){b(function(){function a(a){this._async=a;this._running=!1;this._queue=this;this._queueLen=0;this._afterQueue={};this._afterQueueLen=0;var b=this;this.drain=function(){b._drain()}}a.prototype.enqueue=function(a){this._queue[this._queueLen++]=a;this.run()};a.prototype.afterQueue=function(a){this._afterQueue[this._afterQueueLen++]=a;this.run()};a.prototype.run=function(){this._running||(this._running=!0,this._async(this.drain))};
a.prototype._drain=function(){for(var a=0;a<this._queueLen;++a)this._queue[a].run(),this._queue[a]=void 0;this._queueLen=0;this._running=!1;for(a=0;a<this._afterQueueLen;++a)this._afterQueue[a].run(),this._afterQueue[a]=void 0;this._afterQueueLen=0};return a})})(function(b){l.exports=b()})},{}],102:[function(f,l,h){(function(b){b(function(){function a(b){Error.call(this);this.message=b;this.name=a.name;"function"===typeof Error.captureStackTrace&&Error.captureStackTrace(this,a)}a.prototype=Object.create(Error.prototype);
return a.prototype.constructor=a})})(function(b){l.exports=b()})},{}],103:[function(f,l,h){(function(b){b(function(){function a(a,e){function c(b,c){if(0>b.i)return e(b.f,b.thisArg,b.params,c);a._handler(b.args[b.i]).fold(f,b,void 0,c)}function f(a,b,d){a.params[a.i]=b;--a.i;c(a,d)}2>arguments.length&&(e=b);return function(b,g,d){var f=a._defer(),h=d.length;c({f:b,thisArg:g,args:d,params:Array(h),i:h-1,call:e},f._handler);return f}}function b(a,b,e,f){try{f.resolve(a.apply(b,e))}catch(k){f.reject(k)}}
a.tryCatchResolve=b;return a})})(function(b){l.exports=b()})},{}],104:[function(f,l,h){(function(b){b(function(a){var b=a("../state"),c=a("../apply");return function(a){function e(c){var d;c instanceof a&&(d=c._handler.join());if(d&&0===d.state()||!d)return n(c).then(b.fulfilled,b.rejected);d._unreport();return b.inspect(d)}function f(a){return function(b,c,d){return h(a,void 0,[b,c,d])}}var h=c(a),n=a.resolve,d=a.all,l=Array.prototype.reduce,B=Array.prototype.reduceRight,z=Array.prototype.slice;
a.any=function(b){function c(a){k=null;this.resolve(a)}function d(a){this.resolved||(k.push(a),0===--h&&this.reject(k))}for(var e=a._defer(),g=e._handler,f=b.length>>>0,h=f,k=[],n,p=0;p<f;++p)if(n=b[p],void 0!==n||p in b)if(n=a._handler(n),0<n.state()){g.become(n);a._visitRemaining(b,p,n);break}else n.visit(g,c,d);else--h;0===h&&g.reject(new RangeError("any(): array must not be empty"));return e};a.some=function(b,c){function d(a){this.resolved||(h.push(a),0===--p&&(k=null,this.resolve(h)))}function e(a){this.resolved||
(k.push(a),0===--v&&(h=null,this.reject(k)))}var g=a._defer(),f=g._handler,h=[],k=[],n=b.length>>>0,p=0,l;for(l=0;l<n;++l){var t=b[l];(void 0!==t||l in b)&&++p}c=Math.max(c,0);var v=p-c+1;p=Math.min(c,p);c>p?f.reject(new RangeError("some(): array must contain at least "+c+" item(s), but had "+p)):0===p&&f.resolve(h);for(l=0;l<n;++l)t=b[l],(void 0!==t||l in b)&&a._handler(t).visit(f,d,e,f.notify);return g};a.settle=function(a){return d(a.map(e))};a.map=function(b,c){return a._traverse(c,b)};a.filter=
function(b,c){var d=z.call(b);return a._traverse(c,d).then(function(b){for(var c=b.length,e=Array(c),g=0,f=0;g<c;++g)b[g]&&(e[f++]=a._handler(d[g]).value);e.length=f;return e})};a.reduce=function(a,b){return 2<arguments.length?l.call(a,f(b),arguments[2]):l.call(a,f(b))};a.reduceRight=function(a,b){return 2<arguments.length?B.call(a,f(b),arguments[2]):B.call(a,f(b))};a.prototype.spread=function(a){return this.then(d).then(function(b){return a.apply(this,b)})};return a}})})(function(b){l.exports=b(f)})},
{"../apply":103,"../state":117}],105:[function(f,l,h){(function(b){b(function(){function a(){throw new TypeError("catch predicate must be a function");}function b(a){return a}return function(c){function e(a,b){return function(c){return(b===Error||null!=b&&b.prototype instanceof Error?c instanceof b:b(c))?a.call(this,c):l(c)}}function g(a,b,c,d){a=a.call(b);return"object"!==typeof a&&"function"!==typeof a||null===a?c(d):f(a,c,d)}function f(a,b,c){return h(a).then(function(){return b(c)})}var h=c.resolve,
l=c.reject,d=c.prototype["catch"];c.prototype.done=function(a,b){this._handler.visit(this._handler.receiver,a,b)};c.prototype["catch"]=c.prototype.otherwise=function(b){return 2>arguments.length?d.call(this,b):"function"!==typeof b?this.ensure(a):d.call(this,e(arguments[1],b))};c.prototype["finally"]=c.prototype.ensure=function(a){return"function"!==typeof a?this:this.then(function(c){return g(a,this,b,c)},function(b){return g(a,this,l,b)})};c.prototype["else"]=c.prototype.orElse=function(a){return this.then(void 0,
function(){return a})};c.prototype.yield=function(a){return this.then(function(){return a})};c.prototype.tap=function(a){return this.then(a).yield(this)};return c}})})(function(b){l.exports=b()})},{}],106:[function(f,l,h){(function(b){b(function(){return function(a){a.prototype.fold=function(b,c){var e=this._beget();this._handler.fold(function(c,e,f){a._handler(c).fold(function(a,c,e){e.resolve(b.call(this,c,a))},e,this,f)},c,e._handler.receiver,e._handler);return e};return a}})})(function(b){l.exports=
b()})},{}],107:[function(f,l,h){(function(b){b(function(a){var b=a("../state").inspect;return function(a){a.prototype.inspect=function(){return b(a._handler(this))};return a}})})(function(b){l.exports=b(f)})},{"../state":117}],108:[function(f,l,h){(function(b){b(function(){return function(a){function b(a,e,f,h){function g(d,g){return c(f(d)).then(function(){return b(a,e,f,g)})}return c(h).then(function(b){return c(e(b)).then(function(d){return d?b:c(a(b)).spread(g)})})}var c=a.resolve;a.iterate=function(a,
c,e,f){return b(function(b){return[b,a(b)]},c,e,f)};a.unfold=b;return a}})})(function(b){l.exports=b()})},{}],109:[function(f,l,h){(function(b){b(function(){return function(a){a.prototype.progress=function(a){return this.then(void 0,void 0,a)};return a}})})(function(b){l.exports=b()})},{}],110:[function(f,l,h){(function(b){b(function(a){function b(a,b,e,f){return c.setTimer(function(){a(e,f,b)},b)}var c=a("../env"),f=a("../TimeoutError");return function(a){function e(a,c,e){b(g,a,c,e)}function g(a,
b){b.resolve(a)}function h(a,b,c){a="undefined"===typeof a?new f("timed out after "+c+"ms"):a;b.reject(a)}a.prototype.delay=function(a){var b=this._beget();this._handler.fold(e,a,void 0,b._handler);return b};a.prototype.timeout=function(a,e){var d=this._beget(),g=d._handler,f=b(h,a,e,d._handler);this._handler.visit(g,function(a){c.clearTimer(f);this.resolve(a)},function(a){c.clearTimer(f);this.reject(a)},g.notify);return d};return a}})})(function(b){l.exports=b(f)})},{"../TimeoutError":102,"../env":113}],
111:[function(f,l,h){(function(b){b(function(a){function b(a){throw a;}function c(){}var f=a("../env").setTimer,g=a("../format");return function(a){function e(a){a.handled||(K.push(a),p("Potentially unhandled rejection ["+a.id+"] "+g.formatError(a.value)))}function h(a){var b=K.indexOf(a);0<=b&&(K.splice(b,1),l("Handled previous rejection ["+a.id+"] "+g.formatObject(a.value)))}function d(a,b){y.push(a,b);null===q&&(q=f(n,0))}function n(){for(q=null;0<y.length;)y.shift()(y.shift())}var p=c,l=c;if("undefined"!==
typeof console){var C=console;p="undefined"!==typeof C.error?function(a){C.error(a)}:function(a){C.log(a)};l="undefined"!==typeof C.info?function(a){C.info(a)}:function(a){C.log(a)}}a.onPotentiallyUnhandledRejection=function(a){d(e,a)};a.onPotentiallyUnhandledRejectionHandled=function(a){d(h,a)};a.onFatalRejection=function(a){d(b,a.value)};var y=[],K=[],q=null;return a}})})(function(b){l.exports=b(f)})},{"../env":113,"../format":114}],112:[function(f,l,h){(function(b){b(function(){return function(a){a.prototype["with"]=
a.prototype.withThis=function(a){var b=this._beget(),e=b._handler;e.receiver=a;this._handler.chain(e,a);return b};return a}})})(function(b){l.exports=b()})},{}],113:[function(f,l,h){(function(b){(function(a){a(function(a){function c(a){var b,c=document.createTextNode("");(new a(function(){var a=b;b=void 0;a()})).observe(c,{characterData:!0});var d=0;return function(a){b=a;c.data=d^=1}}var e,g="undefined"!==typeof setTimeout&&setTimeout,f=function(a,b){return setTimeout(a,b)},h=function(a){return clearTimeout(a)},
l=function(a){return g(a,0)};if("undefined"!==typeof b&&"[object process]"===Object.prototype.toString.call(b))l=function(a){return b.nextTick(a)};else if(e="undefined"!==typeof MutationObserver&&MutationObserver||"undefined"!==typeof WebKitMutationObserver&&WebKitMutationObserver)l=c(e);else if(!g)var d=a("vertx"),f=function(a,b){return d.setTimer(b,a)},h=d.cancelTimer,l=d.runOnLoop||d.runOnContext;return{setTimer:f,clearTimer:h,asap:l}})})(function(a){l.exports=a(f)})}).call(this,f("_process"))},
{_process:137}],114:[function(f,l,h){(function(b){b(function(){function a(a){var c=String(a);"[object Object]"===c&&"undefined"!==typeof JSON&&(c=b(a,c));return c}function b(a,b){try{return JSON.stringify(a)}catch(g){return b}}return{formatError:function(b){var c="object"===typeof b&&null!==b&&(b.stack||b.message)?b.stack||b.message:a(b);return b instanceof Error?c:c+" (WARNING: non-Error used)"},formatObject:a,tryStringify:b}})})(function(b){l.exports=b()})},{}],115:[function(f,l,h){(function(b){b(function(){function a(a,
b,e){a[e]=b;return a}function b(a){return"function"===typeof a?a.bind():Object.create(a)}return function(c,e,g,f){"undefined"===typeof e&&(e=a);return Object.keys(f).reduce(function(a,b){var d=f[b];return"function"===typeof d?e(a,c(d),b):a},"undefined"===typeof g?b(f):g)}})})(function(b){l.exports=b()})},{}],116:[function(f,l,h){(function(b){(function(a){a(function(){return function(a){function c(a,b){this._handler=a===z?b:e(a)}function e(a){function b(a){e.resolve(a)}function c(a){e.reject(a)}function d(a){e.notify(a)}
var e=new y;try{a(b,c,d)}catch(Y){c(Y)}return e}function g(a){return a instanceof c?a:new c(z,new K(t(a)))}function f(a){return new c(z,new K(new x(a)))}function h(a,b,d){function e(c,e,f){f.resolved||l(d,g,c,a(b,e,c),f)}function g(a,b,c){u[a]=b;0===--r&&c.become(new L(u))}for(var f="function"===typeof b?e:g,m=new y,r=d.length>>>0,u=Array(r),h=0,k;h<d.length&&!m.resolved;++h)k=d[h],void 0!==k||h in d?l(d,f,h,k,m):--r;0===r&&m.become(new L(u));return new c(z,m)}function l(a,b,e,g,f){if(I(g)){g=g instanceof
c?g._handler.join():B(g);var m=g.state();0===m?g.fold(b,e,void 0,f):0<m?b(e,g.value,f):(f.become(g),d(a,e+1,g))}else b(e,g,f)}function d(a,b,c){for(;b<a.length;++b){var d=t(a[b]);if(d!==c){var e=d.state();0===e?d.visit(d,void 0,d._unreport):0>e&&d._unreport()}}}function t(a){return a instanceof c?a._handler.join():I(a)?B(a):new L(a)}function B(a){try{var b=a.then;return"function"===typeof b?new q(b,a):new L(a)}catch(Z){return new x(Z)}}function z(){}function C(){}function y(a,b){c.createContext(this,
b);this.consumers=void 0;this.receiver=a;this.handler=void 0;this.resolved=!1}function K(a){this.handler=a}function q(a,b){y.call(this);A.enqueue(new F(a,b,this))}function L(a){c.createContext(this);this.value=a}function x(a){c.createContext(this);this.id=++T;this.value=a;this.reported=this.handled=!1;this._report()}function E(a,b){this.rejection=a;this.context=b}function G(a){this.rejection=a}function J(a,b){this.continuation=a;this.handler=b}function Q(a,b){this.handler=b;this.value=a}function F(a,
b,c){this._then=a;this.thenable=b;this.resolver=c}function M(a,b,c,d,e){try{a.call(b,c,d,e)}catch(Y){d(Y)}}function N(a,b,c,d){this.f=a;this.z=b;this.c=c;this.to=d;this.resolver=R;this.receiver=this}function I(a){return("object"===typeof a||"function"===typeof a)&&null!==a}function D(a,b,d,e){if("function"!==typeof a)return e.become(b);c.enterContext(b);try{e.become(t(a.call(d,b.value)))}catch(ba){e.become(new x(ba))}c.exitContext()}function u(a,b,c){try{return a(b,c)}catch(U){return f(U)}}function m(a,
b){b.prototype=S(a.prototype);b.prototype.constructor=b}function r(a,b){return b}function w(){}var A=a.scheduler,V=function(){if("undefined"!==typeof b&&null!==b&&"function"===typeof b.emit)var a=function(a,c){return"unhandledRejection"===a?b.emit(a,c.value,c):b.emit(a,c)};else{if(a="undefined"!==typeof self)a:{if("function"===typeof CustomEvent)try{a=new CustomEvent("unhandledRejection")instanceof CustomEvent;break a}catch(ca){}a=!1}if(a)a=function(a,b){return function(c,d){var e=new b(c,{detail:{reason:d.value,
key:d},bubbles:!1,cancelable:!0});return!a.dispatchEvent(e)}}(self,CustomEvent);else{if(a="undefined"!==typeof self)a:{if("undefined"!==typeof document&&"function"===typeof document.createEvent)try{document.createEvent("CustomEvent").initCustomEvent("eventType",!1,!0,{});a=!0;break a}catch(ca){}a=!1}a=a?function(a,b){return function(c,d){var e=b.createEvent("CustomEvent");e.initCustomEvent(c,!1,!0,{reason:d.value,key:d});return!a.dispatchEvent(e)}}(self,document):w}}return a}(),S=Object.create||function(a){function b(){}
b.prototype=a;return new b};c.resolve=g;c.reject=f;c.never=function(){return ea};c._defer=function(){return new c(z,new y)};c._handler=t;c.prototype.then=function(a,b,c){var d=this._handler,e=d.join().state();if("function"!==typeof a&&0<e||"function"!==typeof b&&0>e)return new this.constructor(z,d);e=this._beget();d.chain(e._handler,d.receiver,a,b,c);return e};c.prototype["catch"]=function(a){return this.then(void 0,a)};c.prototype._beget=function(){var a=this._handler,b=this.constructor,a=new y(a.receiver,
a.join().context);return new b(z,a)};c.all=function(a){return h(r,null,a)};c.race=function(a){if("object"!==typeof a||null===a)return f(new TypeError("non-iterable passed to race()"));if(0===a.length)a=ea;else if(1===a.length)a=g(a[0]);else{var b=new y,e;for(e=0;e<a.length;++e){var m=a[e];if(void 0!==m||e in a)if(m=t(m),0!==m.state()){b.become(m);d(a,e+1,m);break}else m.visit(b,b.resolve,b.reject)}a=new c(z,b)}return a};c._traverse=function(a,b){return h(u,a,b)};c._visitRemaining=d;z.prototype.when=
z.prototype.become=z.prototype.notify=z.prototype.fail=z.prototype._unreport=z.prototype._report=w;z.prototype._state=0;z.prototype.state=function(){return this._state};z.prototype.join=function(){for(var a=this;void 0!==a.handler;)a=a.handler;return a};z.prototype.chain=function(a,b,c,d,e){this.when({resolver:a,receiver:b,fulfilled:c,rejected:d,progress:e})};z.prototype.visit=function(a,b,c,d){this.chain(R,a,b,c,d)};z.prototype.fold=function(a,b,c,d){this.when(new N(a,b,c,d))};m(z,C);C.prototype.become=
function(a){a.fail()};var R=new C;m(z,y);y.prototype._state=0;y.prototype.resolve=function(a){this.become(t(a))};y.prototype.reject=function(a){this.resolved||this.become(new x(a))};y.prototype.join=function(){if(!this.resolved)return this;for(var a=this;void 0!==a.handler;)if(a=a.handler,a===this)return this.handler=new x(new TypeError("Promise cycle"));return a};y.prototype.run=function(){var a=this.consumers,b=this.handler;this.handler=this.handler.join();this.consumers=void 0;for(var c=0;c<a.length;++c)b.when(a[c])};
y.prototype.become=function(a){this.resolved||(this.resolved=!0,this.handler=a,void 0!==this.consumers&&A.enqueue(this),void 0!==this.context&&a._report(this.context))};y.prototype.when=function(a){this.resolved?A.enqueue(new J(a,this.handler)):void 0===this.consumers?this.consumers=[a]:this.consumers.push(a)};y.prototype.notify=function(a){this.resolved||A.enqueue(new Q(a,this))};y.prototype.fail=function(a){a="undefined"===typeof a?this.context:a;this.resolved&&this.handler.join().fail(a)};y.prototype._report=
function(a){this.resolved&&this.handler.join()._report(a)};y.prototype._unreport=function(){this.resolved&&this.handler.join()._unreport()};m(z,K);K.prototype.when=function(a){A.enqueue(new J(a,this))};K.prototype._report=function(a){this.join()._report(a)};K.prototype._unreport=function(){this.join()._unreport()};m(y,q);m(z,L);L.prototype._state=1;L.prototype.fold=function(a,b,d,e){if("function"!==typeof a)e.become(this);else{c.enterContext(this);try{a.call(d,b,this.value,e)}catch(ba){e.become(new x(ba))}c.exitContext()}};
L.prototype.when=function(a){D(a.fulfilled,this,a.receiver,a.resolver)};var T=0;m(z,x);x.prototype._state=-1;x.prototype.fold=function(a,b,c,d){d.become(this)};x.prototype.when=function(a){"function"===typeof a.rejected&&this._unreport();D(a.rejected,this,a.receiver,a.resolver)};x.prototype._report=function(a){A.afterQueue(new E(this,a))};x.prototype._unreport=function(){this.handled||(this.handled=!0,A.afterQueue(new G(this)))};x.prototype.fail=function(a){this.reported=!0;V("unhandledRejection",
this);c.onFatalRejection(this,void 0===a?this.context:a)};E.prototype.run=function(){this.rejection.handled||this.rejection.reported||(this.rejection.reported=!0,V("unhandledRejection",this.rejection)||c.onPotentiallyUnhandledRejection(this.rejection,this.context))};G.prototype.run=function(){this.rejection.reported&&(V("rejectionHandled",this.rejection)||c.onPotentiallyUnhandledRejectionHandled(this.rejection))};c.createContext=c.enterContext=c.exitContext=c.onPotentiallyUnhandledRejection=c.onPotentiallyUnhandledRejectionHandled=
c.onFatalRejection=w;a=new z;var ea=new c(z,a);J.prototype.run=function(){this.handler.join().when(this.continuation)};Q.prototype.run=function(){var a=this.handler.consumers;if(void 0!==a)for(var b,d=0;d<a.length;++d){b=a[d];var e=b.progress,g=this.value,f=this.handler,m=b.receiver;b=b.resolver;if("function"!==typeof e)b.notify(g);else{c.enterContext(f);f=b;try{f.notify(e.call(m,g))}catch(W){f.notify(W)}c.exitContext()}}};F.prototype.run=function(){var a=this.resolver;M(this._then,this.thenable,
function(b){a.resolve(b)},function(b){a.reject(b)},function(b){a.notify(b)})};N.prototype.fulfilled=function(a){this.f.call(this.c,this.z,a,this.to)};N.prototype.rejected=function(a){this.to.reject(a)};N.prototype.progress=function(a){this.to.notify(a)};return c}})})(function(a){l.exports=a()})}).call(this,f("_process"))},{_process:137}],117:[function(f,l,h){(function(b){b(function(){function a(){return{state:"pending"}}function b(a){return{state:"rejected",reason:a}}function c(a){return{state:"fulfilled",
value:a}}return{pending:a,fulfilled:c,rejected:b,inspect:function(e){var g=e.state();return 0===g?a():0<g?c(e.value):b(e.value)}}})})(function(b){l.exports=b()})},{}],118:[function(f,l,h){(function(b){b(function(a){var b=a("./monitor/PromiseMonitor");a=a("./monitor/ConsoleReporter");var c=new b(new a);return function(a){return c.monitor(a)}})})(function(b){l.exports=b(f)})},{"./monitor/ConsoleReporter":119,"./monitor/PromiseMonitor":120}],119:[function(f,l,h){(function(b){b(function(a){function b(){this._previouslyReported=
!1}function c(){}var f=a("./error");b.prototype=function(){var a;if("undefined"===typeof console)var b=a=c;else{var e=console;if("function"===typeof e.error&&"function"===typeof e.dir){if(a=function(a){e.error(a)},b=function(a){e.log(a)},"function"===typeof e.groupCollapsed){var f=function(a){e.groupCollapsed(a)};var d=function(){e.groupEnd()}}}else b="undefined"!==typeof e.log&&"undefined"!==typeof JSON?a=function(a){if("string"!==typeof a)try{a=JSON.stringify(a)}catch(B){}e.log(a)}:a=c}return{msg:b,
warn:a,groupStart:f||a,groupEnd:d||c}}();b.prototype.log=function(a){if(0===a.length)this._previouslyReported&&(this._previouslyReported=!1,this.msg("[promises] All previously unhandled rejections have now been handled"));else{this._previouslyReported=!0;this.groupStart("[promises] Unhandled rejections: "+a.length);try{this._log(a)}finally{this.groupEnd()}}};b.prototype._log=function(a){for(var b=0;b<a.length;++b)this.warn(f.format(a[b]))};return b})})(function(b){l.exports=b(f)})},{"./error":122}],
120:[function(f,l,h){(function(b){b(function(a){function b(a){this.logDelay=0;this.stackFilter=g;this.stackJumpSeparator="from execution context:";this.filterDuplicateFrames=!0;this._reporter=a;"function"===typeof a.configurePromiseMonitor&&a.configurePromiseMonitor(this);this._traces=[];this._traceTask=0;var b=this;this._doLogTraces=function(){b._logTraces()}}function c(a,b){return b.filter(function(b){return!a.test(b)})}function f(a){return!a.handler.handled}var g=/[\s\(\/\\](node|module|timers)\.js:|when([\/\\]{1,2}(lib|monitor|es6-shim)[\/\\]{1,2}|\.js)|(new\sPromise)\b|(\b(PromiseMonitor|ConsoleReporter|Scheduler|RunHandlerTask|ProgressTask|Promise|.*Handler)\.[\w_]\w\w+\b)|\b(tryCatch\w+|getHandler\w*)\b/i,
h=a("../lib/env").setTimer,k=a("./error"),l=[];b.prototype.monitor=function(a){var b=this;a.createContext=function(a,c){a.context=b.createContext(a,c)};a.enterContext=function(a){l.push(a.context)};a.exitContext=function(){l.pop()};a.onPotentiallyUnhandledRejection=function(a,c){return b.addTrace(a,c)};a.onPotentiallyUnhandledRejectionHandled=function(a){return b.removeTrace(a)};a.onFatalRejection=function(a,c){return b.fatal(a,c)};return this};b.prototype.createContext=function(a,b){var c={parent:b||
l[l.length-1],stack:void 0};k.captureStack(c,a.constructor);return c};b.prototype.addTrace=function(a,b){var c;for(c=this._traces.length-1;0<=c;--c){var d=this._traces[c];if(d.handler===a)break}0<=c?d.extraContext=b:this._traces.push({handler:a,extraContext:b});this.logTraces()};b.prototype.removeTrace=function(){this.logTraces()};b.prototype.fatal=function(a,b){var c=Error();c.stack=this._createLongTrace(a.value,a.context,b).join("\n");h(function(){throw c;},0)};b.prototype.logTraces=function(){this._traceTask||
(this._traceTask=h(this._doLogTraces,this.logDelay))};b.prototype._logTraces=function(){this._traceTask=void 0;this._traces=this._traces.filter(f);this._reporter.log(this.formatTraces(this._traces))};b.prototype.formatTraces=function(a){return a.map(function(a){return this._createLongTrace(a.handler.value,a.handler.context,a.extraContext)},this)};b.prototype._createLongTrace=function(a,b,e){a=k.parse(a)||[String(a)+" (WARNING: non-Error used)"];a=c(this.stackFilter,a,0);this._appendContext(a,b);this._appendContext(a,
e);return this.filterDuplicateFrames?this._removeDuplicates(a):a};b.prototype._removeDuplicates=function(a){var b={},c=this.stackJumpSeparator,d=0;return a.reduceRight(function(a,e,g){0===g?a.unshift(e):e===c?0<d&&(a.unshift(e),d=0):b[e]||(b[e]=!0,a.unshift(e),++d);return a},[])};b.prototype._appendContext=function(a,b){a.push.apply(a,this._createTrace(b))};b.prototype._createTrace=function(a){for(var b=[],d;a;){if(d=k.parse(a)){d=c(this.stackFilter,d);var e=b;1<d.length&&(d[0]=this.stackJumpSeparator,
e.push.apply(e,d))}a=a.parent}return b};return b})})(function(b){l.exports=b(f)})},{"../lib/env":113,"./error":122}],121:[function(f,l,h){(function(b){b(function(a){var b=a("../monitor");a=a("../when").Promise;return b(a)})})(function(b){l.exports=b(f)})},{"../monitor":118,"../when":123}],122:[function(f,l,h){(function(b){b(function(){function a(a){try{throw Error();}catch(t){a.stack=t.stack}}function b(a){a.stack=Error().stack}function c(a){return g(a)}function f(a){var b=Error();b.stack=g(a);return b}
function g(a){for(var b=!1,c="",d=0;d<a.length;++d)b?c+="\n"+a[d]:(c+=a[d],b=!0);return c}if(Error.captureStackTrace){var h=function(a){return a&&a.stack&&a.stack.split("\n")};var k=c;var l=Error.captureStackTrace}else h=function(a){var b=a&&a.stack&&a.stack.split("\n");b&&a.message&&b.unshift(a.message);return b},"string"!==typeof Error().stack?(k=c,l=a):(k=f,l=b);return{parse:h,format:k,captureStack:l}})})(function(b){l.exports=b()})},{}],123:[function(f,l,h){(function(b){b(function(a){function b(a,
b,c,d){var e=q.resolve(a);return 2>arguments.length?e:e.then(b,c,d)}function c(a){return function(){for(var b=0,c=arguments.length,d=Array(c);b<c;++b)d[b]=arguments[b];return L(a,this,d)}}function f(a){for(var b=0,c=arguments.length-1,d=Array(c);b<c;++b)d[b]=arguments[b+1];return L(a,this,d)}function g(){function a(a){d._handler.resolve(a)}function b(a){d._handler.reject(a)}function c(a){d._handler.notify(a)}var d=q._defer();this.promise=d;this.resolve=a;this.reject=b;this.notify=c;this.resolver=
{resolve:a,reject:b,notify:c}}var h=a("./lib/decorators/timed"),k=a("./lib/decorators/array"),l=a("./lib/decorators/flow"),d=a("./lib/decorators/fold"),t=a("./lib/decorators/inspect"),B=a("./lib/decorators/iterate"),z=a("./lib/decorators/progress"),C=a("./lib/decorators/with"),y=a("./lib/decorators/unhandledRejection"),K=a("./lib/TimeoutError"),q=[k,l,d,B,z,t,C,h,y].reduce(function(a,b){return b(a)},a("./lib/Promise")),L=a("./lib/apply")(q);b.promise=function(a){return new q(a)};b.resolve=q.resolve;
b.reject=q.reject;b.lift=c;b["try"]=f;b.attempt=f;b.iterate=q.iterate;b.unfold=q.unfold;b.join=function(){return q.all(arguments)};b.all=function(a){return b(a,q.all)};b.settle=function(a){return b(a,q.settle)};b.any=c(q.any);b.some=c(q.some);b.race=c(q.race);b.map=function(a,c){return b(a,function(a){return q.map(a,c)})};b.filter=function(a,c){return b(a,function(a){return q.filter(a,c)})};b.reduce=c(q.reduce);b.reduceRight=c(q.reduceRight);b.isPromiseLike=function(a){return a&&"function"===typeof a.then};
b.Promise=q;b.defer=function(){return new g};b.TimeoutError=K;return b})})(function(b){l.exports=b(f)})},{"./lib/Promise":100,"./lib/TimeoutError":102,"./lib/apply":103,"./lib/decorators/array":104,"./lib/decorators/flow":105,"./lib/decorators/fold":106,"./lib/decorators/inspect":107,"./lib/decorators/iterate":108,"./lib/decorators/progress":109,"./lib/decorators/timed":110,"./lib/decorators/unhandledRejection":111,"./lib/decorators/with":112}],124:[function(f,l,h){l.exports={name:"autobahn",version:"17.5.1",
description:"An implementation of The Web Application Messaging Protocol (WAMP).",main:"index.js",scripts:{test:"nodeunit test/test.js"},engines:{node:">= 4.2.6"},dependencies:{"crypto-js":">= 3.1.8","int64-buffer":">= 0.1.9","msgpack-lite":">= 0.1.26",cbor:">= 3.0.0",tweetnacl:">= 0.14.3",when:">= 3.7.7",ws:">= 1.1.4"},optionalDependencies:{bufferutil:">= 1.2.1","utf-8-validate":">= 1.2.1"},devDependencies:{browserify:">= 13.1.1","deep-equal":">= 1.0.1","google-closure-compiler":"^20170218.0.0",
nodeunit:">= 0.10.2"},browser:{ws:!1,"lib/transport/rawsocket.js":!1},repository:{type:"git",url:"git://github.com/crossbario/autobahn-js.git"},keywords:["WAMP","WebSocket","RPC","PubSub"],author:"Crossbar.io Technologies GmbH",license:"MIT"}},{}],125:[function(f,l,h){},{}],126:[function(f,l,h){function b(a){var b=a.length;if(0<b%4)throw Error("Invalid string. Length must be a multiple of 4");return"="===a[b-2]?2:"="===a[b-1]?1:0}function a(a,b,c){for(var f=[],d=b;d<c;d+=3)b=(a[d]<<16)+(a[d+1]<<8)+
a[d+2],f.push(e[b>>18&63]+e[b>>12&63]+e[b>>6&63]+e[b&63]);return f.join("")}h.byteLength=function(a){return 3*a.length/4-b(a)};h.toByteArray=function(a){var e=a.length;var f=b(a);var g=new n(3*e/4-f);var d=0<f?e-4:e;var h=0;for(e=0;e<d;e+=4){var l=c[a.charCodeAt(e)]<<18|c[a.charCodeAt(e+1)]<<12|c[a.charCodeAt(e+2)]<<6|c[a.charCodeAt(e+3)];g[h++]=l>>16&255;g[h++]=l>>8&255;g[h++]=l&255}2===f?(l=c[a.charCodeAt(e)]<<2|c[a.charCodeAt(e+1)]>>4,g[h++]=l&255):1===f&&(l=c[a.charCodeAt(e)]<<10|c[a.charCodeAt(e+
1)]<<4|c[a.charCodeAt(e+2)]>>2,g[h++]=l>>8&255,g[h++]=l&255);return g};h.fromByteArray=function(b){for(var c=b.length,f=c%3,g="",d=[],h=0,n=c-f;h<n;h+=16383)d.push(a(b,h,h+16383>n?n:h+16383));1===f?(b=b[c-1],g+=e[b>>2],g+=e[b<<4&63],g+="=="):2===f&&(b=(b[c-2]<<8)+b[c-1],g+=e[b>>10],g+=e[b>>4&63],g+=e[b<<2&63],g+="=");d.push(g);return d.join("")};var e=[],c=[],n="undefined"!==typeof Uint8Array?Uint8Array:Array;for(f=0;64>f;++f)e[f]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[f],
c["ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charCodeAt(f)]=f;c[45]=62;c[95]=63},{}],127:[function(f,l,h){arguments[4][125][0].apply(h,arguments)},{dup:125}],128:[function(f,l,h){(function(b){var a=f("buffer"),e=a.Buffer,c=a.SlowBuffer,n=a.kMaxLength||2147483647;h.alloc=function(a,b,c){if("function"===typeof e.alloc)return e.alloc(a,b,c);if("number"===typeof c)throw new TypeError("encoding must not be number");if("number"!==typeof a)throw new TypeError("size must be a number");
if(a>n)throw new RangeError("size is too large");var f=b;void 0===f&&(c=void 0,f=0);b=new e(a);if("string"===typeof f){c=new e(f,c);for(var f=c.length,d=-1;++d<a;)b[d]=c[d%f]}else b.fill(f);return b};h.allocUnsafe=function(a){if("function"===typeof e.allocUnsafe)return e.allocUnsafe(a);if("number"!==typeof a)throw new TypeError("size must be a number");if(a>n)throw new RangeError("size is too large");return new e(a)};h.from=function(a,c,f){if("function"===typeof e.from&&(!b.Uint8Array||Uint8Array.from!==
e.from))return e.from(a,c,f);if("number"===typeof a)throw new TypeError('"value" argument must not be a number');if("string"===typeof a)return new e(a,c);if("undefined"!==typeof ArrayBuffer&&a instanceof ArrayBuffer){var g=c;if(1===arguments.length)return new e(a);"undefined"===typeof g&&(g=0);var d=f;"undefined"===typeof d&&(d=a.byteLength-g);if(g>=a.byteLength)throw new RangeError("'offset' is out of bounds");if(d>a.byteLength-g)throw new RangeError("'length' is out of bounds");return new e(a.slice(g,
g+d))}if(e.isBuffer(a))return g=new e(a.length),a.copy(g,0,0,a.length),g;if(a){if(Array.isArray(a)||"undefined"!==typeof ArrayBuffer&&a.buffer instanceof ArrayBuffer||"length"in a)return new e(a);if("Buffer"===a.type&&Array.isArray(a.data))return new e(a.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.");};h.allocUnsafeSlow=function(a){if("function"===typeof e.allocUnsafeSlow)return e.allocUnsafeSlow(a);if("number"!==typeof a)throw new TypeError("size must be a number");
if(a>=n)throw new RangeError("size is too large");return new c(a)}}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{buffer:129}],129:[function(f,l,h){function b(b){if(b>N)throw new RangeError("Invalid typed array length");b=new Uint8Array(b);b.__proto__=a.prototype;return b}function a(a,b,c){if("number"===typeof a){if("string"===typeof b)throw Error("If encoding is specified then the first argument must be a string");return n(a)}return e(a,
b,c)}function e(c,d,e){if("number"===typeof c)throw new TypeError('"value" argument must not be a number');if(c instanceof ArrayBuffer){if(0>d||c.byteLength<d)throw new RangeError("'offset' is out of bounds");if(c.byteLength<d+(e||0))throw new RangeError("'length' is out of bounds");c=void 0===d&&void 0===e?new Uint8Array(c):void 0===e?new Uint8Array(c,d):new Uint8Array(c,d,e);c.__proto__=a.prototype;return c}if("string"===typeof c){var f=d;if("string"!==typeof f||""===f)f="utf8";if(!a.isEncoding(f))throw new TypeError('"encoding" must be a valid string encoding');
d=v(c,f)|0;e=b(d);c=e.write(c,f);c!==d&&(e=e.slice(0,c));return e}return p(c)}function c(a){if("number"!==typeof a)throw new TypeError('"size" argument must be a number');if(0>a)throw new RangeError('"size" argument must not be negative');}function n(a){c(a);return b(0>a?0:k(a)|0)}function g(a){for(var c=0>a.length?0:k(a.length)|0,d=b(c),e=0;e<c;e+=1)d[e]=a[e]&255;return d}function p(c){if(a.isBuffer(c)){var d=k(c.length)|0,e=b(d);if(0===e.length)return e;c.copy(e,0,0,d);return e}if(c){if(ArrayBuffer.isView(c)||
"length"in c)return(d="number"!==typeof c.length)||(d=c.length,d=d!==d),d?b(0):g(c);if("Buffer"===c.type&&Array.isArray(c.data))return g(c.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.");}function k(a){if(a>=N)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+N.toString(16)+" bytes");return a|0}function v(b,c){if(a.isBuffer(b))return b.length;if(ArrayBuffer.isView(b)||b instanceof ArrayBuffer)return b.byteLength;
"string"!==typeof b&&(b=""+b);var d=b.length;if(0===d)return 0;for(var e=!1;;)switch(c){case "ascii":case "latin1":case "binary":return d;case "utf8":case "utf-8":case void 0:return G(b).length;case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":return 2*d;case "hex":return d>>>1;case "base64":return F.toByteArray(E(b)).length;default:if(e)return G(b).length;c=(""+c).toLowerCase();e=!0}}function d(a,b,c){var d=!1;if(void 0===b||0>b)b=0;if(b>this.length)return"";if(void 0===c||c>this.length)c=
this.length;if(0>=c)return"";c>>>=0;b>>>=0;if(c<=b)return"";for(a||(a="utf8");;)switch(a){case "hex":a=b;b=c;c=this.length;if(!a||0>a)a=0;if(!b||0>b||b>c)b=c;d="";for(c=a;c<b;++c)a=d,d=this[c],d=16>d?"0"+d.toString(16):d.toString(16),d=a+d;return d;case "utf8":case "utf-8":return C(this,b,c);case "ascii":a="";for(c=Math.min(this.length,c);b<c;++b)a+=String.fromCharCode(this[b]&127);return a;case "latin1":case "binary":a="";for(c=Math.min(this.length,c);b<c;++b)a+=String.fromCharCode(this[b]);return a;
case "base64":return b=0===b&&c===this.length?F.fromByteArray(this):F.fromByteArray(this.slice(b,c)),b;case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":b=this.slice(b,c);c="";for(a=0;a<b.length;a+=2)c+=String.fromCharCode(b[a]+256*b[a+1]);return c;default:if(d)throw new TypeError("Unknown encoding: "+a);a=(a+"").toLowerCase();d=!0}}function t(a,b,c){var d=a[b];a[b]=a[c];a[c]=d}function B(b,c,d,e,f){if(0===b.length)return-1;"string"===typeof d?(e=d,d=0):2147483647<d?d=2147483647:-2147483648>
d&&(d=-2147483648);d=+d;isNaN(d)&&(d=f?0:b.length-1);0>d&&(d=b.length+d);if(d>=b.length){if(f)return-1;d=b.length-1}else if(0>d)if(f)d=0;else return-1;"string"===typeof c&&(c=a.from(c,e));if(a.isBuffer(c))return 0===c.length?-1:z(b,c,d,e,f);if("number"===typeof c)return c&=255,"function"===typeof Uint8Array.prototype.indexOf?f?Uint8Array.prototype.indexOf.call(b,c,d):Uint8Array.prototype.lastIndexOf.call(b,c,d):z(b,[c],d,e,f);throw new TypeError("val must be string, number or Buffer");}function z(a,
b,c,d,e){function f(a,b){return 1===g?a[b]:a.readUInt16BE(b*g)}var g=1,m=a.length,h=b.length;if(void 0!==d&&(d=String(d).toLowerCase(),"ucs2"===d||"ucs-2"===d||"utf16le"===d||"utf-16le"===d)){if(2>a.length||2>b.length)return-1;g=2;m/=2;h/=2;c/=2}if(e)for(d=-1;c<m;c++)if(f(a,c)===f(b,-1===d?0:c-d)){if(-1===d&&(d=c),c-d+1===h)return d*g}else-1!==d&&(c-=c-d),d=-1;else for(c+h>m&&(c=m-h);0<=c;c--){m=!0;for(d=0;d<h;d++)if(f(a,c+d)!==f(b,d)){m=!1;break}if(m)return c}return-1}function C(a,b,c){c=Math.min(a.length,
c);for(var d=[];b<c;){var e=a[b],f=null,g=239<e?4:223<e?3:191<e?2:1;if(b+g<=c)switch(g){case 1:128>e&&(f=e);break;case 2:var m=a[b+1];128===(m&192)&&(e=(e&31)<<6|m&63,127<e&&(f=e));break;case 3:m=a[b+1];var h=a[b+2];128===(m&192)&&128===(h&192)&&(e=(e&15)<<12|(m&63)<<6|h&63,2047<e&&(55296>e||57343<e)&&(f=e));break;case 4:m=a[b+1];h=a[b+2];var r=a[b+3];128===(m&192)&&128===(h&192)&&128===(r&192)&&(e=(e&15)<<18|(m&63)<<12|(h&63)<<6|r&63,65535<e&&1114112>e&&(f=e))}null===f?(f=65533,g=1):65535<f&&(f-=
65536,d.push(f>>>10&1023|55296),f=56320|f&1023);d.push(f);b+=g}a=d.length;if(a<=I)d=String.fromCharCode.apply(String,d);else{c="";for(b=0;b<a;)c+=String.fromCharCode.apply(String,d.slice(b,b+=I));d=c}return d}function y(a,b,c){if(0!==a%1||0>a)throw new RangeError("offset is not uint");if(a+b>c)throw new RangeError("Trying to access beyond buffer length");}function K(b,c,d,e,f,g){if(!a.isBuffer(b))throw new TypeError('"buffer" argument must be a Buffer instance');if(c>f||c<g)throw new RangeError('"value" argument is out of bounds');
if(d+e>b.length)throw new RangeError("Index out of range");}function q(a,b,c,d,e,f){if(c+d>a.length)throw new RangeError("Index out of range");if(0>c)throw new RangeError("Index out of range");}function L(a,b,c,d,e){b=+b;c>>>=0;e||q(a,b,c,4,3.4028234663852886E38,-3.4028234663852886E38);M.write(a,b,c,d,23,4);return c+4}function x(a,b,c,d,e){b=+b;c>>>=0;e||q(a,b,c,8,1.7976931348623157E308,-1.7976931348623157E308);M.write(a,b,c,d,52,8);return c+8}function E(a){a=a.trim?a.trim():a.replace(/^\s+|\s+$/g,
"");a=a.replace(D,"");if(2>a.length)return"";for(;0!==a.length%4;)a+="=";return a}function G(a,b){b=b||Infinity;for(var c,d=a.length,e=null,f=[],g=0;g<d;++g){c=a.charCodeAt(g);if(55295<c&&57344>c){if(!e){if(56319<c){-1<(b-=3)&&f.push(239,191,189);continue}else if(g+1===d){-1<(b-=3)&&f.push(239,191,189);continue}e=c;continue}if(56320>c){-1<(b-=3)&&f.push(239,191,189);e=c;continue}c=(e-55296<<10|c-56320)+65536}else e&&-1<(b-=3)&&f.push(239,191,189);e=null;if(128>c){if(0>--b)break;f.push(c)}else if(2048>
c){if(0>(b-=2))break;f.push(c>>6|192,c&63|128)}else if(65536>c){if(0>(b-=3))break;f.push(c>>12|224,c>>6&63|128,c&63|128)}else if(1114112>c){if(0>(b-=4))break;f.push(c>>18|240,c>>12&63|128,c>>6&63|128,c&63|128)}else throw Error("Invalid code point");}return f}function J(a){for(var b=[],c=0;c<a.length;++c)b.push(a.charCodeAt(c)&255);return b}function Q(a,b,c,d){for(var e=0;e<d&&!(e+c>=b.length||e>=a.length);++e)b[e+c]=a[e];return e}var F=f("base64-js"),M=f("ieee754");h.Buffer=a;h.SlowBuffer=function(b){+b!=
b&&(b=0);return a.alloc(+b)};h.INSPECT_MAX_BYTES=50;var N=2147483647;h.kMaxLength=N;a.TYPED_ARRAY_SUPPORT=function(){try{var a=new Uint8Array(1);a.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}};return 42===a.foo()}catch(m){return!1}}();a.TYPED_ARRAY_SUPPORT||"undefined"===typeof console||"function"!==typeof console.error||console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support.");
$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();"undefined"!==typeof Symbol&&Symbol.species&&a[Symbol.species]===a&&($jscomp.initSymbol(),Object.defineProperty(a,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1}));a.poolSize=8192;a.from=function(a,b,c){return e(a,b,c)};a.prototype.__proto__=Uint8Array.prototype;a.__proto__=Uint8Array;a.alloc=function(a,d,e){c(a);a=0>=a?b(a):void 0!==d?"string"===typeof e?b(a).fill(d,e):b(a).fill(d):b(a);return a};a.allocUnsafe=function(a){return n(a)};
a.allocUnsafeSlow=function(a){return n(a)};a.isBuffer=function(a){return null!=a&&!0===a._isBuffer};a.compare=function(b,c){if(!a.isBuffer(b)||!a.isBuffer(c))throw new TypeError("Arguments must be Buffers");if(b===c)return 0;for(var d=b.length,e=c.length,f=0,g=Math.min(d,e);f<g;++f)if(b[f]!==c[f]){d=b[f];e=c[f];break}return d<e?-1:e<d?1:0};a.isEncoding=function(a){switch(String(a).toLowerCase()){case "hex":case "utf8":case "utf-8":case "ascii":case "latin1":case "binary":case "base64":case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":return!0;
default:return!1}};a.concat=function(b,c){if(!Array.isArray(b))throw new TypeError('"list" argument must be an Array of Buffers');if(0===b.length)return a.alloc(0);var d;if(void 0===c)for(d=c=0;d<b.length;++d)c+=b[d].length;var e=a.allocUnsafe(c),f=0;for(d=0;d<b.length;++d){var g=b[d];if(!a.isBuffer(g))throw new TypeError('"list" argument must be an Array of Buffers');g.copy(e,f);f+=g.length}return e};a.byteLength=v;a.prototype._isBuffer=!0;a.prototype.swap16=function(){var a=this.length;if(0!==a%
2)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var b=0;b<a;b+=2)t(this,b,b+1);return this};a.prototype.swap32=function(){var a=this.length;if(0!==a%4)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var b=0;b<a;b+=4)t(this,b,b+3),t(this,b+1,b+2);return this};a.prototype.swap64=function(){var a=this.length;if(0!==a%8)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var b=0;b<a;b+=8)t(this,b,b+7),t(this,b+1,b+6),t(this,b+2,b+5),t(this,
b+3,b+4);return this};a.prototype.toString=function(){var a=this.length;return 0===a?"":0===arguments.length?C(this,0,a):d.apply(this,arguments)};a.prototype.equals=function(b){if(!a.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b?!0:0===a.compare(this,b)};a.prototype.inspect=function(){var a="",b=h.INSPECT_MAX_BYTES;0<this.length&&(a=this.toString("hex",0,b).match(/.{2}/g).join(" "),this.length>b&&(a+=" ... "));return"<Buffer "+a+">"};a.prototype.compare=function(b,c,
d,e,f){if(!a.isBuffer(b))throw new TypeError("Argument must be a Buffer");void 0===c&&(c=0);void 0===d&&(d=b?b.length:0);void 0===e&&(e=0);void 0===f&&(f=this.length);if(0>c||d>b.length||0>e||f>this.length)throw new RangeError("out of range index");if(e>=f&&c>=d)return 0;if(e>=f)return-1;if(c>=d)return 1;c>>>=0;d>>>=0;e>>>=0;f>>>=0;if(this===b)return 0;var g=f-e,m=d-c,h=Math.min(g,m);e=this.slice(e,f);b=b.slice(c,d);for(c=0;c<h;++c)if(e[c]!==b[c]){g=e[c];m=b[c];break}return g<m?-1:m<g?1:0};a.prototype.includes=
function(a,b,c){return-1!==this.indexOf(a,b,c)};a.prototype.indexOf=function(a,b,c){return B(this,a,b,c,!0)};a.prototype.lastIndexOf=function(a,b,c){return B(this,a,b,c,!1)};a.prototype.write=function(a,b,c,d){if(void 0===b)d="utf8",c=this.length,b=0;else if(void 0===c&&"string"===typeof b)d=b,c=this.length,b=0;else if(isFinite(b))b>>>=0,isFinite(c)?(c>>>=0,void 0===d&&(d="utf8")):(d=c,c=void 0);else throw Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");var e=this.length-
b;if(void 0===c||c>e)c=e;if(0<a.length&&(0>c||0>b)||b>this.length)throw new RangeError("Attempt to write outside buffer bounds");d||(d="utf8");for(e=!1;;)switch(d){case "hex":a:{b=Number(b)||0;d=this.length-b;c?(c=Number(c),c>d&&(c=d)):c=d;d=a.length;if(0!==d%2)throw new TypeError("Invalid hex string");c>d/2&&(c=d/2);for(d=0;d<c;++d){e=parseInt(a.substr(2*d,2),16);if(isNaN(e)){a=d;break a}this[b+d]=e}a=d}return a;case "utf8":case "utf-8":return Q(G(a,this.length-b),this,b,c);case "ascii":return Q(J(a),
this,b,c);case "latin1":case "binary":return Q(J(a),this,b,c);case "base64":return Q(F.toByteArray(E(a)),this,b,c);case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":d=a;for(var e=this.length-b,f=[],g=0;g<d.length&&!(0>(e-=2));++g){var m=d.charCodeAt(g);a=m>>8;m%=256;f.push(m);f.push(a)}return Q(f,this,b,c);default:if(e)throw new TypeError("Unknown encoding: "+d);d=(""+d).toLowerCase();e=!0}};a.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};
var I=4096;a.prototype.slice=function(b,c){var d=this.length;b=~~b;c=void 0===c?d:~~c;0>b?(b+=d,0>b&&(b=0)):b>d&&(b=d);0>c?(c+=d,0>c&&(c=0)):c>d&&(c=d);c<b&&(c=b);d=this.subarray(b,c);d.__proto__=a.prototype;return d};a.prototype.readUIntLE=function(a,b,c){a>>>=0;b>>>=0;c||y(a,b,this.length);c=this[a];for(var d=1,e=0;++e<b&&(d*=256);)c+=this[a+e]*d;return c};a.prototype.readUIntBE=function(a,b,c){a>>>=0;b>>>=0;c||y(a,b,this.length);c=this[a+--b];for(var d=1;0<b&&(d*=256);)c+=this[a+--b]*d;return c};
a.prototype.readUInt8=function(a,b){a>>>=0;b||y(a,1,this.length);return this[a]};a.prototype.readUInt16LE=function(a,b){a>>>=0;b||y(a,2,this.length);return this[a]|this[a+1]<<8};a.prototype.readUInt16BE=function(a,b){a>>>=0;b||y(a,2,this.length);return this[a]<<8|this[a+1]};a.prototype.readUInt32LE=function(a,b){a>>>=0;b||y(a,4,this.length);return(this[a]|this[a+1]<<8|this[a+2]<<16)+16777216*this[a+3]};a.prototype.readUInt32BE=function(a,b){a>>>=0;b||y(a,4,this.length);return 16777216*this[a]+(this[a+
1]<<16|this[a+2]<<8|this[a+3])};a.prototype.readIntLE=function(a,b,c){a>>>=0;b>>>=0;c||y(a,b,this.length);c=this[a];for(var d=1,e=0;++e<b&&(d*=256);)c+=this[a+e]*d;c>=128*d&&(c-=Math.pow(2,8*b));return c};a.prototype.readIntBE=function(a,b,c){a>>>=0;b>>>=0;c||y(a,b,this.length);c=b;for(var d=1,e=this[a+--c];0<c&&(d*=256);)e+=this[a+--c]*d;e>=128*d&&(e-=Math.pow(2,8*b));return e};a.prototype.readInt8=function(a,b){a>>>=0;b||y(a,1,this.length);return this[a]&128?-1*(255-this[a]+1):this[a]};a.prototype.readInt16LE=
function(a,b){a>>>=0;b||y(a,2,this.length);var c=this[a]|this[a+1]<<8;return c&32768?c|4294901760:c};a.prototype.readInt16BE=function(a,b){a>>>=0;b||y(a,2,this.length);var c=this[a+1]|this[a]<<8;return c&32768?c|4294901760:c};a.prototype.readInt32LE=function(a,b){a>>>=0;b||y(a,4,this.length);return this[a]|this[a+1]<<8|this[a+2]<<16|this[a+3]<<24};a.prototype.readInt32BE=function(a,b){a>>>=0;b||y(a,4,this.length);return this[a]<<24|this[a+1]<<16|this[a+2]<<8|this[a+3]};a.prototype.readFloatLE=function(a,
b){a>>>=0;b||y(a,4,this.length);return M.read(this,a,!0,23,4)};a.prototype.readFloatBE=function(a,b){a>>>=0;b||y(a,4,this.length);return M.read(this,a,!1,23,4)};a.prototype.readDoubleLE=function(a,b){a>>>=0;b||y(a,8,this.length);return M.read(this,a,!0,52,8)};a.prototype.readDoubleBE=function(a,b){a>>>=0;b||y(a,8,this.length);return M.read(this,a,!1,52,8)};a.prototype.writeUIntLE=function(a,b,c,d){a=+a;b>>>=0;c>>>=0;d||K(this,a,b,c,Math.pow(2,8*c)-1,0);d=1;var e=0;for(this[b]=a&255;++e<c&&(d*=256);)this[b+
e]=a/d&255;return b+c};a.prototype.writeUIntBE=function(a,b,c,d){a=+a;b>>>=0;c>>>=0;d||K(this,a,b,c,Math.pow(2,8*c)-1,0);d=c-1;var e=1;for(this[b+d]=a&255;0<=--d&&(e*=256);)this[b+d]=a/e&255;return b+c};a.prototype.writeUInt8=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,1,255,0);this[b]=a&255;return b+1};a.prototype.writeUInt16LE=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,2,65535,0);this[b]=a&255;this[b+1]=a>>>8;return b+2};a.prototype.writeUInt16BE=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,2,65535,0);
this[b]=a>>>8;this[b+1]=a&255;return b+2};a.prototype.writeUInt32LE=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,4,4294967295,0);this[b+3]=a>>>24;this[b+2]=a>>>16;this[b+1]=a>>>8;this[b]=a&255;return b+4};a.prototype.writeUInt32BE=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,4,4294967295,0);this[b]=a>>>24;this[b+1]=a>>>16;this[b+2]=a>>>8;this[b+3]=a&255;return b+4};a.prototype.writeIntLE=function(a,b,c,d){a=+a;b>>>=0;d||(d=Math.pow(2,8*c-1),K(this,a,b,c,d-1,-d));d=0;var e=1,f=0;for(this[b]=a&255;++d<c&&
(e*=256);)0>a&&0===f&&0!==this[b+d-1]&&(f=1),this[b+d]=(a/e>>0)-f&255;return b+c};a.prototype.writeIntBE=function(a,b,c,d){a=+a;b>>>=0;d||(d=Math.pow(2,8*c-1),K(this,a,b,c,d-1,-d));d=c-1;var e=1,f=0;for(this[b+d]=a&255;0<=--d&&(e*=256);)0>a&&0===f&&0!==this[b+d+1]&&(f=1),this[b+d]=(a/e>>0)-f&255;return b+c};a.prototype.writeInt8=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,1,127,-128);0>a&&(a=255+a+1);this[b]=a&255;return b+1};a.prototype.writeInt16LE=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,2,32767,
-32768);this[b]=a&255;this[b+1]=a>>>8;return b+2};a.prototype.writeInt16BE=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,2,32767,-32768);this[b]=a>>>8;this[b+1]=a&255;return b+2};a.prototype.writeInt32LE=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,4,2147483647,-2147483648);this[b]=a&255;this[b+1]=a>>>8;this[b+2]=a>>>16;this[b+3]=a>>>24;return b+4};a.prototype.writeInt32BE=function(a,b,c){a=+a;b>>>=0;c||K(this,a,b,4,2147483647,-2147483648);0>a&&(a=4294967295+a+1);this[b]=a>>>24;this[b+1]=a>>>16;this[b+2]=
a>>>8;this[b+3]=a&255;return b+4};a.prototype.writeFloatLE=function(a,b,c){return L(this,a,b,!0,c)};a.prototype.writeFloatBE=function(a,b,c){return L(this,a,b,!1,c)};a.prototype.writeDoubleLE=function(a,b,c){return x(this,a,b,!0,c)};a.prototype.writeDoubleBE=function(a,b,c){return x(this,a,b,!1,c)};a.prototype.copy=function(a,b,c,d){c||(c=0);d||0===d||(d=this.length);b>=a.length&&(b=a.length);b||(b=0);0<d&&d<c&&(d=c);if(d===c||0===a.length||0===this.length)return 0;if(0>b)throw new RangeError("targetStart out of bounds");
if(0>c||c>=this.length)throw new RangeError("sourceStart out of bounds");if(0>d)throw new RangeError("sourceEnd out of bounds");d>this.length&&(d=this.length);a.length-b<d-c&&(d=a.length-b+c);var e=d-c;if(this===a&&c<b&&b<d)for(d=e-1;0<=d;--d)a[d+b]=this[d+c];else if(1E3>e)for(d=0;d<e;++d)a[d+b]=this[d+c];else Uint8Array.prototype.set.call(a,this.subarray(c,c+e),b);return e};a.prototype.fill=function(b,c,d,e){if("string"===typeof b){"string"===typeof c?(e=c,c=0,d=this.length):"string"===typeof d&&
(e=d,d=this.length);if(1===b.length){var f=b.charCodeAt(0);256>f&&(b=f)}if(void 0!==e&&"string"!==typeof e)throw new TypeError("encoding must be a string");if("string"===typeof e&&!a.isEncoding(e))throw new TypeError("Unknown encoding: "+e);}else"number"===typeof b&&(b&=255);if(0>c||this.length<c||this.length<d)throw new RangeError("Out of range index");if(d<=c)return this;c>>>=0;d=void 0===d?this.length:d>>>0;b||(b=0);if("number"===typeof b)for(e=c;e<d;++e)this[e]=b;else for(b=a.isBuffer(b)?b:new a(b,
e),f=b.length,e=0;e<d-c;++e)this[e+c]=b[e%f];return this};var D=/[^+/0-9A-Za-z-_]/g},{"base64-js":126,ieee754:132}],130:[function(f,l,h){(function(b){h.isArray=function(a){return Array.isArray?Array.isArray(a):"[object Array]"===Object.prototype.toString.call(a)};h.isBoolean=function(a){return"boolean"===typeof a};h.isNull=function(a){return null===a};h.isNullOrUndefined=function(a){return null==a};h.isNumber=function(a){return"number"===typeof a};h.isString=function(a){return"string"===typeof a};
h.isSymbol=function(a){return"symbol"===typeof a};h.isUndefined=function(a){return void 0===a};h.isRegExp=function(a){return"[object RegExp]"===Object.prototype.toString.call(a)};h.isObject=function(a){return"object"===typeof a&&null!==a};h.isDate=function(a){return"[object Date]"===Object.prototype.toString.call(a)};h.isError=function(a){return"[object Error]"===Object.prototype.toString.call(a)||a instanceof Error};h.isFunction=function(a){return"function"===typeof a};h.isPrimitive=function(a){return null===
a||"boolean"===typeof a||"number"===typeof a||"string"===typeof a||"symbol"===typeof a||"undefined"===typeof a};h.isBuffer=b.isBuffer}).call(this,{isBuffer:f("../../is-buffer/index.js")})},{"../../is-buffer/index.js":134}],131:[function(f,l,h){function b(){this._events=this._events||{};this._maxListeners=this._maxListeners||void 0}function a(a){return"function"===typeof a}function e(a){return"object"===typeof a&&null!==a}l.exports=b;b.EventEmitter=b;b.prototype._events=void 0;b.prototype._maxListeners=
void 0;b.defaultMaxListeners=10;b.prototype.setMaxListeners=function(a){if("number"!==typeof a||0>a||isNaN(a))throw TypeError("n must be a positive number");this._maxListeners=a;return this};b.prototype.emit=function(b){var c;this._events||(this._events={});if("error"===b&&(!this._events.error||e(this._events.error)&&!this._events.error.length)){var f=arguments[1];if(f instanceof Error)throw f;var h=Error('Uncaught, unspecified "error" event. ('+f+")");h.context=f;throw h;}h=this._events[b];if(void 0===
h)return!1;if(a(h))switch(arguments.length){case 1:h.call(this);break;case 2:h.call(this,arguments[1]);break;case 3:h.call(this,arguments[1],arguments[2]);break;default:f=Array.prototype.slice.call(arguments,1),h.apply(this,f)}else if(e(h)){f=Array.prototype.slice.call(arguments,1);var k=h.slice();h=k.length;for(c=0;c<h;c++)k[c].apply(this,f)}return!0};b.prototype.addListener=function(c,f){var g;if(!a(f))throw TypeError("listener must be a function");this._events||(this._events={});this._events.newListener&&
this.emit("newListener",c,a(f.listener)?f.listener:f);this._events[c]?e(this._events[c])?this._events[c].push(f):this._events[c]=[this._events[c],f]:this._events[c]=f;e(this._events[c])&&!this._events[c].warned&&(g=void 0!==this._maxListeners?this._maxListeners:b.defaultMaxListeners)&&0<g&&this._events[c].length>g&&(this._events[c].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[c].length),
"function"===typeof console.trace&&console.trace());return this};b.prototype.on=b.prototype.addListener;b.prototype.once=function(b,e){function c(){this.removeListener(b,c);f||(f=!0,e.apply(this,arguments))}if(!a(e))throw TypeError("listener must be a function");var f=!1;c.listener=e;this.on(b,c);return this};b.prototype.removeListener=function(b,f){if(!a(f))throw TypeError("listener must be a function");if(!this._events||!this._events[b])return this;var c=this._events[b];var h=c.length;var k=-1;
if(c===f||a(c.listener)&&c.listener===f)delete this._events[b],this._events.removeListener&&this.emit("removeListener",b,f);else if(e(c)){for(;0<h--;)if(c[h]===f||c[h].listener&&c[h].listener===f){k=h;break}if(0>k)return this;1===c.length?(c.length=0,delete this._events[b]):c.splice(k,1);this._events.removeListener&&this.emit("removeListener",b,f)}return this};b.prototype.removeAllListeners=function(b){if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events=
{}:this._events[b]&&delete this._events[b],this;if(0===arguments.length){for(c in this._events)"removeListener"!==c&&this.removeAllListeners(c);this.removeAllListeners("removeListener");this._events={};return this}var c=this._events[b];if(a(c))this.removeListener(b,c);else if(c)for(;c.length;)this.removeListener(b,c[c.length-1]);delete this._events[b];return this};b.prototype.listeners=function(b){return this._events&&this._events[b]?a(this._events[b])?[this._events[b]]:this._events[b].slice():[]};
b.prototype.listenerCount=function(b){if(this._events){b=this._events[b];if(a(b))return 1;if(b)return b.length}return 0};b.listenerCount=function(a,b){return a.listenerCount(b)}},{}],132:[function(f,l,h){arguments[4][67][0].apply(h,arguments)},{dup:67}],133:[function(f,l,h){l.exports="function"===typeof Object.create?function(b,a){b.super_=a;b.prototype=Object.create(a.prototype,{constructor:{value:b,enumerable:!1,writable:!0,configurable:!0}})}:function(b,a){b.super_=a;var e=function(){};e.prototype=
a.prototype;b.prototype=new e;b.prototype.constructor=b}},{}],134:[function(f,l,h){function b(a){return!!a.constructor&&"function"===typeof a.constructor.isBuffer&&a.constructor.isBuffer(a)}l.exports=function(a){return null!=a&&(b(a)||"function"===typeof a.readFloatLE&&"function"===typeof a.slice&&b(a.slice(0,0))||!!a._isBuffer)}},{}],135:[function(f,l,h){arguments[4][69][0].apply(h,arguments)},{dup:69}],136:[function(f,l,h){(function(b){function a(a,c,f,g){if("function"!==typeof a)throw new TypeError('"callback" argument must be a function');
var e=arguments.length;switch(e){case 0:case 1:return b.nextTick(a);case 2:return b.nextTick(function(){a.call(null,c)});case 3:return b.nextTick(function(){a.call(null,c,f)});case 4:return b.nextTick(function(){a.call(null,c,f,g)});default:var h=Array(e-1);for(e=0;e<h.length;)h[e++]=arguments[e];return b.nextTick(function(){a.apply(null,h)})}}!b.version||0===b.version.indexOf("v0.")||0===b.version.indexOf("v1.")&&0!==b.version.indexOf("v1.8.")?l.exports=a:l.exports=b.nextTick}).call(this,f("_process"))},
{_process:137}],137:[function(f,l,h){function b(){throw Error("setTimeout has not been defined");}function a(){throw Error("clearTimeout has not been defined");}function e(a){if(v===setTimeout)return setTimeout(a,0);if((v===b||!v)&&setTimeout)return v=setTimeout,setTimeout(a,0);try{return v(a,0)}catch(K){try{return v.call(null,a,0)}catch(q){return v.call(this,a,0)}}}function c(b){if(d===clearTimeout)return clearTimeout(b);if((d===a||!d)&&clearTimeout)return d=clearTimeout,clearTimeout(b);try{return d(b)}catch(K){try{return d.call(null,
b)}catch(q){return d.call(this,b)}}}function n(){B&&z&&(B=!1,z.length?t=z.concat(t):C=-1,t.length&&g())}function g(){if(!B){var a=e(n);B=!0;for(var b=t.length;b;){z=t;for(t=[];++C<b;)z&&z[C].run();C=-1;b=t.length}z=null;B=!1;c(a)}}function p(a,b){this.fun=a;this.array=b}function k(){}f=l.exports={};try{var v="function"===typeof setTimeout?setTimeout:b}catch(y){v=b}try{var d="function"===typeof clearTimeout?clearTimeout:a}catch(y){d=a}var t=[],B=!1,z,C=-1;f.nextTick=function(a){var b=Array(arguments.length-
1);if(1<arguments.length)for(var c=1;c<arguments.length;c++)b[c-1]=arguments[c];t.push(new p(a,b));1!==t.length||B||e(g)};p.prototype.run=function(){this.fun.apply(null,this.array)};f.title="browser";f.browser=!0;f.env={};f.argv=[];f.version="";f.versions={};f.on=k;f.addListener=k;f.once=k;f.off=k;f.removeListener=k;f.removeAllListeners=k;f.emit=k;f.binding=function(a){throw Error("process.binding is not supported");};f.cwd=function(){return"/"};f.chdir=function(a){throw Error("process.chdir is not supported");
};f.umask=function(){return 0}},{}],138:[function(f,l,h){(function(b){(function(a){function e(a){throw new RangeError(L[a]);}function c(a,b){for(var c=a.length,d=[];c--;)d[c]=b(a[c]);return d}function f(a,b){var d=a.split("@"),e="";1<d.length&&(e=d[0]+"@",a=d[1]);a=a.replace(q,".");d=a.split(".");d=c(d,b).join(".");return e+d}function g(a){for(var b=[],c=0,d=a.length,e,f;c<d;)e=a.charCodeAt(c++),55296<=e&&56319>=e&&c<d?(f=a.charCodeAt(c++),56320==(f&64512)?b.push(((e&1023)<<10)+(f&1023)+65536):(b.push(e),
c--)):b.push(e);return b}function p(a){return c(a,function(a){var b="";65535<a&&(a-=65536,b+=E(a>>>10&1023|55296),a=56320|a&1023);return b+=E(a)}).join("")}function k(a,b){return a+22+75*(26>a)-((0!=b)<<5)}function v(a,b,c){var d=0;a=c?x(a/700):a>>1;for(a+=x(a/b);455<a;d+=36)a=x(a/35);return x(d+36*a/(a+38))}function d(a){var b=[],c=a.length,d=0,f=128,g=72,h,k;var m=a.lastIndexOf("-");0>m&&(m=0);for(h=0;h<m;++h)128<=a.charCodeAt(h)&&e("not-basic"),b.push(a.charCodeAt(h));for(m=0<m?m+1:0;m<c;){h=d;
var n=1;for(k=36;;k+=36){m>=c&&e("invalid-input");var l=a.charCodeAt(m++);l=10>l-48?l-22:26>l-65?l-65:26>l-97?l-97:36;(36<=l||l>x((2147483647-d)/n))&&e("overflow");d+=l*n;var q=k<=g?1:k>=g+26?26:k-g;if(l<q)break;l=36-q;n>x(2147483647/l)&&e("overflow");n*=l}n=b.length+1;g=v(d-h,n,0==h);x(d/n)>2147483647-f&&e("overflow");f+=x(d/n);d%=n;b.splice(d++,0,f)}return p(b)}function t(a){var b,c,d,f=[];a=g(a);var h=a.length;var n=128;var l=0;var m=72;for(d=0;d<h;++d){var q=a[d];128>q&&f.push(E(q))}for((b=c=
f.length)&&f.push("-");b<h;){var p=2147483647;for(d=0;d<h;++d)q=a[d],q>=n&&q<p&&(p=q);var t=b+1;p-n>x((2147483647-l)/t)&&e("overflow");l+=(p-n)*t;n=p;for(d=0;d<h;++d)if(q=a[d],q<n&&2147483647<++l&&e("overflow"),q==n){var G=l;for(p=36;;p+=36){q=p<=m?1:p>=m+26?26:p-m;if(G<q)break;var J=G-q;G=36-q;f.push(E(k(q+J%G,0)));G=x(J/G)}f.push(E(k(G,0)));m=v(l,t,b==c);l=0;++b}++l;++n}return f.join("")}var B="object"==typeof h&&h&&!h.nodeType&&h,z="object"==typeof l&&l&&!l.nodeType&&l,C="object"==typeof b&&b;
if(C.global===C||C.window===C||C.self===C)a=C;var y=/^xn--/,K=/[^\x20-\x7E]/,q=/[\x2E\u3002\uFF0E\uFF61]/g,L={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},x=Math.floor,E=String.fromCharCode,G,C={version:"1.4.1",ucs2:{decode:g,encode:p},decode:d,encode:t,toASCII:function(a){return f(a,function(a){return K.test(a)?"xn--"+t(a):a})},toUnicode:function(a){return f(a,function(a){return y.test(a)?
d(a.slice(4).toLowerCase()):a})}};if(B&&z)if(l.exports==B)z.exports=C;else for(G in C)C.hasOwnProperty(G)&&(B[G]=C[G]);else a.punycode=C})(this)}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{}],139:[function(f,l,h){l.exports=function(a,e,c,f){c=c||"=";var g={};if("string"!==typeof a||0===a.length)return g;var h=/\+/g;a=a.split(e||"&");e=1E3;f&&"number"===typeof f.maxKeys&&(e=f.maxKeys);f=a.length;0<e&&f>e&&(f=e);for(e=0;e<f;++e){var k=
a[e].replace(h,"%20"),l=k.indexOf(c);if(0<=l){var d=k.substr(0,l);k=k.substr(l+1)}else d=k,k="";d=decodeURIComponent(d);k=decodeURIComponent(k);Object.prototype.hasOwnProperty.call(g,d)?b(g[d])?g[d].push(k):g[d]=[g[d],k]:g[d]=k}return g};var b=Array.isArray||function(a){return"[object Array]"===Object.prototype.toString.call(a)}},{}],140:[function(f,l,h){function b(a,b){if(a.map)return a.map(b);for(var c=[],e=0;e<a.length;e++)c.push(b(a[e],e));return c}var a=function(a){switch(typeof a){case "string":return a;
case "boolean":return a?"true":"false";case "number":return isFinite(a)?a:"";default:return""}};l.exports=function(f,g,h,k){g=g||"&";h=h||"=";null===f&&(f=void 0);return"object"===typeof f?b(c(f),function(c){var d=encodeURIComponent(a(c))+h;return e(f[c])?b(f[c],function(b){return d+encodeURIComponent(a(b))}).join(g):d+encodeURIComponent(a(f[c]))}).join(g):k?encodeURIComponent(a(k))+h+encodeURIComponent(a(f)):""};var e=Array.isArray||function(a){return"[object Array]"===Object.prototype.toString.call(a)},
c=Object.keys||function(a){var b=[],c;for(c in a)Object.prototype.hasOwnProperty.call(a,c)&&b.push(c);return b}},{}],141:[function(f,l,h){h.decode=h.parse=f("./decode");h.encode=h.stringify=f("./encode")},{"./decode":139,"./encode":140}],142:[function(f,l,h){l.exports=f("./lib/_stream_duplex.js")},{"./lib/_stream_duplex.js":143}],143:[function(f,l,h){function b(c){if(!(this instanceof b))return new b(c);n.call(this,c);g.call(this,c);c&&!1===c.readable&&(this.readable=!1);c&&!1===c.writable&&(this.writable=
!1);this.allowHalfOpen=!0;c&&!1===c.allowHalfOpen&&(this.allowHalfOpen=!1);this.once("end",a)}function a(){this.allowHalfOpen||this._writableState.ended||c(e,this)}function e(a){a.end()}h=Object.keys||function(a){var b=[],c;for(c in a)b.push(c);return b};l.exports=b;var c=f("process-nextick-args");l=f("core-util-is");l.inherits=f("inherits");var n=f("./_stream_readable"),g=f("./_stream_writable");l.inherits(b,n);f=h(g.prototype);for(l=0;l<f.length;l++)h=f[l],b.prototype[h]||(b.prototype[h]=g.prototype[h])},
{"./_stream_readable":145,"./_stream_writable":147,"core-util-is":130,inherits:133,"process-nextick-args":136}],144:[function(f,l,h){function b(e){if(!(this instanceof b))return new b(e);a.call(this,e)}l.exports=b;var a=f("./_stream_transform");l=f("core-util-is");l.inherits=f("inherits");l.inherits(b,a);b.prototype._transform=function(a,b,f){f(null,a)}},{"./_stream_transform":146,"core-util-is":130,inherits:133}],145:[function(f,l,h){(function(b){function a(a,b,c){if("function"===typeof a.prependListener)return a.prependListener(b,
c);if(a._events&&a._events[b])E(a._events[b])?a._events[b].unshift(c):a._events[b]=[c,a._events[b]];else a.on(b,c)}function e(a,b){G=G||f("./_stream_duplex");a=a||{};this.objectMode=!!a.objectMode;b instanceof G&&(this.objectMode=this.objectMode||!!a.readableObjectMode);var c=a.highWaterMark,d=this.objectMode?16:16384;this.highWaterMark=c||0===c?c:d;this.highWaterMark=~~this.highWaterMark;this.buffer=new D;this.length=0;this.pipes=null;this.pipesCount=0;this.flowing=null;this.reading=this.endEmitted=
this.ended=!1;this.sync=!0;this.resumeScheduled=this.readableListening=this.emittedReadable=this.needReadable=!1;this.defaultEncoding=a.defaultEncoding||"utf8";this.ranOut=!1;this.awaitDrain=0;this.readingMore=!1;this.encoding=this.decoder=null;a.encoding&&(u||(u=f("string_decoder/").StringDecoder),this.decoder=new u(a.encoding),this.encoding=a.encoding)}function c(a){G=G||f("./_stream_duplex");if(!(this instanceof c))return new c(a);this._readableState=new e(a,this);this.readable=!0;a&&"function"===
typeof a.read&&(this._read=a.read);J.call(this)}function h(a,b,c,d,e){var f=c;var g=null;Q.isBuffer(f)||"string"===typeof f||null===f||void 0===f||b.objectMode||(g=new TypeError("Invalid non-string/buffer chunk"));if(f=g)a.emit("error",f);else if(null===c)b.reading=!1,b.ended||(b.decoder&&(c=b.decoder.end())&&c.length&&(b.buffer.push(c),b.length+=b.objectMode?1:c.length),b.ended=!0,p(a));else if(b.objectMode||c&&0<c.length)if(b.ended&&!e)a.emit("error",Error("stream.push() after EOF"));else if(b.endEmitted&&
e)a.emit("error",Error("stream.unshift() after end event"));else{if(b.decoder&&!e&&!d){c=b.decoder.write(c);var h=!b.objectMode&&0===c.length}e||(b.reading=!1);h||(b.flowing&&0===b.length&&!b.sync?(a.emit("data",c),a.read(0)):(b.length+=b.objectMode?1:c.length,e?b.buffer.unshift(c):b.buffer.push(c),b.needReadable&&p(a)));b.readingMore||(b.readingMore=!0,x(v,a,b))}else e||(b.reading=!1);return!b.ended&&(b.needReadable||b.length<b.highWaterMark||0===b.length)}function g(a,b){if(0>=a||0===b.length&&
b.ended)return 0;if(b.objectMode)return 1;if(a!==a)return b.flowing&&b.length?b.buffer.head.data.length:b.length;if(a>b.highWaterMark){var c=a;8388608<=c?c=8388608:(c--,c|=c>>>1,c|=c>>>2,c|=c>>>4,c|=c>>>8,c|=c>>>16,c++);b.highWaterMark=c}return a<=b.length?a:b.ended?b.length:(b.needReadable=!0,0)}function p(a){var b=a._readableState;b.needReadable=!1;b.emittedReadable||(I("emitReadable",b.flowing),b.emittedReadable=!0,b.sync?x(k,a):k(a))}function k(a){I("emit readable");a.emit("readable");z(a)}function v(a,
b){for(var c=b.length;!b.reading&&!b.flowing&&!b.ended&&b.length<b.highWaterMark&&(I("maybeReadMore read 0"),a.read(0),c!==b.length);)c=b.length;b.readingMore=!1}function d(a){return function(){var b=a._readableState;I("pipeOnDrain",b.awaitDrain);b.awaitDrain&&b.awaitDrain--;0===b.awaitDrain&&a.listeners("data").length&&(b.flowing=!0,z(a))}}function t(a){I("readable nexttick read 0");a.read(0)}function B(a,b){b.reading||(I("resume read 0"),a.read(0));b.resumeScheduled=!1;b.awaitDrain=0;a.emit("resume");
z(a);b.flowing&&!b.reading&&a.read(0)}function z(a){var b=a._readableState;for(I("flow",b.flowing);b.flowing&&null!==a.read(););}function C(a,b){if(0===b.length)return null;if(b.objectMode)var c=b.buffer.shift();else if(!a||a>=b.length)c=b.decoder?b.buffer.join(""):1===b.buffer.length?b.buffer.head.data:b.buffer.concat(b.length),b.buffer.clear();else{c=b.buffer;var d=b.decoder;if(a<c.head.data.length)d=c.head.data.slice(0,a),c.head.data=c.head.data.slice(a);else{if(a===c.head.data.length)c=c.shift();
else if(d){for(var e=c.head,f=1,g=e.data,d=a-g.length;e=e.next;){var h=e.data,m=d>h.length?h.length:d,g=m===h.length?g+h:g+h.slice(0,d),d=d-m;if(0===d){m===h.length?(++f,c.head=e.next?e.next:c.tail=null):(c.head=e,e.data=h.slice(m));break}++f}c.length-=f;c=g}else{d=a;e=F.allocUnsafe(d);f=c.head;g=1;f.data.copy(e);for(d-=f.data.length;f=f.next;){h=f.data;m=d>h.length?h.length:d;h.copy(e,e.length-d,0,m);d-=m;if(0===d){m===h.length?(++g,c.head=f.next?f.next:c.tail=null):(c.head=f,f.data=h.slice(m));
break}++g}c.length-=g;c=e}d=c}c=d}return c}function y(a){var b=a._readableState;if(0<b.length)throw Error('"endReadable()" called on non-empty stream');b.endEmitted||(b.ended=!0,x(K,b,a))}function K(a,b){a.endEmitted||0!==a.length||(a.endEmitted=!0,b.readable=!1,b.emit("end"))}function q(a,b){for(var c=0,d=a.length;c<d;c++)b(a[c],c)}function L(a,b){for(var c=0,d=a.length;c<d;c++)if(a[c]===b)return c;return-1}l.exports=c;var x=f("process-nextick-args"),E=f("isarray"),G;c.ReadableState=e;f("events");
try{var J=f("stream")}catch(m){}finally{J||(J=f("events").EventEmitter)}var Q=f("buffer").Buffer,F=f("buffer-shims"),M=f("core-util-is");M.inherits=f("inherits");var N=f("util"),I=void 0,I=N&&N.debuglog?N.debuglog("stream"):function(){},D=f("./internal/streams/BufferList"),u;M.inherits(c,J);c.prototype.push=function(a,b){var c=this._readableState;c.objectMode||"string"!==typeof a||(b=b||c.defaultEncoding,b!==c.encoding&&(a=F.from(a,b),b=""));return h(this,c,a,b,!1)};c.prototype.unshift=function(a){return h(this,
this._readableState,a,"",!0)};c.prototype.isPaused=function(){return!1===this._readableState.flowing};c.prototype.setEncoding=function(a){u||(u=f("string_decoder/").StringDecoder);this._readableState.decoder=new u(a);this._readableState.encoding=a;return this};c.prototype.read=function(a){I("read",a);a=parseInt(a,10);var b=this._readableState,c=a;0!==a&&(b.emittedReadable=!1);if(0===a&&b.needReadable&&(b.length>=b.highWaterMark||b.ended))return I("read: emitReadable",b.length,b.ended),0===b.length&&
b.ended?y(this):p(this),null;a=g(a,b);if(0===a&&b.ended)return 0===b.length&&y(this),null;var d=b.needReadable;I("need readable",d);if(0===b.length||b.length-a<b.highWaterMark)d=!0,I("length less than watermark",d);b.ended||b.reading?I("reading or ended",!1):d&&(I("do read"),b.reading=!0,b.sync=!0,0===b.length&&(b.needReadable=!0),this._read(b.highWaterMark),b.sync=!1,b.reading||(a=g(c,b)));d=0<a?C(a,b):null;null===d?(b.needReadable=!0,a=0):b.length-=a;0===b.length&&(b.ended||(b.needReadable=!0),
c!==a&&b.ended&&y(this));null!==d&&this.emit("data",d);return d};c.prototype._read=function(a){this.emit("error",Error("_read() is not implemented"))};c.prototype.pipe=function(c,e){function f(a){I("onunpipe");a===p&&h()}function g(){I("onend");c.end()}function h(){I("cleanup");c.removeListener("close",l);c.removeListener("finish",q);c.removeListener("drain",t);c.removeListener("error",m);c.removeListener("unpipe",f);p.removeListener("end",g);p.removeListener("end",h);p.removeListener("data",k);E=
!0;!r.awaitDrain||c._writableState&&!c._writableState.needDrain||t()}function k(a){I("ondata");G=!1;!1!==c.write(a)||G||((1===r.pipesCount&&r.pipes===c||1<r.pipesCount&&-1!==L(r.pipes,c))&&!E&&(I("false write response, pause",p._readableState.awaitDrain),p._readableState.awaitDrain++,G=!0),p.pause())}function m(a){I("onerror",a);n();c.removeListener("error",m);0===c.listeners("error").length&&c.emit("error",a)}function l(){c.removeListener("finish",q);n()}function q(){I("onfinish");c.removeListener("close",
l);n()}function n(){I("unpipe");p.unpipe(c)}var p=this,r=this._readableState;switch(r.pipesCount){case 0:r.pipes=c;break;case 1:r.pipes=[r.pipes,c];break;default:r.pipes.push(c)}r.pipesCount+=1;I("pipe count=%d opts=%j",r.pipesCount,e);var u=e&&!1===e.end||c===b.stdout||c===b.stderr?h:g;if(r.endEmitted)x(u);else p.once("end",u);c.on("unpipe",f);var t=d(p);c.on("drain",t);var E=!1,G=!1;p.on("data",k);a(c,"error",m);c.once("close",l);c.once("finish",q);c.emit("pipe",p);r.flowing||(I("pipe resume"),
p.resume());return c};c.prototype.unpipe=function(a){var b=this._readableState;if(0===b.pipesCount)return this;if(1===b.pipesCount){if(a&&a!==b.pipes)return this;a||(a=b.pipes);b.pipes=null;b.pipesCount=0;b.flowing=!1;a&&a.emit("unpipe",this);return this}if(!a){a=b.pipes;var c=b.pipesCount;b.pipes=null;b.pipesCount=0;b.flowing=!1;for(b=0;b<c;b++)a[b].emit("unpipe",this);return this}c=L(b.pipes,a);if(-1===c)return this;b.pipes.splice(c,1);--b.pipesCount;1===b.pipesCount&&(b.pipes=b.pipes[0]);a.emit("unpipe",
this);return this};c.prototype.on=function(a,b){var c=J.prototype.on.call(this,a,b);if("data"===a)!1!==this._readableState.flowing&&this.resume();else if("readable"===a){var d=this._readableState;d.endEmitted||d.readableListening||(d.readableListening=d.needReadable=!0,d.emittedReadable=!1,d.reading?d.length&&p(this,d):x(t,this))}return c};c.prototype.addListener=c.prototype.on;c.prototype.resume=function(){var a=this._readableState;a.flowing||(I("resume"),a.flowing=!0,a.resumeScheduled||(a.resumeScheduled=
!0,x(B,this,a)));return this};c.prototype.pause=function(){I("call pause flowing=%j",this._readableState.flowing);!1!==this._readableState.flowing&&(I("pause"),this._readableState.flowing=!1,this.emit("pause"));return this};c.prototype.wrap=function(a){var b=this._readableState,c=!1,d=this;a.on("end",function(){I("wrapped end");if(b.decoder&&!b.ended){var a=b.decoder.end();a&&a.length&&d.push(a)}d.push(null)});a.on("data",function(e){I("wrapped data");b.decoder&&(e=b.decoder.write(e));b.objectMode&&
(null===e||void 0===e)||!(b.objectMode||e&&e.length)||d.push(e)||(c=!0,a.pause())});for(var e in a)void 0===this[e]&&"function"===typeof a[e]&&(this[e]=function(b){return function(){return a[b].apply(a,arguments)}}(e));q(["error","close","destroy","pause","resume"],function(b){a.on(b,d.emit.bind(d,b))});d._read=function(b){I("wrapped _read",b);c&&(c=!1,a.resume())};return d};c._fromList=C}).call(this,f("_process"))},{"./_stream_duplex":143,"./internal/streams/BufferList":148,_process:137,buffer:129,
"buffer-shims":128,"core-util-is":130,events:131,inherits:133,isarray:135,"process-nextick-args":136,"string_decoder/":154,util:127}],146:[function(f,l,h){function b(a){this.afterTransform=function(b,c){var e=a._transformState;e.transforming=!1;var f=e.writecb;f?(e.writechunk=null,e.writecb=null,null!==c&&void 0!==c&&a.push(c),f(b),e=a._readableState,e.reading=!1,(e.needReadable||e.length<e.highWaterMark)&&a._read(e.highWaterMark),e=void 0):e=a.emit("error",Error("no writecb in Transform class"));
return e};this.transforming=this.needTransform=!1;this.writeencoding=this.writechunk=this.writecb=null}function a(f){if(!(this instanceof a))return new a(f);c.call(this,f);this._transformState=new b(this);var g=this;this._readableState.needReadable=!0;this._readableState.sync=!1;f&&("function"===typeof f.transform&&(this._transform=f.transform),"function"===typeof f.flush&&(this._flush=f.flush));this.once("prefinish",function(){"function"===typeof this._flush?this._flush(function(a,b){e(g,a,b)}):
e(g)})}function e(a,b,c){if(b)return a.emit("error",b);null!==c&&void 0!==c&&a.push(c);b=a._transformState;if(a._writableState.length)throw Error("Calling transform done when ws.length != 0");if(b.transforming)throw Error("Calling transform done when still transforming");return a.push(null)}l.exports=a;var c=f("./_stream_duplex");l=f("core-util-is");l.inherits=f("inherits");l.inherits(a,c);a.prototype.push=function(a,b){this._transformState.needTransform=!1;return c.prototype.push.call(this,a,b)};
a.prototype._transform=function(a,b,c){throw Error("_transform() is not implemented");};a.prototype._write=function(a,b,c){var e=this._transformState;e.writecb=c;e.writechunk=a;e.writeencoding=b;e.transforming||(a=this._readableState,(e.needTransform||a.needReadable||a.length<a.highWaterMark)&&this._read(a.highWaterMark))};a.prototype._read=function(a){a=this._transformState;null!==a.writechunk&&a.writecb&&!a.transforming?(a.transforming=!0,this._transform(a.writechunk,a.writeencoding,a.afterTransform)):
a.needTransform=!0}},{"./_stream_duplex":143,"core-util-is":130,inherits:133}],147:[function(f,l,h){(function(b){function a(){}function e(a,b,c){this.chunk=a;this.encoding=b;this.callback=c;this.next=null}function c(a,b){C=C||f("./_stream_duplex");a=a||{};this.objectMode=!!a.objectMode;b instanceof C&&(this.objectMode=this.objectMode||!!a.writableObjectMode);var c=a.highWaterMark,d=this.objectMode?16:16384;this.highWaterMark=c||0===c?c:d;this.highWaterMark=~~this.highWaterMark;this.finished=this.ended=
this.ending=this.needDrain=!1;this.decodeStrings=!1!==a.decodeStrings;this.defaultEncoding=a.defaultEncoding||"utf8";this.length=0;this.writing=!1;this.corked=0;this.sync=!0;this.bufferProcessing=!1;this.onwrite=function(a){var c=b._writableState,d=c.sync,e=c.writecb;c.writing=!1;c.writecb=null;c.length-=c.writelen;c.writelen=0;a?(--c.pendingcb,d?B(e,a):e(a),b._writableState.errorEmitted=!0,b.emit("error",a)):((a=v(c))||c.corked||c.bufferProcessing||!c.bufferedRequest||k(b,c),d?z(p,b,c,a,e):p(b,c,
a,e))};this.writecb=null;this.writelen=0;this.lastBufferedRequest=this.bufferedRequest=null;this.pendingcb=0;this.errorEmitted=this.prefinished=!1;this.bufferedRequestCount=0;this.corkedRequestsFree=new t(this)}function h(a){C=C||f("./_stream_duplex");if(!(x.call(h,this)||this instanceof C))return new h(a);this._writableState=new c(a,this);this.writable=!0;a&&("function"===typeof a.write&&(this._write=a.write),"function"===typeof a.writev&&(this._writev=a.writev));K.call(this)}function g(a,b,c,d,
e,f,g){b.writelen=d;b.writecb=g;b.writing=!0;b.sync=!0;c?a._writev(e,b.onwrite):a._write(e,f,b.onwrite);b.sync=!1}function p(a,b,c,e){!c&&0===b.length&&b.needDrain&&(b.needDrain=!1,a.emit("drain"));b.pendingcb--;e();d(a,b)}function k(a,b){b.bufferProcessing=!0;var c=b.bufferedRequest;if(a._writev&&c&&c.next){var d=Array(b.bufferedRequestCount),e=b.corkedRequestsFree;e.entry=c;for(var f=0;c;)d[f]=c,c=c.next,f+=1;g(a,b,!0,b.length,d,"",e.finish);b.pendingcb++;b.lastBufferedRequest=null;e.next?(b.corkedRequestsFree=
e.next,e.next=null):b.corkedRequestsFree=new t(b)}else{for(;c&&(d=c.chunk,g(a,b,!1,b.objectMode?1:d.length,d,c.encoding,c.callback),c=c.next,!b.writing););null===c&&(b.lastBufferedRequest=null)}b.bufferedRequestCount=0;b.bufferedRequest=c;b.bufferProcessing=!1}function v(a){return a.ending&&0===a.length&&null===a.bufferedRequest&&!a.finished&&!a.writing}function d(a,b){var c=v(b);c&&(0===b.pendingcb?(b.prefinished||(b.prefinished=!0,a.emit("prefinish")),b.finished=!0,a.emit("finish")):b.prefinished||
(b.prefinished=!0,a.emit("prefinish")));return c}function t(a){var b=this;this.entry=this.next=null;this.finish=function(c){var d=b.entry;for(b.entry=null;d;){var e=d.callback;a.pendingcb--;e(c);d=d.next}a.corkedRequestsFree?a.corkedRequestsFree.next=b:a.corkedRequestsFree=b}}l.exports=h;var B=f("process-nextick-args"),z=!b.browser&&-1<["v0.10","v0.9."].indexOf(b.version.slice(0,5))?setImmediate:B,C;h.WritableState=c;b=f("core-util-is");b.inherits=f("inherits");var y={deprecate:f("util-deprecate")};
try{var K=f("stream")}catch(E){}finally{K||(K=f("events").EventEmitter)}var q=f("buffer").Buffer,L=f("buffer-shims");b.inherits(h,K);c.prototype.getBuffer=function(){for(var a=this.bufferedRequest,b=[];a;)b.push(a),a=a.next;return b};(function(){try{Object.defineProperty(c.prototype,"buffer",{get:y.deprecate(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")})}catch(E){}})();$jscomp.initSymbol();$jscomp.initSymbol();$jscomp.initSymbol();
if("function"===typeof Symbol&&Symbol.hasInstance&&"function"===typeof Function.prototype[Symbol.hasInstance]){$jscomp.initSymbol();var x=Function.prototype[Symbol.hasInstance];$jscomp.initSymbol();Object.defineProperty(h,Symbol.hasInstance,{value:function(a){return x.call(this,a)?!0:a&&a._writableState instanceof c}})}else x=function(a){return a instanceof this};h.prototype.pipe=function(){this.emit("error",Error("Cannot pipe, not readable"))};h.prototype.write=function(b,c,d){var f=this._writableState,
h=!1,k=q.isBuffer(b);"function"===typeof c&&(d=c,c=null);k?c="buffer":c||(c=f.defaultEncoding);"function"!==typeof d&&(d=a);if(f.ended)f=d,k=Error("write after end"),this.emit("error",k),B(f,k);else{var l;if(!(l=k)){l=d;var n=!0,p=!1;null===b?p=new TypeError("May not write null values to stream"):"string"===typeof b||void 0===b||f.objectMode||(p=new TypeError("Invalid non-string/buffer chunk"));p&&(this.emit("error",p),B(l,p),n=!1);l=n}l&&(f.pendingcb++,h=b,k||(k=h,f.objectMode||!1===f.decodeStrings||
"string"!==typeof k||(k=L.from(k,c)),h=k,q.isBuffer(h)&&(c="buffer")),b=f.objectMode?1:h.length,f.length+=b,k=f.length<f.highWaterMark,k||(f.needDrain=!0),f.writing||f.corked?(b=f.lastBufferedRequest,f.lastBufferedRequest=new e(h,c,d),b?b.next=f.lastBufferedRequest:f.bufferedRequest=f.lastBufferedRequest,f.bufferedRequestCount+=1):g(this,f,!1,b,h,c,d),h=k)}return h};h.prototype.cork=function(){this._writableState.corked++};h.prototype.uncork=function(){var a=this._writableState;a.corked&&(a.corked--,
a.writing||a.corked||a.finished||a.bufferProcessing||!a.bufferedRequest||k(this,a))};h.prototype.setDefaultEncoding=function(a){"string"===typeof a&&(a=a.toLowerCase());if(!(-1<"hex utf8 utf-8 ascii binary base64 ucs2 ucs-2 utf16le utf-16le raw".split(" ").indexOf((a+"").toLowerCase())))throw new TypeError("Unknown encoding: "+a);this._writableState.defaultEncoding=a;return this};h.prototype._write=function(a,b,c){c(Error("_write() is not implemented"))};h.prototype._writev=null;h.prototype.end=function(a,
b,c){var e=this._writableState;"function"===typeof a?(c=a,b=a=null):"function"===typeof b&&(c=b,b=null);null!==a&&void 0!==a&&this.write(a,b);e.corked&&(e.corked=1,this.uncork());if(!e.ending&&!e.finished){a=c;e.ending=!0;d(this,e);if(a)if(e.finished)B(a);else this.once("finish",a);e.ended=!0;this.writable=!1}}}).call(this,f("_process"))},{"./_stream_duplex":143,_process:137,buffer:129,"buffer-shims":128,"core-util-is":130,events:131,inherits:133,"process-nextick-args":136,"util-deprecate":157}],
148:[function(f,l,h){function b(){this.tail=this.head=null;this.length=0}f("buffer");var a=f("buffer-shims");l.exports=b;b.prototype.push=function(a){a={data:a,next:null};0<this.length?this.tail.next=a:this.head=a;this.tail=a;++this.length};b.prototype.unshift=function(a){a={data:a,next:this.head};0===this.length&&(this.tail=a);this.head=a;++this.length};b.prototype.shift=function(){if(0!==this.length){var a=this.head.data;this.head=1===this.length?this.tail=null:this.head.next;--this.length;return a}};
b.prototype.clear=function(){this.head=this.tail=null;this.length=0};b.prototype.join=function(a){if(0===this.length)return"";for(var b=this.head,e=""+b.data;b=b.next;)e+=a+b.data;return e};b.prototype.concat=function(b){if(0===this.length)return a.alloc(0);if(1===this.length)return this.head.data;b=a.allocUnsafe(b>>>0);for(var c=this.head,e=0;c;)c.data.copy(b,e),e+=c.data.length,c=c.next;return b}},{buffer:129,"buffer-shims":128}],149:[function(f,l,h){l.exports=f("./lib/_stream_passthrough.js")},
{"./lib/_stream_passthrough.js":144}],150:[function(f,l,h){var b=f("_process");a:{try{var a=f("stream");break a}catch(e){}a=void 0}h=l.exports=f("./lib/_stream_readable.js");h.Stream=a||h;h.Readable=h;h.Writable=f("./lib/_stream_writable.js");h.Duplex=f("./lib/_stream_duplex.js");h.Transform=f("./lib/_stream_transform.js");h.PassThrough=f("./lib/_stream_passthrough.js");!b.browser&&"disable"===b.env.READABLE_STREAM&&a&&(l.exports=a)},{"./lib/_stream_duplex.js":143,"./lib/_stream_passthrough.js":144,
"./lib/_stream_readable.js":145,"./lib/_stream_transform.js":146,"./lib/_stream_writable.js":147,_process:137}],151:[function(f,l,h){l.exports=f("./lib/_stream_transform.js")},{"./lib/_stream_transform.js":146}],152:[function(f,l,h){l.exports=f("./lib/_stream_writable.js")},{"./lib/_stream_writable.js":147}],153:[function(f,l,h){function b(){a.call(this)}l.exports=b;var a=f("events").EventEmitter;f("inherits")(b,a);b.Readable=f("readable-stream/readable.js");b.Writable=f("readable-stream/writable.js");
b.Duplex=f("readable-stream/duplex.js");b.Transform=f("readable-stream/transform.js");b.PassThrough=f("readable-stream/passthrough.js");b.Stream=b;b.prototype.pipe=function(b,c){function e(a){b.writable&&!1===b.write(a)&&t.pause&&t.pause()}function f(){t.readable&&t.resume&&t.resume()}function h(){B||(B=!0,b.end())}function k(){B||(B=!0,"function"===typeof b.destroy&&b.destroy())}function l(b){d();if(0===a.listenerCount(this,"error"))throw b;}function d(){t.removeListener("data",e);b.removeListener("drain",
f);t.removeListener("end",h);t.removeListener("close",k);t.removeListener("error",l);b.removeListener("error",l);t.removeListener("end",d);t.removeListener("close",d);b.removeListener("close",d)}var t=this;t.on("data",e);b.on("drain",f);b._isStdio||c&&!1===c.end||(t.on("end",h),t.on("close",k));var B=!1;t.on("error",l);b.on("error",l);t.on("end",d);t.on("close",d);b.on("close",d);b.emit("pipe",t);return b}},{events:131,inherits:133,"readable-stream/duplex.js":142,"readable-stream/passthrough.js":149,
"readable-stream/readable.js":150,"readable-stream/transform.js":151,"readable-stream/writable.js":152}],154:[function(f,l,h){function b(a){return a.toString(this.encoding)}function a(a){this.charLength=(this.charReceived=a.length%2)?2:0}function e(a){this.charLength=(this.charReceived=a.length%3)?3:0}var c=f("buffer").Buffer,n=c.isEncoding||function(a){switch(a&&a.toLowerCase()){case "hex":case "utf8":case "utf-8":case "ascii":case "binary":case "base64":case "ucs2":case "ucs-2":case "utf16le":case "utf-16le":case "raw":return!0;
default:return!1}};f=h.StringDecoder=function(f){this.encoding=(f||"utf8").toLowerCase().replace(/[-_]/,"");if(f&&!n(f))throw Error("Unknown encoding: "+f);switch(this.encoding){case "utf8":this.surrogateSize=3;break;case "ucs2":case "utf16le":this.surrogateSize=2;this.detectIncompleteChar=a;break;case "base64":this.surrogateSize=3;this.detectIncompleteChar=e;break;default:this.write=b;return}this.charBuffer=new c(6);this.charLength=this.charReceived=0};f.prototype.write=function(a){for(var b,c="";this.charLength;){c=
a.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:a.length;a.copy(this.charBuffer,this.charReceived,0,c);this.charReceived+=c;if(this.charReceived<this.charLength)return"";a=a.slice(c,a.length);c=this.charBuffer.slice(0,this.charLength).toString(this.encoding);b=c.charCodeAt(c.length-1);if(55296<=b&&56319>=b)this.charLength+=this.surrogateSize,c="";else{this.charReceived=this.charLength=0;if(0===a.length)return c;break}}this.detectIncompleteChar(a);var e=a.length;this.charLength&&
(a.copy(this.charBuffer,0,a.length-this.charReceived,e),e-=this.charReceived);c+=a.toString(this.encoding,0,e);e=c.length-1;b=c.charCodeAt(e);return 55296<=b&&56319>=b?(b=this.surrogateSize,this.charLength+=b,this.charReceived+=b,this.charBuffer.copy(this.charBuffer,b,0,b),a.copy(this.charBuffer,0,0,b),c.substring(0,e)):c};f.prototype.detectIncompleteChar=function(a){for(var b=3<=a.length?3:a.length;0<b;b--){var c=a[a.length-b];if(1==b&&6==c>>5){this.charLength=2;break}if(2>=b&&14==c>>4){this.charLength=
3;break}if(3>=b&&30==c>>3){this.charLength=4;break}}this.charReceived=b};f.prototype.end=function(a){var b="";a&&a.length&&(b=this.write(a));this.charReceived&&(a=this.encoding,b+=this.charBuffer.slice(0,this.charReceived).toString(a));return b}},{buffer:129}],155:[function(f,l,h){function b(){this.href=this.path=this.pathname=this.query=this.search=this.hash=this.hostname=this.port=this.host=this.auth=this.slashes=this.protocol=null}function a(a,d,e){if(a&&c.isObject(a)&&a instanceof b)return a;
var f=new b;f.parse(a,d,e);return f}var e=f("punycode"),c=f("./util");h.parse=a;h.resolve=function(b,c){return a(b,!1,!0).resolve(c)};h.resolveObject=function(b,c){return b?a(b,!1,!0).resolveObject(c):c};h.format=function(d){c.isString(d)&&(d=a(d));return d instanceof b?d.format():b.prototype.format.call(d)};h.Url=b;var n=/^([a-z0-9.+-]+:)/i,g=/:[0-9]*$/,p=/^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/;l="{}|\\^`".split("").concat('<>"` \r\n\t'.split(""));var k=["'"].concat(l),v=["%","/","?",";","#"].concat(k),
d=["/","?","#"],t=/^[+a-z0-9A-Z_-]{0,63}$/,B=/^([+a-z0-9A-Z_-]{0,63})(.*)$/,z={javascript:!0,"javascript:":!0},C={javascript:!0,"javascript:":!0},y={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,"http:":!0,"https:":!0,"ftp:":!0,"gopher:":!0,"file:":!0},K=f("querystring");b.prototype.parse=function(a,b,f){var g,h;if(!c.isString(a))throw new TypeError("Parameter 'url' must be a string, not "+typeof a);var l=a.indexOf("?"),l=-1!==l&&l<a.indexOf("#")?"?":"#";a=a.split(l);a[0]=a[0].replace(/\\/g,"/");a=a.join(l);
l=a.trim();if(!f&&1===a.split("#").length&&(a=p.exec(l)))return this.href=this.path=l,this.pathname=a[1],a[2]?(this.search=a[2],this.query=b?K.parse(this.search.substr(1)):this.search.substr(1)):b&&(this.search="",this.query={}),this;if(a=n.exec(l))a=a[0],this.protocol=h=a.toLowerCase(),l=l.substr(a.length);if(f||a||l.match(/^\/\/[^@\/]+@[^@\/]+/))!(g="//"===l.substr(0,2))||a&&C[a]||(l=l.substr(2),this.slashes=!0);if(!C[a]&&(g||a&&!y[a])){a=-1;for(f=0;f<d.length;f++)g=l.indexOf(d[f]),-1!==g&&(-1===
a||g<a)&&(a=g);g=-1===a?l.lastIndexOf("@"):l.lastIndexOf("@",a);-1!==g&&(f=l.slice(0,g),l=l.slice(g+1),this.auth=decodeURIComponent(f));a=-1;for(f=0;f<v.length;f++)g=l.indexOf(v[f]),-1!==g&&(-1===a||g<a)&&(a=g);-1===a&&(a=l.length);this.host=l.slice(0,a);l=l.slice(a);this.parseHost();this.hostname=this.hostname||"";g="["===this.hostname[0]&&"]"===this.hostname[this.hostname.length-1];if(!g){var q=this.hostname.split(/\./);f=0;for(a=q.length;f<a;f++){var x=q[f];if(x&&!x.match(t)){for(var L="",N=0,
I=x.length;N<I;N++)L=127<x.charCodeAt(N)?L+"x":L+x[N];if(!L.match(t)){a=q.slice(0,f);f=q.slice(f+1);if(x=x.match(B))a.push(x[1]),f.unshift(x[2]);f.length&&(l="/"+f.join(".")+l);this.hostname=a.join(".");break}}}}this.hostname=255<this.hostname.length?"":this.hostname.toLowerCase();g||(this.hostname=e.toASCII(this.hostname));f=this.port?":"+this.port:"";this.host=(this.hostname||"")+f;this.href+=this.host;g&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),"/"!==l[0]&&(l="/"+l))}if(!z[h])for(f=
0,a=k.length;f<a;f++)g=k[f],-1!==l.indexOf(g)&&(x=encodeURIComponent(g),x===g&&(x=escape(g)),l=l.split(g).join(x));f=l.indexOf("#");-1!==f&&(this.hash=l.substr(f),l=l.slice(0,f));f=l.indexOf("?");-1!==f?(this.search=l.substr(f),this.query=l.substr(f+1),b&&(this.query=K.parse(this.query)),l=l.slice(0,f)):b&&(this.search="",this.query={});l&&(this.pathname=l);y[h]&&this.hostname&&!this.pathname&&(this.pathname="/");if(this.pathname||this.search)f=this.pathname||"",this.path=f+(this.search||"");this.href=
this.format();return this};b.prototype.format=function(){var a=this.auth||"";a&&(a=encodeURIComponent(a),a=a.replace(/%3A/i,":"),a+="@");var b=this.protocol||"",d=this.pathname||"",e=this.hash||"",f=!1,g="";this.host?f=a+this.host:this.hostname&&(f=a+(-1===this.hostname.indexOf(":")?this.hostname:"["+this.hostname+"]"),this.port&&(f+=":"+this.port));this.query&&c.isObject(this.query)&&Object.keys(this.query).length&&(g=K.stringify(this.query));a=this.search||g&&"?"+g||"";b&&":"!==b.substr(-1)&&(b+=
":");this.slashes||(!b||y[b])&&!1!==f?(f="//"+(f||""),d&&"/"!==d.charAt(0)&&(d="/"+d)):f||(f="");e&&"#"!==e.charAt(0)&&(e="#"+e);a&&"?"!==a.charAt(0)&&(a="?"+a);d=d.replace(/[?#]/g,function(a){return encodeURIComponent(a)});a=a.replace("#","%23");return b+f+d+a+e};b.prototype.resolve=function(b){return this.resolveObject(a(b,!1,!0)).format()};b.prototype.resolveObject=function(a){var d;if(c.isString(a)){var e=new b;e.parse(a,!1,!0);a=e}for(var e=new b,f=Object.keys(this),g=0;g<f.length;g++){var h=
f[g];e[h]=this[h]}e.hash=a.hash;if(""===a.href)return e.href=e.format(),e;if(a.slashes&&!a.protocol){f=Object.keys(a);for(g=0;g<f.length;g++)h=f[g],"protocol"!==h&&(e[h]=a[h]);y[e.protocol]&&e.hostname&&!e.pathname&&(e.path=e.pathname="/");e.href=e.format();return e}if(a.protocol&&a.protocol!==e.protocol){if(!y[a.protocol]){f=Object.keys(a);for(g=0;g<f.length;g++)h=f[g],e[h]=a[h];e.href=e.format();return e}e.protocol=a.protocol;if(a.host||C[a.protocol])e.pathname=a.pathname;else{for(d=(a.pathname||
"").split("/");d.length&&!(a.host=d.shift()););a.host||(a.host="");a.hostname||(a.hostname="");""!==d[0]&&d.unshift("");2>d.length&&d.unshift("");e.pathname=d.join("/")}e.search=a.search;e.query=a.query;e.host=a.host||"";e.auth=a.auth;e.hostname=a.hostname||a.host;e.port=a.port;if(e.pathname||e.search)e.path=(e.pathname||"")+(e.search||"");e.slashes=e.slashes||a.slashes;e.href=e.format();return e}var f=e.pathname&&"/"===e.pathname.charAt(0),k=a.host||a.pathname&&"/"===a.pathname.charAt(0),l=f=k||
f||e.host&&a.pathname,g=e.pathname&&e.pathname.split("/")||[];d=a.pathname&&a.pathname.split("/")||[];if(h=e.protocol&&!y[e.protocol])e.hostname="",e.port=null,e.host&&(""===g[0]?g[0]=e.host:g.unshift(e.host)),e.host="",a.protocol&&(a.hostname=null,a.port=null,a.host&&(""===d[0]?d[0]=a.host:d.unshift(a.host)),a.host=null),f=f&&(""===d[0]||""===g[0]);if(k)e.host=a.host||""===a.host?a.host:e.host,e.hostname=a.hostname||""===a.hostname?a.hostname:e.hostname,e.search=a.search,e.query=a.query,g=d;else if(d.length)g||
(g=[]),g.pop(),g=g.concat(d),e.search=a.search,e.query=a.query;else if(!c.isNullOrUndefined(a.search))return h&&(e.hostname=e.host=g.shift(),h=e.host&&0<e.host.indexOf("@")?e.host.split("@"):!1)&&(e.auth=h.shift(),e.host=e.hostname=h.shift()),e.search=a.search,e.query=a.query,c.isNull(e.pathname)&&c.isNull(e.search)||(e.path=(e.pathname?e.pathname:"")+(e.search?e.search:"")),e.href=e.format(),e;if(!g.length)return e.pathname=null,e.path=e.search?"/"+e.search:null,e.href=e.format(),e;k=g.slice(-1)[0];
d=(e.host||a.host||1<g.length)&&("."===k||".."===k)||""===k;for(var n=0,p=g.length;0<=p;p--)k=g[p],"."===k?g.splice(p,1):".."===k?(g.splice(p,1),n++):n&&(g.splice(p,1),n--);if(!f&&!l)for(;n--;n)g.unshift("..");!f||""===g[0]||g[0]&&"/"===g[0].charAt(0)||g.unshift("");d&&"/"!==g.join("/").substr(-1)&&g.push("");l=""===g[0]||g[0]&&"/"===g[0].charAt(0);h&&(e.hostname=e.host=l?"":g.length?g.shift():"",h=e.host&&0<e.host.indexOf("@")?e.host.split("@"):!1)&&(e.auth=h.shift(),e.host=e.hostname=h.shift());
(f=f||e.host&&g.length)&&!l&&g.unshift("");g.length?e.pathname=g.join("/"):(e.pathname=null,e.path=null);c.isNull(e.pathname)&&c.isNull(e.search)||(e.path=(e.pathname?e.pathname:"")+(e.search?e.search:""));e.auth=a.auth||e.auth;e.slashes=e.slashes||a.slashes;e.href=e.format();return e};b.prototype.parseHost=function(){var a=this.host,b=g.exec(a);b&&(b=b[0],":"!==b&&(this.port=b.substr(1)),a=a.substr(0,a.length-b.length));a&&(this.hostname=a)}},{"./util":156,punycode:138,querystring:141}],156:[function(f,
l,h){l.exports={isString:function(b){return"string"===typeof b},isObject:function(b){return"object"===typeof b&&null!==b},isNull:function(b){return null===b},isNullOrUndefined:function(b){return null==b}}},{}],157:[function(f,l,h){(function(b){function a(a){try{if(!b.localStorage)return!1}catch(c){return!1}a=b.localStorage[a];return null==a?!1:"true"===String(a).toLowerCase()}l.exports=function(b,c){if(a("noDeprecation"))return b;var e=!1;return function(){if(!e){if(a("throwDeprecation"))throw Error(c);
a("traceDeprecation")?console.trace(c):console.warn(c);e=!0}return b.apply(this,arguments)}}}).call(this,"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{}],158:[function(f,l,h){arguments[4][133][0].apply(h,arguments)},{dup:133}],159:[function(f,l,h){l.exports=function(b){return b&&"object"===typeof b&&"function"===typeof b.copy&&"function"===typeof b.fill&&"function"===typeof b.readUInt8}},{}],160:[function(f,l,h){(function(b,a){function e(a,
b){var d={seen:[],stylize:l};3<=arguments.length&&(d.depth=arguments[2]);4<=arguments.length&&(d.colors=arguments[3]);C(b)?d.showHidden=b:b&&h._extend(d,b);q(d.showHidden)&&(d.showHidden=!1);q(d.depth)&&(d.depth=2);q(d.colors)&&(d.colors=!1);q(d.customInspect)&&(d.customInspect=!0);d.colors&&(d.stylize=c);return p(d,a,d.depth)}function c(a,b){var c=e.styles[b];return c?"\u001b["+e.colors[c][0]+"m"+a+"\u001b["+e.colors[c][1]+"m":a}function l(a,b){return a}function g(a){var b={};a.forEach(function(a,
c){b[a]=!0});return b}function p(a,b,c){if(a.customInspect&&b&&J(b.inspect)&&b.inspect!==h.inspect&&(!b.constructor||b.constructor.prototype!==b)){var e=b.inspect(c,a);K(e)||(e=p(a,e,c));return e}if(e=k(a,b))return e;var f=Object.keys(b),l=g(f);a.showHidden&&(f=Object.getOwnPropertyNames(b));if(G(b)&&(0<=f.indexOf("message")||0<=f.indexOf("description")))return v(b);if(0===f.length){if(J(b))return a.stylize("[Function"+(b.name?": "+b.name:"")+"]","special");if(L(b))return a.stylize(RegExp.prototype.toString.call(b),
"regexp");if(E(b))return a.stylize(Date.prototype.toString.call(b),"date");if(G(b))return v(b)}var e="",m=!1,n=["{","}"];z(b)&&(m=!0,n=["[","]"]);J(b)&&(e=" [Function"+(b.name?": "+b.name:"")+"]");L(b)&&(e=" "+RegExp.prototype.toString.call(b));E(b)&&(e=" "+Date.prototype.toUTCString.call(b));G(b)&&(e=" "+v(b));if(0===f.length&&(!m||0==b.length))return n[0]+e+n[1];if(0>c)return L(b)?a.stylize(RegExp.prototype.toString.call(b),"regexp"):a.stylize("[Object]","special");a.seen.push(b);f=m?d(a,b,c,l,
f):f.map(function(d){return t(a,b,c,l,d,m)});a.seen.pop();return B(f,e,n)}function k(a,b){if(q(b))return a.stylize("undefined","undefined");if(K(b)){var c="'"+JSON.stringify(b).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return a.stylize(c,"string")}if(y(b))return a.stylize(""+b,"number");if(C(b))return a.stylize(""+b,"boolean");if(null===b)return a.stylize("null","null")}function v(a){return"["+Error.prototype.toString.call(a)+"]"}function d(a,b,c,d,e){for(var f=[],g=0,h=b.length;g<
h;++g)Object.prototype.hasOwnProperty.call(b,String(g))?f.push(t(a,b,c,d,String(g),!0)):f.push("");e.forEach(function(e){e.match(/^\d+$/)||f.push(t(a,b,c,d,e,!0))});return f}function t(a,b,c,d,e,f){var g,h;b=Object.getOwnPropertyDescriptor(b,e)||{value:b[e]};b.get?h=b.set?a.stylize("[Getter/Setter]","special"):a.stylize("[Getter]","special"):b.set&&(h=a.stylize("[Setter]","special"));Object.prototype.hasOwnProperty.call(d,e)||(g="["+e+"]");h||(0>a.seen.indexOf(b.value)?(h=null===c?p(a,b.value,null):
p(a,b.value,c-1),-1<h.indexOf("\n")&&(h=f?h.split("\n").map(function(a){return"  "+a}).join("\n").substr(2):"\n"+h.split("\n").map(function(a){return"   "+a}).join("\n"))):h=a.stylize("[Circular]","special"));if(q(g)){if(f&&e.match(/^\d+$/))return h;g=JSON.stringify(""+e);g.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(g=g.substr(1,g.length-2),g=a.stylize(g,"name")):(g=g.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),g=a.stylize(g,"string"))}return g+": "+h}function B(a,b,c){var d=0;return 60<
a.reduce(function(a,b){d++;0<=b.indexOf("\n")&&d++;return a+b.replace(/\u001b\[\d\d?m/g,"").length+1},0)?c[0]+(""===b?"":b+"\n ")+" "+a.join(",\n  ")+" "+c[1]:c[0]+b+" "+a.join(", ")+" "+c[1]}function z(a){return Array.isArray(a)}function C(a){return"boolean"===typeof a}function y(a){return"number"===typeof a}function K(a){return"string"===typeof a}function q(a){return void 0===a}function L(a){return x(a)&&"[object RegExp]"===Object.prototype.toString.call(a)}function x(a){return"object"===typeof a&&
null!==a}function E(a){return x(a)&&"[object Date]"===Object.prototype.toString.call(a)}function G(a){return x(a)&&("[object Error]"===Object.prototype.toString.call(a)||a instanceof Error)}function J(a){return"function"===typeof a}function Q(a){return 10>a?"0"+a.toString(10):a.toString(10)}function F(){var a=new Date,b=[Q(a.getHours()),Q(a.getMinutes()),Q(a.getSeconds())].join(":");return[a.getDate(),D[a.getMonth()],b].join(" ")}var M=/%[sdj%]/g;h.format=function(a){if(!K(a)){for(var b=[],c=0;c<
arguments.length;c++)b.push(e(arguments[c]));return b.join(" ")}for(var c=1,d=arguments,f=d.length,b=String(a).replace(M,function(a){if("%%"===a)return"%";if(c>=f)return a;switch(a){case "%s":return String(d[c++]);case "%d":return Number(d[c++]);case "%j":try{return JSON.stringify(d[c++])}catch(R){return"[Circular]"}default:return a}}),g=d[c];c<f;g=d[++c])b=null!==g&&x(g)?b+(" "+e(g)):b+(" "+g);return b};h.deprecate=function(c,d){if(q(a.process))return function(){return h.deprecate(c,d).apply(this,
arguments)};if(!0===b.noDeprecation)return c;var e=!1;return function(){if(!e){if(b.throwDeprecation)throw Error(d);b.traceDeprecation?console.trace(d):console.error(d);e=!0}return c.apply(this,arguments)}};var N={},I;h.debuglog=function(a){q(I)&&(I=b.env.NODE_DEBUG||"");a=a.toUpperCase();if(!N[a])if((new RegExp("\\b"+a+"\\b","i")).test(I)){var c=b.pid;N[a]=function(){var b=h.format.apply(h,arguments);console.error("%s %d: %s",a,c,b)}}else N[a]=function(){};return N[a]};h.inspect=e;e.colors={bold:[1,
22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]};e.styles={special:"cyan",number:"yellow","boolean":"yellow",undefined:"grey","null":"bold",string:"green",date:"magenta",regexp:"red"};h.isArray=z;h.isBoolean=C;h.isNull=function(a){return null===a};h.isNullOrUndefined=function(a){return null==a};h.isNumber=y;h.isString=K;h.isSymbol=function(a){return"symbol"===typeof a};h.isUndefined=
q;h.isRegExp=L;h.isObject=x;h.isDate=E;h.isError=G;h.isFunction=J;h.isPrimitive=function(a){return null===a||"boolean"===typeof a||"number"===typeof a||"string"===typeof a||"symbol"===typeof a||"undefined"===typeof a};h.isBuffer=f("./support/isBuffer");var D="Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec".split(" ");h.log=function(){console.log("%s - %s",F(),h.format.apply(h,arguments))};h.inherits=f("inherits");h._extend=function(a,b){if(!b||!x(b))return a;for(var c=Object.keys(b),d=c.length;d--;)a[c[d]]=
b[c[d]];return a}}).call(this,f("_process"),"undefined"!==typeof global?global:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./support/isBuffer":159,_process:137,inherits:158}]},{},[3])(3)});
